

//
#ifndef _THEMEHELPERST_H_
#define _THEMEHELPERST_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef	HTHEME
#define	HTHEME	HANDLE
#endif

#ifndef GLL_BP_PUSHBUTTON
enum { GLL_BP_PUSHBUTTON=1, GLL_BP_RADIOBUTTON, GLL_BP_CHECKBOX, GLL_BP_GROUPBOX, GLL_BP_USERBUTTON};
enum { GLL_PBS_NORMAL = 1, GLL_PBS_HOT, GLL_PBS_PRESSED, GLL_PBS_DISABLED, GLL_PBS_DEFAULTED};
enum { GLL_RBS_UNCHECKEDNORMAL = 1, GLL_RBS_UNCHECKEDHOT, GLL_RBS_UNCHECKEDPRESSED, GLL_RBS_UNCHECKEDDISABLED, GLL_RBS_CHECKEDNORMAL, GLL_RBS_CHECKEDHOT, GLL_RBS_CHECKEDPRESSED, GLL_RBS_CHECKEDDISABLED};
enum { GLL_CBS_UNCHECKEDNORMAL = 1, GLL_CBS_UNCHECKEDHOT, GLL_CBS_UNCHECKEDPRESSED, GLL_CBS_UNCHECKEDDISABLED, GLL_CBS_CHECKEDNORMAL, GLL_CBS_CHECKEDHOT, GLL_CBS_CHECKEDPRESSED, GLL_CBS_CHECKEDDISABLED, GLL_CBS_MIXEDNORMAL, GLL_CBS_MIXEDHOT, GLL_CBS_MIXEDPRESSED};
enum { GLL_CBXS_NORMAL = 1, GLL_CBXS_HOT, GLL_CBXS_PRESSED, GLL_CBXS_DISABLED};
enum { GLL_SBP_ARROWBTN = 1, GLL_SBP_THUMBBTNHORZ, GLL_SBP_THUMBBTNVERT, GLL_SBP_LOWERTRACKHORZ, GLL_SBP_UPPERTRACKHORZ, GLL_SBP_LOWERTRACKVERT, GLL_SBP_UPPERTRACKVERT, GLL_SBP_GRIPPERHORZ, GLL_SBP_GRIPPERVERT, GLL_SBP_SIZEBOX};
enum { GLL_SZB_RIGHTALIGN = 1, GLL_SZB_LEFTALIGN};
#endif

class CGLL_Theme_Helper  
{
public:
	CGLL_Theme_Helper();
	
	void LoadDLL();
	virtual ~CGLL_Theme_Helper();

	void Close();

	bool IsThemeEnabled();

	HTHEME OpenThemeData(HWND hwnd, LPCWSTR pszClassList);
	HRESULT CloseThemeData(HTHEME hTheme);
	HRESULT DrawThemeBackground(HTHEME hTheme, HWND hWnd, HDC hdc, int iPartId, int iStateId, const RECT* pRect, const RECT* pClipRect = NULL, bool m_bParentBkGround = true);
	HRESULT DrawThemeText(HTHEME hTheme, HDC hdc, int iPartId, int iStateId, LPCWSTR pszText, int iCharCount, DWORD dwTextFlags, DWORD dwTextFlags2, const RECT* pRect);
	HRESULT DrawThemeEdge(HTHEME, HDC hdc, int iPartId, int iStateId, RECT *pDestRect, UINT uEdge, UINT uFlags, RECT *pContentRect);
	HRESULT SetWindowTheme(HWND hwnd, LPCWSTR pszSubAppName, LPCWSTR pszSubIdList);
	HRESULT GetThemeColor(HTHEME hTheme, int iPartID, int iStateID, int iPropID, COLORREF* pColor);
	BOOL IsThemeActive();
	BOOL IsAppThemed();
	BOOL DrawFrameControl(HTHEME hTheme,  HWND hWnd, HDC hdc, LPRECT pRect, UINT nType, UINT nState, LPCRECT prClip = NULL, bool m_ParentBackGround = true);
	BOOL GetThemeClassPartState(HWND hWnd, int nType, int nState, CString& sThClass, int& nThPart, int& nThState);
	BOOL SupportsTheming(int nFlag);
	DWORD GetAppThemeProperties();

	void Draw3dRect(HDC hdc, LPCRECT lpRect, COLORREF clrTopLeft, COLORREF clrBottomRight);
	void Draw3dRect(HDC hdc, int x, int y, int cx, int cy, COLORREF clrTopLeft, COLORREF clrBottomRight);
	void FillSolidRect(HDC hdc, int x, int y, int cx, int cy, COLORREF clr);
	void FillSolidRect(HDC hdc, LPCRECT lpRect, COLORREF clr);

private:

	typedef HTHEME(STDAPICALLTYPE *PFNOPENTHEMEDATA)(HWND hwnd, LPCWSTR pszClassList);
	typedef HRESULT(STDAPICALLTYPE *PFNCLOSETHEMEDATA)(HTHEME hTheme);
	typedef HRESULT(STDAPICALLTYPE *PFNDRAWTHEMEBACKGROUND)(HTHEME, HDC hdc, int iPartId, int iStateId, const RECT* pRect,  const RECT* pClipRect);
	typedef HRESULT(STDAPICALLTYPE *PFNDRAWTHEMEPARENTBACKGROUND)(HWND hWnd, HDC hdc, RECT* pRect);

	typedef HRESULT (STDAPICALLTYPE *PFNDRAWTHEMETEXT)(HTHEME, HDC hdc, int iPartId, int iStateId, LPCWSTR pszText, int iCharCount, DWORD dwTextFlags, DWORD dwTextFlags2, const RECT* pRect);
	typedef HRESULT (STDAPICALLTYPE *PFNDRAWTHEMEEDGE)(HTHEME, HDC hdc, int iPartId, int iStateId, const RECT *pDestRect, UINT uEdge, UINT uFlags, RECT *pContentRect);
	typedef HRESULT (STDAPICALLTYPE *PFNSETWINDOWTHEME)(HWND hwnd, LPCWSTR pszSubAppName,LPCWSTR pszSubIdList);
	typedef BOOL(STDAPICALLTYPE *PFNISAPPTHEMED)();
	typedef BOOL (STDAPICALLTYPE *PFNISTHEMEACTIVE)();
	typedef DWORD (STDAPICALLTYPE *PFNGETTHEMEAPPPROPERTIES)();
	typedef HRESULT (STDAPICALLTYPE *PFNGETTHEMECOLOR)(HTHEME hTheme, int iPartID, int iStateID, int iPropID, COLORREF* pColor);
	
	HMODULE		m_hDll;
	void Init();
	DWORD dwOS;
	/**********************************************************************/

	PFNOPENTHEMEDATA pfnOpenThemeData;
	PFNCLOSETHEMEDATA pfnCloseThemeData;
	PFNDRAWTHEMEPARENTBACKGROUND pfnDrawThemeParentBackground;
	PFNDRAWTHEMEBACKGROUND pfnDrawThemeBackground;
	PFNDRAWTHEMETEXT pfnDrawThemeText;
	PFNDRAWTHEMEEDGE pfnDrawThemeEdge;
	PFNSETWINDOWTHEME pfnSetWindowTheme;
	PFNISAPPTHEMED pfnIsAppThemed;
	PFNISTHEMEACTIVE pfnIsThemeActive;
	PFNGETTHEMECOLOR pfnGetThemeColor;
};

#endif 
