// LayoutGroup.h: Schnittstelle fr die Klasse CLayoutGroup.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LAYOUTGROUP_H__34051C7A_F99E_4517_9916_7137261DFEEE__INCLUDED_)
#define AFX_LAYOUTGROUP_H__34051C7A_F99E_4517_9916_7137261DFEEE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <afxtempl.h>		// CArray and CTypedPtrList


/**********************************************************************
  LayoutGroup.h: Implementierung der Klasse CLayoutGroup.
  GLL GUI Layout Lib
	(c) 1999-2015, AKApplications, Andreas Kapust, E-Mail: info AT akapplications DOT com
***********************************************************************

 Die Nutzung dieser Routinen geschieht auf eigenes Risiko. 
 Es wird keine Haftung fr Fehler jeglicher Art bernommen. 
 Das Copyright dieser Routinen liegt bei Andreas Kapust. 

 Bei Kommerziellen Programmen muss im About-Dialog oder in der Anleitung
 ein Verweiss wie: 'Nutzt die GUILayoutLib-Routinen' 
 stehen.

***********************************************************************

//#H Port to Pocket PC
//#V 2.01
//#A Dirk Gaudian
//#D 2002-06-18

HISTORY:
	Start 15.10.99
	Version 1.0 [17.10.99]
		-GrundLayout-Routinen
	[15-16.10.99]
		-CDialogLayout
			-FIFO fr CDialogLayout-Routinen (sXXXXXX)
			-AddSpace
			-SetAlign
	[17.10.99]
		-Prozentuale Ausdehnung
		-Fix der StartLayout-Berechnung
		-Laden/Speichern der DLG-Gre
		-AddSpace(0) (IS_A_SPREADER) eingebaut.
! SetAlign und AddSpace(0) luft nicht !
! Ist auch nicht ntig. In dem Fall 2 AddSpace(0) nutzen !
! Bei AddSpace(0) wird die Gruppe wieder Align-Left !

	Version 1.1 [19.10.99]
		-CPropertySheetLayout & CPropertyPageLayout eingebaut
		-Anpassung der CalcLayout-Routine
		-Kleiner Bug bei minimierten Fenstern behoben.
		 Die StatusBar-Hhe wurde immer wieder neu berechnet. Ist ja nicht
		 sooo schlecht, nur ist die bei minimierten Fenstern und anschlieendem
		 ffnen -7 oder waren es -12? Auerdem wird bei OnSize nun nicht mehr
		 cx,cy benutzt, sondern die Gre ber GetWindowRect() und 
		 GetClientRect() berechnet.

	Version 1.2 [20-21.10.99]
		-CFormViewLayout eingebaut
		-CWnd-Routinen wegen CFormViewLayout durch HWND ersetzt (m_hTheWnd)
		-Kleine Vernderungen an CPropertySheetLayout

	Version 1.3 [22.10.99]
		-CGroupStatic eingebaut.
			Automatisches SubClassen von GROUPBOX-Fenstern.
			1.Flackerfreier, 2. Entstehen bei WS_CLIPCHILDREN-Dialogen
			recht blde Grafikfehler.
			Diese Klasse entstand ursprnglich fr die Routinen
			von Erwin Tratar.
			(In den neuen Routinen werden die 'Member' 
			automatisch eingetragen.)
		-AddXGrpCtrl- u. AddXGrpTitleCtrl-Funktionen hinzugefgt.
		-Kleinen Bug bei Gruppen die sich nur Vertikal o. Horizontal
		 ausdehnen behoben. (Falsche Berechnung).
		-Hoffentlich alle xxxSpace-Probleme behoben.
  
	Version 1.4 [22.10.99]
		-AddLine() eingebaut.
		-Fehler im Layout behoben. Wieder bei Gruppen die sich nur 
		 Vertikal o. Horizontal ausdehnen. Jetzt habe ich es aber ;-)
		 Beispiel: Eine VGroup enthlt 2 HGroups die FIX_VERT sind. Nun wird
		 die VGroup auch FIX_VERT. Zusehen im Demo - AddLine-Dialog, oben links.
		-Optimierung: Die Schalter werden jetzt erst nach der Berechnung
		 gesetzt. Sieht etwas 'ruhiger' aus.
		-Kleine Anpassungen von CPropertySheetLayout im Zusammenhang
		 mit Modeless-Dialogen.
	[23.10.99]
		-CTypedPtrList durch CArray ersetzt (schneller ?!).
		-CGroupStatic um Mglichkeit des disablen erweitert.
		 Wurde vorher an CStatic weitergeleitet, was nicht so toll aussaht.
		-Kleiner Fix. Beispiel: HGroup, drin 2 VGroups mit einmal 5 und einmal
		 4 Schaltern. Wenn sich alle gleichmig ausdehnen, haben die natrlich
		 eine unterschiedliche Gesamthhe. Nun werden alle nicht-fixen 
		 Schaltern einen Punkt vergrert, bis die Gesamthhe/breite 
		 erreicht wird.
		-Vorbereitungen fr CGroupSplitter.

	Version 1.5 [25.10.99]
		-CGroupSplitter erstellt.
		 Dadurch wurden einige Anpassungen der Layout-Routinen ntig.
		 So die berarbeitung der prozentualen Ausdehnung.
		-AddSplitter()-Funktion fr CGroupSplitter eingebaut.
	[26.10.99]
		-AddSplitter() erweitert. Mglichkeit der Prozentangabe fr 
		 die obere/rechte Gruppe im Bereich 5-95% ergnzt. 
		 (Untere berechnet sich von allein - klar.)
	
	Version 1.6 [29.-31.10.99]
		-VisibleXGroup eingebaut. (Ausblenden von Gruppen)
		-Mglichkeit eingebaut, dass sich Fenster (Dialog/PropSheet) 
		 nur vertikal oder nur horizontal Ausdehnen knnen.
		-Bugfix der Splitter, funktionierten in PropSheets nicht richtig.
		 In Views kam es auch zu einem kleinen Fehler.
		 Auerdem den typischen Rundungsfehler (+0.5) ausgebaut.
		-Peinlich! In sAddChild(CWnd *w, long mode, long prozent)
		 die bernahme von prozent vergessen :-(
		-GLL merkt sich die Gre und Position von Fenstern und stellt diese
		 nach erneutem Aufruf wieder her. Nun ist es mglich nur die Gre
		 oder nur die Position zu bernehmen.
		-Mal wieder an der Initial-Grenberechnung gebastelt.
		 Und Align-Funktion verbessert.
		-AddXGrpCtrl() um Parameter Flags erweitert.
		 Im Zusammenhang mit TabControls und VisibleXGroup war es mir doch 
		 etwas zu seltsam, dass sich die Gre des TabCtrls bei jedem 
		 Umschalten verndern konnte.
		 Dieses kann jetzt ber USE_INIT_(WIDTH/HEIGHT) unterbunden werden.

	Version 1.7 [6.11.99]
		-Bei GroupSplittern besteht jetzt die Mglichkeit diese Realtime 
		 zu layouten. Sprich die Grenvernderung wird sofort sichtbar.
		 Dieses Einstellung ist default.
		 Bitte schn, Olaf ;-)
		-Der Grenfix aus Version 1.4 hatte noch einen kleinen Bug.
		 Es wurden nur Ctrl-Gruppen gefixt. Bei normalen Gruppen schlug 
		 die Routine nicht an. Weiterhin wurde die Durchlaufvaribale auch dann
		 dekrimentiert, wenn keine Grennderung, wegen MinWidth/Height,
		 durchgefhrt wurde.
		-Controls werden jetzt nur dann verschoben und refresht, wenn sich
		 die Position und Gre wirklich verndert hat.
		 Das sieht 1. ruhiger aus und 2. ist es (laut Profiler) schneller.
	[7.11.99]
		-Es wird nun kein MoveWindow(..., TRUE); (true steht fr Refresh) 
		 mehr durchgefhrt. Dadurch werden die Controls nur verschoben 
		 aber nicht gelscht, die Grafik an der alten Position beleibt also
		 erhalten. Aber das schmiert doch!? Tut es auch. Darum wird das 
		 Fenster einfach gelscht und die sichtbaren Controls ausgestanzt. 
		 Und warum das Ganze? MoveWindow() verschlang die meiste 
		 Zeit bei einem Resize. Wo durch es bei vielen Controls zu einem 
		 unschnen Nachzeh-Effekt kam (z.B. AddLine-Demo vor V1.7).
		-Fix im CPropertySheetLayout - WizardMode. Die Breite wurde durch
		 den Trennstrich breiter als ntig. Die Initialgre des Strichs 
		 ist nun 100 statt 500+(!? (Hlfte der Screenbreite?)).

	Version 1.8 [8.11.99]
		-Fix der Layoutroutine (ReSize). Wenn zwei GREEDY-Gruppen 
		 verkleinert wurden, so wurden beide auf das Minimum der grten 
		 Gruppe verkleinert. Obwohl die minimale Gre bei der anderen 
		 noch nicht erreicht war, wurde diese nicht weiter verkleinert.
		-Auf einigen Systemen wurde der Cursor fr die GroupSplitter
		 nicht richtig gesetzt. Der Mauszeiger verschwand einfach.
		 Nun wird statt 
			::SetCursor(AfxGetApp()->LoadCursor(AFX_IDC_HSPLITBAR));
		 diese
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_SIZEWE));
		 benutzt. Und damit sollte es funktionieren.

	Version 1.9 [12.11.99]
		-Prozentangabe bei V/HGroup() ermglicht.
	[15.11.99]
		-Kleiner Grenfix bei Modeless-Propsheets.
		 Wie bei Dialogen und normalen Propsheets wurde vorher einer
		 5 Pixel Border um das TabCtrl eingefgt.
		-Durch die bergabe eines Namens ist es bei Splittern jetzt
		 mglich, deren letzte Position zu speichern.
	[20.11.99]
		-Kleine Anpassungen bei PropSheets.
		-Fix der Scrollposition bei FormViewLayout.
		 Die aktuelle Position und ob Scroller sichtbar sind
		 wurde nicht bercksichtigt.
		-ShowVisibleGroup(..., bShrink) eingebaut.
		 bShrink (true) bewirkt, wie der Name schon sagt, dass sich das Fenster
		 auf Initialgre verkleinert. Im Normalfall wird es nur vergrert
		 aber nicht verkleinert.
		-Neue Funktion RestetGroup(). Diese ist z.B. dann ntig,
		 wenn ein Dialog geschlossen wird aber noch nicht 'Zerstrt' wird
		 und anschlieend neu aufgerufen.
	[22.11.99]
		-CFormViewBox eingebaut und dadurch kleine nderungen an der
		 Hauptroutine vorgenommen.
		-Die PropSheet-Routinen haben immer noch Problem wenn die aktive
		 Seite nicht die grte Seite im Sheet ist.
		 Zwar wird beim Umschalten vergrert, doch wenn der Dialog schon durch
		 das Laden der letzten Gre vergrert wurde, er also grer ist als
		 das Initiallayout, und dann verkleinert wird - tja, dann wird der Dialog
		 zu klein. Es wird nach wie vor die Gre der ersten Seite als kleinste
		 Gre angenommen. Die Seiten werden durch die MFC erst dann angelegt,
		 wenn auf diese Seiten umgeschaltete wurde. Vorher existieren diese
		 Seiten-Dialog noch gar nicht. Drum komme ich nicht an die Gre.
		 (Versteht mich berhaupt einer?)
		 Ist ja auch egal. Da ist also noch ein Bug drin.
	[26.11.99]
		-Zum Cursor-Problem (siehe Version 1.8)
		 Man muss nur mal etwas in den Header-Files stbern ;-)
		// Note: If this LoadCursor call fails, it is likely that
		//  _AFX_NO_SPLITTER_RESOURCES is defined in your .RC file.
		// To correct the situation, remove the following line from your
		//  resource script:
		//      #define _AFX_NO_SPLITTER_RESOURCES
		// This should be done using the Resource.Set Includes... command.
		-Kleine Optimierungen fr die Compiler Warnstufe 4

  Version 1.10 [14.12.99]
		-Fix wegen WinNT SSP 5.
		-Fix in PropSheet (FIX_Vert/HORI, NORESIZE).
	[26.11.99]
		-Bei AddVisibleXGroup() und AddXGrpCtrl() kam es zu Fehlern
		 bei der Neuberechnung. Die Left/Right/Top/BottomSpace-Werte wurden
		 nicht bercksichtig.
		-Bei NORESIZE Dialogen wird nun der WS_THICKFRAME-Style entfernt und
		 somit auch kein Gripper (Grerziehicon) erzeugt.
		-Der WS_CLIPCHILDREN-Style wird nun automatisch gesetzt.
		-AddChild() um lFlags erweitert (z.B. fr NO_ERASE).

  Version 1.11 [18.12.99]
		-HideTabControl() eingebaut.
		 Wie der Name schon sagt, wird damit das TabControl versteckt.
		 Das funktioniert nicht mit dem WizardMode(!) und sollte nur in
		 ModeLess-Dialoagen genutzt werden.
		-Kleiner Bug in der XGroup()-Routine.
		 H-Fixe Gruppen bekamen die falsche Initialgre
		 zugewiesen, echt bld. Sie bekammen die InitWidth der Elterngruppe
		 und nicht ihre eigene.
		-Fix der AddVGrpTitleCtrl()-Routine.
		 Die Minimalbreite dieser Gruppen betrgt nun TitelControlBreite+
		 Left/RightSpace der Gruppe.
		 So ragt das TitelControl nicht mehr ber die Gruppen hinaus.
	[19.12.99] 0 Uhr (also schon 20.12.99)
		-Die Left/Top/Right/BottomSpace-Geschichte machte immer wieder
		 Probleme. Entweder beim Gren-Fix von Gruppen oder wenn neue
		 Funktionen eingebaut wurden. berall stand so etwas wie
		 'Height = m_Entry->InitHeight+m_Entry->TopSpace+m_Entry->BottomSpace'
		 Das wurde mit der Zeit zu unbersichtlich und Fehleranfllig.
		 Darum: XXXSpace wird nun 1. nur noch bei Gruppen bercksichtigt
		 & 2. die Initialgre beinhaltet jetzt die xxxSpace-Abstnde.
		 Der neue Code reduzierte die Anpassung auf ca. 4 Zeilen Code-
		 das ist bersichtlich.
	[25.12.99]
		-SetGrpProperty() eingebaut.
	[16.01.00]
		-Bei Formviews & Splittern funktionierte das Zusammenspiel noch 
		 nicht richtig. Es wird jetzt GetTotalSize() als kleinste Gre 
		 angenommen.
		-Sollte sich mehr als ein Splitter in der Gruppe befinden wird jetzt
		 eine Fehlermeldung ausgegeben.
	[02.02.00]
		-Kleine Anpassungen bei CPropertySheetLayout.
		 Der CPropertySheetLayout und die erste Seite wird 
		 beim Aufruf von CPropertySheetLayout::OnInitDialog()
		 auf eine Gre von 80/10 gesetzt. Dadurch knnen die Dialog
		 im Erstellungs-Editor auch grer sein als bentigt.
		 So wurde vorher der Sheet automatisch grer gemacht.

  Version 1.12 [25.02.00]
		-Kleine Verbesserung bei der Breite/Hhe von Linien.
		 Bei Linien wurde der XXXSpace-Wert der Elterngruppe 
		 nicht bercksichtigt.
		 Da ich gerade dabei war. AddLine() um Parameter lFlags erweitert.
  
  Version 1.13 [17.03.00]
		-Alle CWnd::ScreenToClient-Aufrufe gendert, da diese in der 'alten'
		 MFC42.dll nicht enthalten war.

  Version 1.14 [26.06.00]
		-Bug in der CGroupStatic-Klasse behoben.
	[04.07.00]
		-In der CGroupStatic-Klasse wurde Titelcontrol nach 
		dem Verschieben nicht neugezeichnet. (MoveWindow(,...,false))
	[09.07.00]
		-Kleiner Fehler bei fixen Gruppen -> Siehe CTest14
		-Bei AddVGrpTitleCtrls wird jetzt die Gre des CheckBox-Ctrls
		 der lnge des Textes angepat.
  
  Version 1.15 [30.07.00]
		-SetAlign() RIGHT ist nun nicht mehr gleich BOTTOM.
		-AddSpreader() eingebaut.
	[08.08.00]
		-AddSpreaderLike() hinzugefgt.
		-ComboBoxen werden jetzt automatisch FIX_VERT gesetzt.
		-Spinbutton (Drehfelder) mit Autom. Buddy werden jetzt richtig
		 angezeigt. Siehe CTest15
	[29.08.00]
		-Kleiner Fix in EndGroup()
	[10.09.00]
		-AddXGrpCtrl(). Wenn der Eingabefukus zum 1. Mal ndert wurde,
		 wurde die OnPaint-Nachricht an der Originalctrl weitergeleitet, 
		 so das der Windowtext von dem Original gezeichnet wurde, und nicht
		 vom CGroupStatic.
	[13.09.00]
		-Bei festen Dialog-Gren wird LOAD_SIZE nun nicht mehr bercksichtigt.
	[29.10.00]
		-SetAlign() in VGroups verbessert.
	[07.12.00]
		-Strings in Unicode-Strings gendert.
  
  Version 1.16 [10.12.00]
		-Fix der Gruppengrenberechnung.
		-Fehler im Projekt fr den Demo-Source behoben.
		-Kleine Berichtigung der Splitterroutinen.
	[19.12.00]
		-Kleiner Fix bei SetAlign() in Zusammenhang mit Spreadern.
	[04.01.01]
		-Bei ComboBox wurde der Modus automatisch auf FIX_VERT gesetzt
		 und so ein NORESIZE einfach berschieben. Nun wurd erst geprft,
		 ob nicht NORESIZE angegeben wurde.
	[16.02.01]
		-Kleinere Positionierungs/Gren-Fixes bei PropertySheets.
	[21.02.01]
		-Wenn die alte Position eines Dialogs wiederhergestellt wird
		 und diese Position auerhalb der Bildschrimanzeige befindet
		 (z.B. alte Pos. x43,y500, Screen 640*480) wird die Position
		 jetzt auf x0,y0 gesetzt.
  
  Version 1.17 [18.03.01]
		-AddXGrpCtrl() und AddXGrpTitleCtrl() arbeiten jetzt mit Prozent-Ausdehnung
  
  Version 1.18 [19.04.01]
		-Die CPropertyPageLayout::OnSetActive()-Funktion berarbeitet.
	[28.04.01]
		-Durch die Umstellung klappte das Zusammenspiel mit PropPages
		 & Splitter nicht mehr 100%ig.
		-Kleine optische Verbesserung von OnSetActive().
	[25.05.01]
		-SetActivePage() berschrieben. Es wird jetzt geprft ob die
		 Seite schon aktuell ist.
  
	Version 1.19 [30.07.01]
		-Wenn Dialog ikoninfiziert und anschlieend wieder geffnet wurden, 
		 hatten die Dialoge eine falsche Gre, da der Rand nicht richtig 
		 berechnet wurde.
	[17.08.01]
		-Bei MDIs wurde die Start-Position des CFormViewLayout nicht richtig
		 gesetzt.
	[30.08.01]
		-Zwischen NT und 9x gibt es scheinbar ziemliche Unterschiede im 
		Aufbau von PropSheet bei Modeless & Tabless. Um genau zu sein:
		10 Pixel in der Breite und 3 in der Hhe, beim Aufruf von
		OnSetActive().
	[05.09.01]
		-SpinControls & UDS_AUTOBUDDY machten vereinzelt noch Probleme.
		 Ist nach dem Wechsel von GetNextDlgTabItem() in GetNextWindow() 
		 nun hoffentlich behoben.
		-Bei IsIconic() & IsZoomed() werden die Position und die Gre
		 nicht mehr gespeichert.
	[10.12.01]
		-Kleiner Fix bei Modeless-PropSheets in FormViews.
	[30.12.01]
		-Fix in ShowVisibleGroup();
	[05.01.02]
		-CPropertyPageLayout::OnSetActive() - Die Unendliche Geschichte.
		 Und wieder ein Fix.

	Version 1.20 [13.01.02]
		AddLine() hat jetzt einen 2. Parameter.

----------------------------------------------------------------------	
	Version 2.0 [13.02.02]
		-CLayoutGroup/CDialogLayout/CPropertySheetLayout/CPropertyPageLayout 
		 wurde komplett neu programmiert.
	[03.03.02]
		-Dialoge werden beim ersten ffnen auf dem Schirm zentriert.
	[17.03.02]
		-Kleine Verbesserung bei ShowVisibleGroup
	[02.06.02]
		-ShowVisibleGroup() fr CFormViewLayout implementiert.
	[03.06.02]
		-Fix vom GroupBoxCtrl. Eine negativer Startposition wurden nicht
		 bercksichtigt (kommt z.B. in CFormViewLayout vor).
	[13.06.02]
		-ProbPages kommen jetzt unter XP besser mit Themen zurecht. Die
		 Seite wird jetzt komplett in COLOR_BTNFACE gezeichnet. (Dieses
		 wird sich in noch ndern und in einer der nchsten Versionen
		 wird mit dem Themen-Hintergrund gezeichnet).
		-Neue Funktion: AKIsThemeActive()
	[16.06.02]
		-Verbesserungen in der RegLoadSetSize()-Funktion. XP-Luna scheint
		 bei MoveWindow() bRepaint = false doch einen Refresh zu machen.
		-Ergnzung von NO_REDRAW.
	[21.06.02]
		-Kleine Verbesserungen bei PropSheets & RegLoadSetSize

	Version 2.1 [11.07.02]
		-Kompilierung mit der fr WinCE genderten Version.
	[06.08.02]
		-Erweiterung von AddChild(): NORESIZE_CALCWIDTH berechnet
		 die Breite eines Controls anhand der Textbreite + m_lCalcExtra
		 [+ 20 (wenn Radio oder CheckBox)].
		-SetCalcExtra() zum setzen von m_lCalcExtra. 
		-AKSetWindowSize(CWnd *m_pSouceWnd,CWnd *m_pDestWnd) und 
		 AKSetWindowSize(CWnd *m_pParentWnd,UINT SourceID,UINT DestID)
		 Gibt dem Dest(ination)-Window die Gre des Source-Windows.
	[15.08.02]
		-Fehler bei beim ReCreate von nicht-Modalen Dialogen behoben.
	[31.08.02]
		-Mens in Dialogen wurden nicht in der Minimalengre der
		 jeweilige Dialoge anrechnet. Hierfr gibt es jetzt das Flag
		 INCLUDE_MENUHEIGHT welches z.B. mit LOAD_POS_AND_SIZE 
		 bergeben werden kann.
	[08/11.11.02]
		-Fix von NORESIZE_CW.
	[20.11.02]
		-Fix in AddVGrpTitleCtrl() im Zusammenhang mit ComboBox-Ctrls.

	Version 2.2 [15.03.03]
		-Viele nderungen in VisibleGroups. AddVisibleXGroup hat fr
		 die Zusammenarbeit mit TabControls einen neuen Schalter 
		 bekommen (bReCalc). Z.B. wurde bei weggefalteten Gruppen der
		 Rand trotzdem in die Grenberechnugn einbezogen.
	
	 Version 2.3 [26.04.03]
		-Dateien fr den VC7 beigefgt.
	[20.05.03]
		-ShowVisibleGroup() bercksichtigt nun die aktuelle Aufteilung
		 von Splittern.
	[08.06.03]
		-ShowVisibleGroup() setzt Splitter in der Wnd-Liste nach vorn (Z-Order).
	[02.08.03]
		-ShowVisibleGroup(): Wenn die Gruppe zu einem Splitter gehrt und
		 ausgeschaltet wird, geht die andere Gruppe auf 100%. Wird die Gruppe
		 wieder eingeschaltet, wird das eigentliche Prozentverhltnis wiederher-
		 gestellt. Ist eine der beiden Gruppen ausgeschaltet, wird der Splitter
		 disabled. (Wenn ich etwas Zeit finde, baue ich eine Routine, mit der er
		 ausgeblendet werden kann.)
	[15.08.03]
		-Berichtigung von SetAlign(BOTTOM) in VGroups().
	[14.10.03]
		-CStatusBar gegen CWnd getauscht. Damit ist der Rand unten kleiner geworden
		 und unter XP-Luna gibt es nicht mehr den unschnen Absatz.
	[14.12.03]
		- #define End EndGroup() Gendert, da es einen Konflikt mit
		  virtual HRESULT STDMETHODCALLTYPE End( void) = 0; ergab.
		  Entwerder #define EndG EndGroup() oder #define EndGrp EndGroup() oder
		  #define End EndGroup() in StdAfx.h setzen.

	Version 2.4 [01.02.04]
		-SetBkgColor() zum setzen der Dlg-Hintergrundfarbe.
		-Dateien fr den VC6,VC7,VC7.1
	[28.05.04]
		-Splitter laufen jetzt glatter.
	[18.06.04]
		-Fix: VisibleGoups: Unsichtbare Greedy-Ctrls in Fixen-Gruppen.
	[21.06.04]
		-Message-Bearbeitung in ResetGroup() auf Zeichen-Nachrichten beschrnkt.
	[08.11.04]
		-MOVEWINDOW_REDRAW-Flag fr Dialog/PropSheet. Fhrt beim setzen der Controls ein
		 MoveWindow(x,x,x,x,TRUE) fr alle aus (default ist false).
	[06.12.04]
		-Fix in CDialogLayout::SetSize()
		 Unter bestimmten Umstnden wurde dem Untergrund-Dlg vom Modeless-Sheet eine 
		 Grenvernderung gemeldet, obwohl noch genug Platz war.
		-Fix in CPropertySheetLayout::OnInitDialog()
		 Das TabCtrl wird jetzt erst am Ende der Routine ausgeschaltet. 
	[20.07.05]
		-ON_DLG_TOP, FULL_HEIGHT und FULL_WIDTH - Flags.
	[18.09.05]
		-DisableThickFrame();
		-MOVE_OCX
		-AddLine()-Hintergrundfarbe
	[18.02.06]
		-Kleiner nderungen fr VS2005
	[29.05.06]
		-Multimonitor-Support
	[04.07.06]
		-Anpassungen an Vista (Beta2).
		-nderung: AKIsThemeActive(), ,0=Aus,1=WinXp,2=Vista
	[19.09.06]
		-Anpassungen an Vista RC1.
	[30.09.06]
		-Erweiterung von sAddGrpCtrl() um Color-Parameter
	[14.11.06]
		-BOLD_FONT fr CGroupStatic
	[14.03.07]
		-Vistafix 
	[29.06.07]
		-DisableGLLEraseBackground
	[05.10.07]
		-ShowGroups-Fix fr System vor Win2000.
	[03.01.08]
		-Fix: Im Zusammenhang mit AddChild(XXX, FIX_VERT|FULL_WIDTH|ON_DLG_TOP) und 
		 CPropertySheetLayout kam es zu Size-Problemen. Es wird nun ein AKReSize() 
		 ausgefhrt. Auerdem wird in SetWizardButtons() das unsichtbare Control 
		 ID_WIZFINISH repositioniert.

  Version 2.5 [17.03.08]
		-CGroupStatic wird nun von CButton abgeleitet.
		-CGroupStatic Theme-Untersttzung (Linien).
	[10.04.08]
		-GLL ist OpenSource
	[09.05.08]
		-Fix: CGroupStatic (Theme) unter 2k/NT4/9x
	[19.05.08]
		-Fix: MoveWindows()-> TabCtrl
	[17.06.08]
		-Fix: in MoveWindows(), refresh des Title-Ctrls (AddXGrpCtrl)
	[25.06.08]
		-Fix: AddSpreaderLike & NORESIZE_CW
	[02.07.08]
		-Alle Gruppen (XGroup/AddXGrpCtrl/...)liefern nun CLayoutGroupObj * zurck.
	[19.08.08]
		-Fix: Initial-Gre bei Propsheets & NORESIZE_CW
	
  Version 2.6 [02.09.08]
		-CDialogLayout -> GrowSize
		-Theme-Anpassungen
		-CPropertySheetLayout -> GrowSize
		-CPropertySheetLayout::OnInitDialog(_WMFlags_NoBottomLine|_WMFlags_Wizard)

   Version 2.7 [17.01.12]
		-Lazy fetching-Group AddLFV/HGroup()

   Version 2.7.1 [22.11.12]
		-Windows 8 GroupBox-Fix (CGLL_Theme_Helper)

   Version 2.7.2 [08.01.13]
		-MaxSize-Controls siehe AddChild

   Version 2.7.3 [25.03.14]
		-Win8.1++-Erkennung in GLL_GetWindowsVers()

   Version 2.7.4 [02.05.14]-[23.06.14]
		-Anpassungen an high-DPI (CGLLHiDpi).
   
   Version 2.7.5 [05.10.15]
		-Rckgabewert von AddChilde, AddLine etc von bool in CLayoutGroupObj * gendert.
		-SetCalcExtra() nutzt CGLLHiDpi
		-SetGroupBorder(), AddGroupBorder()
		-Der Border wurde bei IS_A_GROUP_WINDOW durch 2 geteilt, er soll aber den inneren Bereich angeben.
			+ Dies war vorher so: (B = Border, G=Group, C=Control)
			+ G(B/2)C(B/2) es soll bei GroupBoxen aber sein GCB
			+ bei normalen Controls ist es GBC, da diese keinen 'inneren' Bereich haben.
	
	Version 2.8  [02.02.16]
		-GetGroupBoxColor() /SetGroupBoxColor()
		-GetDpiForMonitor-Untersttzung fr CGLLHiDpi

	Version 2.8.1  [09.03.16]
		-GLL_MonitorFromRect()
		-GLL_MonitorFromPoint()
		-GLL_GetMonitorInfo()

	Version 2.8.2  [07.02.18]
		-SetRootBorderSite()
		-SetRootBorder()
		-ReSizeRoot()
		-ReCalcRoot()
		-SetRootPos()
		-GetRootBorder()
		-SetViewSize()

	Version 2.8.3  [21.01.19]
		-GetOSVersion() (Manifest-fix)

**********************************************************************/

#define _USE_GLL_THEME_

#ifdef _USE_GLL_THEME_
	/************************************************************************
	* nutzt CGLL_Theme_Helper, wenn gewnscht
	* ToDo: Pfad ggf. anpassen!
	************************************************************************/
#ifdef _GLL_DEMO_
#include "GLL_Theme_Helper.h"
#else
#include <Classes\GUILayoutLib\GLL_Theme_Helper.h>
#endif

void GLLSetThemeHelper(CGLL_Theme_Helper* pTheme);
void GLLSetGroubBoxColor(long nColor = -1);
#endif

/**********************************************************************/

//hier gehts los! ;-)

extern UINT const WM_PROPPAGE_SIZED_SHEET, 
	WM_VIEW_SCROLL_PARAM,
	WM_VISIBLEGROUP_RESIZED, 
	WM_GET_LINE_BKGCOLOR_,
	WM_OPEN_LAZY_FETCHING_GROUP;

//RegLoadSetSize
#define _RGL_TYPE_DIALOG_ 1
#define _RGL_TYPE_MAINWND_ 1
#define _RGL_TYPE_PROPSHEET_ 3

/**********************************************************************/

enum  { IS_THE_ROOT,IS_A_LAYOUT_GROUP, IS_A_WINDOW,
	IS_A_SPACE,IS_A_SPREADER, IS_A_GROUP_WINDOW,
	IS_A_LINE, IS_A_SPLITTER, IS_A_TABCONTROL
	};

enum {
	GREEDY			= 0,
	FIX_HORI		= 1 << 0,
	FIX_VERT		= 1 << 1,
	NORESIZE		= FIX_HORI | FIX_VERT,
	
	// Nur fr Dialog/PropSheet
	LOAD_POS = 1 << 3,
	LOAD_SIZE = 1 << 4,
	LOAD_POS_AND_SIZE = LOAD_POS|LOAD_SIZE, // default
	NORESIZE_CALCWIDTH,
	INCLUDE_MENUHEIGHT = 1 << 6,
	MOVEWINDOW_REDRAW = 1 << 7, // MoveWindow(x,x,x,x,TRUE);
	FULL_WIDTH = 1 << 8,
	FULL_HEIGHT = 1 << 9,
	ON_DLG_TOP = 1 << 10, // Positioniert Control ganz oben
	
	MOVE_OCX = 1 << 13, // Benutzt CWnd statt HWND
	ON_DLG_TOP2 = 1 << 14, // Positioniert Control ganz oben und addiert den Abstand nach oben zur Hhe
	IS_LF_GROUP = 1 << 15, //Lazy fetching-Group
	};

#define NORESIZE_CW  NORESIZE_CALCWIDTH

// flags AddXGrpCtrl
enum {
	USE_INIT_WIDTH = 1 << 0,
	USE_INIT_HEIGHT = 1 << 1,
// SetGrpProperty
	SAME_SIZE = 1 << 2,

	PRIVAT1 = 1 << 3,
	PRIVAT2 = 1 << 4,
	
//	AddLine
	LINE_FULL_WIDTH  = 1 << 5,
	LINE_FULL_HEIGHT = 1 << 5,
	PRIVAT3 = 1 << 6,
	CENTER_TEXT  = 1 << 7, // default
	LEFT_TEXT  = 1 << 8, // 
	RIGHT_TEXT  = 1 << 9, // 

	PRIVAT4 = 1 << 12,
	BOLD_FONT = 1 << 13, // CGroupStatic
	PRIVAT5 = 1 << 14,

	};

#define IS_UPDOWN32RIGHT (1 << 6)
#define IS_UPDOWN32LEFT  (1 << 7)

//flags AddChild 
enum {
	NO_ERASE = 1 << 2,
	NO_REDRAW = 1 << 10,
	NO_RECALC = 1 << 11,
	};

enum { IS_CDialogLayout=10,IS_CPropertySheetLayout,
	IS_CPropertyPageLayout, IS_CFormViewLayout};

enum { LEFT,CENTER, RIGHT, VCENTER, HCENTER, BOTTOM , VRIGHT, HBOTTOM};

#define LABEL_TOP 1
#define LABEL_BOTTOM 2

/*********************************************************************/

#define VGROUP_LAYOUT 1
#define HGROUP_LAYOUT 2
#define TOP  LEFT

// Gendert 
//#define End EndGroup()
// Konflikt
///virtual HRESULT STDMETHODCALLTYPE End( void) = 0;

#define EndG EndGroup()
#define EndGrp EndGroup()

#define AddBottomGroup(x,y) AddSpace(2);AddLine(LINE_FULL_WIDTH);\
	AddSpace(2);HGroup();SetAlign(RIGHT);AddChild(x,NORESIZE); \
	AddSpace(10);AddChild(y,NORESIZE);EndGroup();

#define AddBottomGroup1(x) AddSpace(2);AddLine(LINE_FULL_WIDTH);\
	AddSpace(2);HGroup();SetAlign(RIGHT); AddChild(x,NORESIZE);EndGroup();

#define AddBottomGroup3(x,y,z) AddSpace(2);AddLine(LINE_FULL_WIDTH);\
	AddSpace(2);HGroup();AddChild(x,NORESIZE);AddSpace(0);AddChild(y,NORESIZE); \
	AddSpace(10);AddChild(z,NORESIZE);EndGroup();

/*********************************************************************/

void AKSetWindowSize(CWnd *m_pSouceWnd, CWnd *m_pDestWnd);
void AKSetWindowSize(CWnd *m_pParentWnd, UINT SourceID, UINT DestID);
void AKScreenToClient(HWND m_phWnd, LPRECT lpRect);

int AKGetWindowWidth(CWnd *m_pWnd);
int AKGetWindowHeight(CWnd *m_pWnd);
int AKGetWindowWidth(CWnd *m_pParentWnd, UINT ID);
int AKGetWindowHeight(CWnd *m_pParentWnd, UINT ID);

void AKSetWindowWidth(CWnd *m_pWnd, long m_lWidth);
void AKSetWindowHeight(CWnd *m_pWnd, long m_lHeight);
void AKSetWindowWidth(CWnd *m_pParentWnd, UINT ID, long m_lWidth);
void AKSetWindowHeight(CWnd *m_pParentWnd, UINT ID, long m_lHeight);
void AKReSize(CWnd *m_pWnd); // Width +1 ->  Width -1

//VC6
CRect AKGetWorkArea(LPCRECT rc);
HANDLE GLL_MonitorFromRect(LPCRECT lprect, DWORD dwFlags);
HANDLE GLL_MonitorFromPoint(POINT pt, DWORD dwFlags);
BOOL GLL_GetMonitorInfo(HANDLE hMonitor, void *lpMInfo);

// Use GLL_XXXX
#define GLL_SetWindowSize AKSetWindowSize
#define GLL_ScreenToClient AKScreenToClient
#define GLL_GetWindowWidth AKGetWindowWidth
#define GLL_GetWindowHeight AKGetWindowHeight
#define GLL_SetWindowWidth AKSetWindowWidth
#define GLL_SetWindowHeight AKSetWindowHeight
#define GLL_ReSize AKReSize
#define GLL_GetWorkArea AKGetWorkArea


#ifndef UNDER_CE
int RegLoadSetSize(CWnd *m_pWnd, LPCTSTR szString, long lMode = LOAD_POS_AND_SIZE, int iType = 0, DWORD dwGrowSizeGLL = 0);
void RegWriteSize(CWnd *m_pWnd, LPCTSTR szString);
#endif
void sSetButtonHeight(CWnd *pWnd, UINT ids[]);
int AKIsThemeActive();
int AKIsThisNT();

/**********************************************************************/
class CLayoutGroup;
class CLayoutGroupObj;
class CDialogLayout;
class CPropertySheetLayout;
class CPropertyPageLayout;
class CFormViewLayout;
class CFormViewBox;
class CPropertyPageLayoutWhite;
class CGroupStatic;
class CGroupSplitter;

void SetGroupBorder(CLayoutGroupObj *pGrp, LONG left, LONG top, LONG right, LONG bottom);
void SetGroupBorder(CLayoutGroupObj *pGrp, LPCRECT lpRect);
void AddGroupBorder(CLayoutGroupObj *pGrp, LONG left, LONG top, LONG right, LONG bottom);
void AddGroupBorder(CLayoutGroupObj *pGrp, LPCRECT lpRect);

/*********************************************************************/
#define  _GLL_AUTO_SCALE_

class CGLLHiDpi
{
public:

	CGLLHiDpi();

	int GetDPIX();
	int GetDPIY();
	int ScaleX(int x, int iDpiScaleAbove = CGLLHiDpi::m_iDefaultDpi);
	int ScaleY(int y, int iDpiScaleAbove = CGLLHiDpi::m_iDefaultDpi);
	void ScaleRect(PRECTL pRect);
	void Invalidate();

private:

	void _Init();

private:
	static int m_iDefaultDpi; // 96
	int m_idpiX, m_idpiY;
	BOOL m_bInitialized;
};

/**********************************************************************/

CGLLHiDpi* GLL_GetDPI();

/**********************************************************************/


class CLayoutGroupObj : public CObject  
{
public:
	CLayoutGroupObj();
	virtual ~CLayoutGroupObj();


	HWND	m_hTheWnd;
	CWnd	*m_TheWnd;
	CRect	rcAktSize, rcMinSize, rcBorder, rcWinSize;


	int Align, Ausrichtung, Art, WinArt, Space, InitalSpace;
	DWORD dwFlags, dwMaxSize; //(LO/HIWORD)

	bool ReSizeHori, ReSizeVert,
		bVisible, bRefresh,
		bUse_RDW_ERASE,
		bUse_CWnd_Move; // def. false

	int ReSizeVertInit, ReSizeHoriInit;
	double nPercent, nPercentBackUp;
	CString m_Name; // GroupCtrl

	CGroupStatic	*m_Group;
	CGroupSplitter	*m_Splitter;
	CLayoutGroup	*m_RootGroup;
	CLayoutGroupObj	*pParentGroup;

	CArray<CLayoutGroupObj*, CLayoutGroupObj*>m_Childs;
	long ID,
		m_iInitialWidth,	// IS_A_TABCONTROL
		m_iInitialHeight;	// IS_A_TABCONTROL

	//-------------
	void InitGroupObj();
};

/*********************************************************************/
enum { _GLBS_LEFT = 0, _GLBS_TOP, _GLBS_RIGHT, _GLBS_BOTTOM }; //SetRootBorderSize
class CLayoutGroup : public CObject
{
public:
	CLayoutGroup();
	virtual ~CLayoutGroup();
	void SetRootBorder(LONG left, LONG top, LONG right, LONG bottom){SetGroupBorder(&m_RootGroup, left, top, right, bottom);}
	void SetRootBorder(LPCRECT lpRect){SetGroupBorder(&m_RootGroup,lpRect);}
	void SetRootBorderSite(UINT nSite, LONG nSpace, bool m_bScale = true);
	void ReSizeRoot() { Size(&m_RootGroup); }
	void ReCalcRoot(){CalcGroups(&m_RootGroup); }
	CLayoutGroupObj *FindGroup(HWND hWnd, LPCTSTR szString = NULL);
	void SetRootPos(int posx = 0, int posy = 0) {SetPosGroups(&m_RootGroup, posx, posy);}
	void GetRootBorder(CRect& rc) {rc = m_RootGroup.rcBorder;}
	void SetViewSize(SIZE size) {m_ViewSize = size;}
	COLORREF GetBkgColor();
	/**********************************************************************/
	void SetBkgColor(COLORREF crColor);
	void LayoutInit();
	void SetParentWindow(CWnd *pParentN);/// Only 4 subclass
 protected:
	friend class CGroupStatic;
	friend class CGroupSplitter;
	friend class CDialogLayout;
	friend class CPropertySheetLayout;
	friend class CPropertyPageLayout;
	friend class CFormViewLayout;
	friend class CFormViewBox;
	friend class CPropertyPageLayoutWhite;

	int iStatusBarHeight;
	long lTheWindowIsA;
	CWnd *pTheWindow;
	int m_bIsThemeActive;

	CLayoutGroupObj *privAddGroup(int mode, LPCRECT lpRect, LPCTSTR szString = NULL);
	CLayoutGroupObj *privAddGrpCtrl(UINT id, long mode, UINT titelID = 0, long type = IS_A_GROUP_WINDOW, long lFlags = 0, long m_Color = -1);
	CLayoutGroupObj *privAddLFGroup(int mode, LPCRECT lpRect);
	CLayoutGroupObj *privAddVisibleGroup(long mode, bool bVisible, LPCRECT lpRect, bool bReCalc);

	bool privInitLFGroup(CLayoutGroupObj *pLFGrp);
	CLayoutGroupObj *privAddChild(UINT id, DWORD mode = 0, DWORD nPercent = 0, DWORD lFlags = 0, DWORD dwMaxSize = 0);
	CLayoutGroupObj *privAddChild(CWnd *w, DWORD mode = 0, DWORD nPercent = 0, DWORD lFlags = 0, DWORD dwMaxSize = 0);
	CLayoutGroupObj *privAddLine(long lFlags = 0, LPCTSTR szString = NULL, long m_Color = -1);
	CLayoutGroupObj *privAddSpace(long space, long InitalSpace = 0);
	CLayoutGroupObj *privAddSpreader(long xspace = 1, long yspace = 1, long mode = 0);
	CLayoutGroupObj *privAddSpreaderLike(CWnd *w, long mode = 0);
	CLayoutGroupObj *privAddSpreaderLike(UINT id, long mode = 0);
	CLayoutGroupObj *privAddSplitter(long prozent = 0, bool bRealTimeLayout = true, LPCTSTR szString = NULL, long lBackGroundColor = -1);

	void privSetAlign(long mode);
	void privShowVisibleGroup(CLayoutGroupObj *m_Grp, bool bShow, bool bRefresh = false);

	void SetDlgName(LPCTSTR szString)
		{
		m_Name = szString;
		}

	void privSetCalcExtra(long lWidth)
		{
		m_lCalcExtra = GLL_GetDPI()->ScaleX(lWidth);
		}

	void privEndLFGroup();// muss nach sInitLFGroup() aufgerufen werden
	void Size(CLayoutGroupObj *pGroup);
	LPCTSTR GetDlgName()
		{
		return m_Name;
		}

	int  GetGroupID();
	long OSVersion() {return m_NTVersion;}
	//-------------------------------------------
	void CalcGroups(CLayoutGroupObj *pGroup);
	void SetPosGroups(CLayoutGroupObj *pGroup, int posx = 0, int posy = 0);
	void SearchForGroupStatics(CLayoutGroupObj *pGroup, CLayoutGroupObj *pLGroup);
	void SetReSize(int bVert, int bHori);
	void InitGroups(CLayoutGroupObj *pGroup);
	
	void privEndGroup();
	void MoveWindows();
	CSize privGetMinSize();

	COLORREF GetDlgBKColor();
	COLORREF GetGroupBoxColor();


	CLayoutGroupObj m_RootGroup;

	CLayoutGroupObj *NewGroup(CLayoutGroupObj *m_pParentGrp, long Ausrichtung);
	CLayoutGroupObj *NewItem(CLayoutGroupObj *m_pParentGrp, UINT nID, long lSpread);
	CLayoutGroupObj *NewItem(CLayoutGroupObj *m_pParentGrp, CWnd *pWnd, long lSpread);
	CTypedPtrList<CObList, CLayoutGroupObj*>m_FIFO;

	CSize m_ViewSize; // GetTotalSize() bei Views sonst (0,0)!
	long m_crBackGrdColor, // def = -1 == ::GetSysColor(COLOR_BTNFACE)
		m_crGroupBoxBorderColor; // -1 def;
	bool m_bMWRedrawWindow, m_NoGLLEraseBackGround;

//protected:
	void ResetGroup();
	void ShowGroups(CLayoutGroupObj *pGroup, bool bVisible, bool bInit = false);
	void ReInitGroups(CLayoutGroupObj *pGroup);
	void ReInitGroupSplitter(CLayoutGroupObj *pGroup);

	CLayoutGroupObj* GetGroup();
	CArray<CLayoutGroupObj*, CLayoutGroupObj*>m_Childs;
	CFont *m_pCWFont;
	CString m_Name;
	long ID, m_lCalcExtra, // default 5
		m_NTVersion;
};


/*********************************************************************/

/**********************************************************************
// CGroupStatic
//
// (w) 1999++,Andreas Kapust
// info AT akapplications DOT com
//
// <Unterbindet das Flackern in ein einer Group>
**********************************************************************/

class CGroupStatic : public CButton
{
// Konstruktion
public:
	CGroupStatic();
	DECLARE_DYNAMIC(CGroupStatic)
	long m_lFlags, m_BkColor;
// Attribute
public:

// Operationen
public:
// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CGroupStatic)
	protected:
	//}}AFX_VIRTUAL

// Implementierung

public:
	long SetTitleCtrl(UINT uiID);
	long SetTitleCtrl(CWnd *m_pWnd);
	virtual ~CGroupStatic();
	
	void AddMember(CWnd* pWnd);
	void AddMember(HWND pWnd);
	void AddMember(UINT nID);
	void SetTitle(CString m_Title);
	void RemoveAllMember();
	void RedrawTitleCtrl();

	CLayoutGroup *m_RootGroup;

	void GroupPaint(CDC *dc,bool bMember);

	CGroupStatic& operator<< ( CWnd* pWnd )
		{
		AddMember(pWnd);
		return *this;
		}

	CGroupStatic& operator<< ( UINT nID )
		{
		AddMember(nID);
		return *this;
		}
	
	HWND GetTitleCtrl()
		{
		return m_hTitleControl;
		}
	
protected:
#ifdef _USE_GLL_THEME_
	CGLL_Theme_Helper*	m_pTheme;
	HTHEME	hLoadedTheme;
	void SetThemeHelper(CGLL_Theme_Helper* pTheme);
#endif

	long m_lTextLen,m_lTextLenInit;
	CString m_WinTitle;
	CRect winRectOld;
	HWND m_hTitleControl;
	CFont *pBoldFont;
	bool m_UseBoldFont;
	CArray<HWND,HWND>m_Member;
	
	//{{AFX_MSG(CGroupStatic)
	afx_msg void OnPaint();
	afx_msg void OnWindowPosChanged(WINDOWPOS FAR* lpwndpos);
	afx_msg void OnEnable(BOOL bEnable);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnSysColorChange();
	afx_msg UINT OnGetDlgCode();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
		friend class CLayoutGroup;
private:
	virtual void PreSubclassWindow();
	bool bIsDisabled;
};


/*********************************************************************/

/**********************************************************************
// CGroupSplitter
//
// (w) 1999++,Andreas Kapust
// info AT akinstaller DOT de
//
**********************************************************************/

class CGroupSplitter : public CStatic
{
// Konstruktion
public:
	CGroupSplitter();

// Attribute
public:
	int m_bIsThemeActive;
// Operationen
public:

// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CGroupSplitter)
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CGroupSplitter();
	CLayoutGroup *m_LayoutGroup;

	void SetPercent(double lFirstPercent)
		{
		m_lFirstPercent = lFirstPercent;
		} //  fix 2.1.4

	void SetData(CWnd *w, bool bHori, long lFirstPercent = 0)
		{
		m_Parent = w;
		bIsHori = bHori;
		m_lFirstPercent = lFirstPercent;
		}

	void ReInitTopBottomGroups();
	
	void SetTopBottomGroups(CLayoutGroupObj *pTopGrp, CLayoutGroupObj *pBottomGrp);
	
	double GetFirstGrpPercent()
		{
		return m_lFirstPercent;
		}
	bool bRealTimeLayout;
//	CLayoutGroupObj *GetRootGroup(){return pRootGroup;}
private:
	CLayoutGroupObj *pTopGroup,*pBottomGroup;

protected:
	friend class CLayoutGroup;

	COLORREF GetBkGrColor();
	void CalcPercent(double diff, bool m_UpdateWindow = false);
	CWnd *m_Parent;
	bool bIsHori;
	long m_BackGroundColor;
	long VertSplitting(CPoint pt);
	long HoriSplitting(CPoint pt);
	double m_lFirstPercent;
	bool GetGroupRect(CRect *mRect);
	//{{AFX_MSG(CGroupSplitter)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/*********************************************************************/

#define CSizeGLL(width,height) MAKELONG(width,height)


class CDialogLayout : public CDialog
{
// Konstruktion
public:
	DECLARE_DYNAMIC(CDialogLayout)
	CDialogLayout(UINT nID, 
		CWnd* pParent = NULL, 
		LPCTSTR strName = NULL, 
		bool bGripper = true, long lSpread = GREEDY|LOAD_POS_AND_SIZE,
		DWORD lpInitGrowSizeGLL = NULL); //CSizeGLL()  
	virtual ~CDialogLayout();

	CLayoutGroup m_LayoutGroup;

	CLayoutGroupObj *VGroup(LPCRECT lpRect = NULL, LPCTSTR szString = NULL)
		{
		return(m_LayoutGroup.privAddGroup(VGROUP_LAYOUT, lpRect, szString));
		}

	CLayoutGroupObj *HGroup(LPCRECT lpRect = NULL, LPCTSTR szString = NULL)
		{
		return(m_LayoutGroup.privAddGroup(HGROUP_LAYOUT, lpRect, szString));
		}

	CLayoutGroupObj *AddVGrpCtrl(UINT id, long type = IS_A_GROUP_WINDOW, long lFlags = 0, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, VGROUP_LAYOUT, 0, type, lFlags, m_Color));
		}

	CLayoutGroupObj *AddHGrpCtrl(UINT id, long type = IS_A_GROUP_WINDOW, long lFlags = 0, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, HGROUP_LAYOUT, 0, type, lFlags, m_Color));
		}
	
	CLayoutGroupObj *AddVGrpTitleCtrl(UINT id, UINT wID, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, VGROUP_LAYOUT, wID, 0, 0, m_Color));
		}

	CLayoutGroupObj *AddHGrpTitleCtrl(UINT id, UINT wID, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, HGROUP_LAYOUT, wID, 0, 0, m_Color));
		}

	CLayoutGroupObj *AddVisibleVGroup(bool bVisible = true, LPCRECT lpRect = NULL, bool m_bRecalc = true)
		{
		return(m_LayoutGroup.privAddVisibleGroup(VGROUP_LAYOUT, bVisible, lpRect, m_bRecalc));
		}

	CLayoutGroupObj *AddVisibleHGroup(bool bVisible = true, LPCRECT lpRect = NULL, bool m_bRecalc = true)
		{
		return(m_LayoutGroup.privAddVisibleGroup(HGROUP_LAYOUT, bVisible, lpRect, m_bRecalc));
		}
	
	CLayoutGroupObj *AddLFVGroup(LPCRECT lpRect = NULL)
		{
		return(m_LayoutGroup.privAddLFGroup(VGROUP_LAYOUT, lpRect));
		}

	CLayoutGroupObj *AddLFHGroup(LPCRECT lpRect = NULL)
		{
		return(m_LayoutGroup.privAddLFGroup(HGROUP_LAYOUT, lpRect));
		}

	void ShowVisibleGroup(CLayoutGroupObj *m_pGrp, bool bShow, bool bRefresh = false, BYTE bShrink = 0);
	
	void EndLFGroup()
		{
		m_LayoutGroup.privEndLFGroup();
		}// muss nach InitLFGroup() aufgerufen werden

	void SetButtonHeight(UINT ids[])
		{
		sSetButtonHeight(this, ids);
		}
	
	void SetReSize(int bVert = -1, int bHori = -1)
		{
		m_LayoutGroup.SetReSize(bVert, bHori);
		}
	
	void EndGroup(LPCRECT lpBorderRect = NULL);

	void SetAlign(long mode)
		{
		m_LayoutGroup.privSetAlign(mode);
		}

	void SetCalcExtra(long lWidth)
		{
		m_LayoutGroup.privSetCalcExtra(lWidth);
		}

	void DisableThickFrame();
	
	void SetDlgName(LPCTSTR szString)
		{
		m_LayoutGroup.SetDlgName(szString); m_strRegStore = szString;
		}

	void SetBkgColor(COLORREF crBkh = -1);
	void SetGroupBoxColor(COLORREF crColor = -1);
	void DisableGLLEraseBackground(bool m_NoErase = false);

	bool InitLFGroup(CLayoutGroupObj *pLFGrp)
		{
		return m_LayoutGroup.privInitLFGroup(pLFGrp);
		}

	CLayoutGroupObj *AddLine(long lFlags = 0, LPCTSTR szString = NULL, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddLine(lFlags, szString, m_Color));
		}

	CLayoutGroupObj *AddChild(UINT id, DWORD mode = 0, DWORD lPercent = 0, DWORD lFlags = 0, DWORD dwMaxSize = 0)
		{
		return(m_LayoutGroup.privAddChild(id, mode, lPercent, lFlags, dwMaxSize));
		}

	CLayoutGroupObj *AddChild(CWnd *pWnd, DWORD mode = 0, DWORD lPercent = 0, DWORD lFlags = 0, DWORD dwMaxSize = 0)
		{
		return(m_LayoutGroup.privAddChild(pWnd, mode, lPercent, lFlags, dwMaxSize));
		}
	
	CLayoutGroupObj *AddSpace(long space, long InitalSpace = 0)
		{
		return(m_LayoutGroup.privAddSpace(space, InitalSpace));
		}
	
	CLayoutGroupObj *AddSpreader(long xspace = 1, long yspace = 0, long mode = 0)
		{
		return(m_LayoutGroup.privAddSpreader(xspace, yspace, mode));
		}

	CLayoutGroupObj *AddSpreaderLike(CWnd *w, long mode = 0)
		{
		return m_LayoutGroup.privAddSpreaderLike(w, mode);
		}

	CLayoutGroupObj *AddSpreaderLike(UINT id, long mode = 0)
		{
		return m_LayoutGroup.privAddSpreaderLike(id, mode);
		}

	CLayoutGroupObj *AddSplitter(long lFirstPercent = 50, bool bRealTimeLayout = true, LPCTSTR m_Name = NULL, long lBackGroundColor = -1)
		{
		return(m_LayoutGroup.privAddSplitter(lFirstPercent, bRealTimeLayout, m_Name, lBackGroundColor));
		}
	
	int GetGroupID()
		{
		return m_LayoutGroup.GetGroupID();
		}

	LPCTSTR GetDlgName()
		{
		return m_LayoutGroup.GetDlgName();
		}
	
	CSize GetMinSize();

	long m_lSpread, iStatusBarHeight;
	bool m_bGripper;
	CString m_strRegStore;
	CWnd m_StatusBar;
	CSize m_StatusBarSize;
// Dialogfelddaten
	//{{AFX_DATA(CDialogLayout)
		// HINWEIS: Der Klassen-Assistent fgt hier Datenelemente ein
	//}}AFX_DATA


// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CDialogLayout)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	void SetSize();
	// Generierte Nachrichtenzuordnungsfunktionen
	//{{AFX_MSG(CDialogLayout)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);

//#C The following line was #ifdef'd - OnGetMinMaxInfo is not part of MFC
//#A Dirk Gaudian
//#D 18.06.2002
//#V 2.01
#ifndef UNDER_CE
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
#endif
	//}}AFX_MSG
	afx_msg LRESULT OnPageResize(WPARAM, LPARAM);
	DECLARE_MESSAGE_MAP()
	CPoint m_DlgSize;
	DWORD lpInitialGrow; // Prozentuale Vergrerung beim ersten(!) Aufruf
};

/*********************************************************************/
/*********************************************************************/
///m_bWizardModeFlags
#define _WMFlags_Wizard 1
#define _WMFlags_NoBottomLine 2

class CPropertySheetLayout : public CPropertySheet
{
	DECLARE_DYNAMIC(CPropertySheetLayout)

// Konstruktion
public:
	CPropertySheetLayout(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0, LPCTSTR strName = NULL, bool bGripper = true, long lSpread = GREEDY | LOAD_POS_AND_SIZE, DWORD lpInitGrowSizeGLL = NULL); //CSizeGLL()  
	CPropertySheetLayout(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0, LPCTSTR strName = NULL, bool bGripper = true, long lSpread = GREEDY | LOAD_POS_AND_SIZE, DWORD lpInitGrowSizeGLL = NULL); //CSizeGLL()  

	void InitData();
// Attribute
public:
	CLayoutGroup m_LayoutGroup;

	CLayoutGroupObj *VGroup(LPCRECT lpRect = NULL, LPCTSTR szString = NULL)
		{
		return(m_LayoutGroup.privAddGroup(VGROUP_LAYOUT, lpRect, szString));
		}

	CLayoutGroupObj *HGroup(LPCRECT lpRect = NULL, LPCTSTR szString = NULL)
		{
		return(m_LayoutGroup.privAddGroup(HGROUP_LAYOUT, lpRect, szString));
		}

	CLayoutGroupObj *AddVGrpCtrl(UINT id, long type = IS_A_GROUP_WINDOW, long lFlags = 0, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, VGROUP_LAYOUT, 0, type, lFlags, m_Color));
		}

	CLayoutGroupObj *AddHGrpCtrl(UINT id, long type = IS_A_GROUP_WINDOW, long lFlags = 0, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, HGROUP_LAYOUT, 0, type, lFlags, m_Color));
		}

	CLayoutGroupObj *AddVGrpTitleCtrl(UINT id, UINT wID, long flags = 0, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, VGROUP_LAYOUT, wID, 0, flags, m_Color));
		}

	CLayoutGroupObj *AddHGrpTitleCtrl(UINT id, UINT wID, long flags = 0, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, HGROUP_LAYOUT, wID, 0, flags, m_Color));
		}

	CLayoutGroupObj *AddVisibleVGroup(bool bVisible = true, LPCRECT lpRect = NULL, bool m_bRecalc = true)
		{
		return(m_LayoutGroup.privAddVisibleGroup(VGROUP_LAYOUT, bVisible, lpRect, m_bRecalc));
		}

	CLayoutGroupObj *AddVisibleHGroup(bool bVisible = true, LPCRECT lpRect = NULL, bool m_bRecalc = true)
		{
		return(m_LayoutGroup.privAddVisibleGroup(HGROUP_LAYOUT, bVisible, lpRect, m_bRecalc));
		}

	CLayoutGroupObj *AddLFVGroup(LPCRECT lpRect = NULL)
		{
		return(m_LayoutGroup.privAddLFGroup(VGROUP_LAYOUT, lpRect));
		}

	CLayoutGroupObj *AddLFHGroup(LPCRECT lpRect = NULL)
		{
		return(m_LayoutGroup.privAddLFGroup(HGROUP_LAYOUT, lpRect));
		}


	bool InitLFGroup(CLayoutGroupObj *pLFGrp)
		{
		return m_LayoutGroup.privInitLFGroup(pLFGrp);
		}

	CLayoutGroupObj *AddLine(long lFlags = 0, LPCTSTR szString = NULL, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddLine(lFlags, szString, m_Color));
		}

	CLayoutGroupObj *AddChild(UINT id, DWORD mode = 0, DWORD lPercent = 0, DWORD lFlags = 0, DWORD dwMaxSize = 0)
		{
		return(m_LayoutGroup.privAddChild(id, mode, lPercent, lFlags, dwMaxSize));
		}

	CLayoutGroupObj *AddChild(CWnd *pWnd, DWORD mode = 0, DWORD lPercent = 0, DWORD lFlags = 0, DWORD dwMaxSize = 0)
		{
		return(m_LayoutGroup.privAddChild(pWnd, mode, lPercent, lFlags, dwMaxSize));
		}

	CLayoutGroupObj *AddSpace(long space, long InitalSpace = 0)
		{
		return(m_LayoutGroup.privAddSpace(space, InitalSpace));
		}

	CLayoutGroupObj *AddSpreader(long xspace = 1, long yspace = 0, long mode = 0)
		{
		return(m_LayoutGroup.privAddSpreader(xspace, yspace, mode));
		}

	CLayoutGroupObj *AddSpreaderLike(CWnd *w, long mode = 0)
		{
		return m_LayoutGroup.privAddSpreaderLike(w, mode);
		}

	CLayoutGroupObj *AddSpreaderLike(UINT id, long mode = 0)
		{
		return m_LayoutGroup.privAddSpreaderLike(id, mode);
		}

	CLayoutGroupObj *AddSplitter(long lFirstPercent = 0, bool bRealTimeLayout = true, LPCTSTR m_Name = NULL, long lBackGroundColor = -1)
		{
		return(m_LayoutGroup.privAddSplitter(lFirstPercent, bRealTimeLayout, m_Name, lBackGroundColor));
		}

	bool IsNoTabCtrl()
		{
		return m_bNoTabCtrl;
		}

	bool IsModeLess()
		{
		return m_bModeless ? true : false;
		}

	bool IsBottomLabel()
		{
		return bool(m_lAdjust == LABEL_BOTTOM);
		}


	void EndLFGroup()
		{
		m_LayoutGroup.privEndLFGroup();
		}// muss nach InitLFGroup() aufgerufen werden

	void SetButtonHeight(UINT ids[])
		{
		sSetButtonHeight(this, ids);
		}

	void SetReSize(int bVert = -1, int bHori = -1)
		{
		m_LayoutGroup.SetReSize(bVert, bHori);
		}

	void SetDlgName(LPCTSTR szString)
		{
		m_LayoutGroup.SetDlgName(szString); m_strRegStore = szString;
		}

	void ShowVisibleGroup(CLayoutGroupObj *m_pGrp, bool bShow, bool bRefresh = false, BYTE bShrink = 0);
	void EndGroup(LPCRECT lpBorderRect = NULL);

	void SetAlign(long mode)
		{
		m_LayoutGroup.privSetAlign(mode);
		}

	void SetCalcExtra(long lWidth)
		{
		m_LayoutGroup.privSetCalcExtra(lWidth);
		}

	void HideHelpButton(), HideApplyButton(), HideTabControl(), SetModeLess();
	void LabelAdjust(long lAdjust);
	void AddPage(CPropertyPage *page);
	void SetBkgColor(COLORREF crBkh = -1);
	void DisableGLLEraseBackground(bool m_NoErase = false);
	void SetWizardButtons(DWORD dwFlags);

	LPCTSTR GetDlgName()
		{
		return m_LayoutGroup.GetDlgName();
		}

	int  GetGroupID()
		{
		return m_LayoutGroup.GetGroupID();
		}

	BOOL SetActivePage(int nPage);
	BOOL SetActivePage(CPropertyPage* pnPage);

	CSize GetMinSize();
	
	


	CString m_strRegStore;
	CWnd m_StatusBar;
	CSize m_StatusBarSize;
	CLayoutGroupObj *m_TabGroup;
	long GetTapHeight();
// Operationen
public:
	void SetSize(int id);
// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CPropertySheetLayout)
	public:
	virtual BOOL DestroyWindow();
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CPropertySheetLayout();
	CRect m_rcAktPage;
	// Generierte Nachrichtenzuordnungsfunktionen
protected:
	//{{AFX_MSG(CPropertySheetLayout)
	virtual BOOL OnInitDialog(BYTE m_bWizardModeFlags = 0);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	//afx_msg LRESULT OnPageResize(WPARAM, LPARAM);

//#C The following line was #ifdef'd - OnGetMinMaxInfo is not part of MFC
//#A Dirk Gaudian
//#D 18.06.2002
//#V 2.01
#ifndef UNDER_CE
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
#endif
	DECLARE_MESSAGE_MAP()

	bool AddTab(CWnd *w,long lSpread = GREEDY);

	long m_lSpread,iStatusBarHeight,m_lAdjust;
	CPoint m_DlgSize;
	CBrush m_BkGBrush;
	DWORD lpInitialGrow; // Prozentuale Vergrerung beim ersten(!) Aufruf
	bool m_bGripper,m_bHideHelp,m_bNoTabCtrl,_INIT, 
		m_IsThisNT; // Fix fr Windows98-Bug
};


/*********************************************************************/
/*********************************************************************/


class CPropertyPageLayout : public CPropertyPage
{
	DECLARE_DYNCREATE(CPropertyPageLayout)

// Konstruktion
public:
	CPropertyPageLayout();
	CPropertyPageLayout(UINT nIDTemplate, UINT nIDCaption = 0);
	CPropertyPageLayout(LPCTSTR lpszTemplateName, UINT nIDCaption = 0);
	~CPropertyPageLayout();
	CPropertySheetLayout *m_Sheet;


	CLayoutGroup m_LayoutGroup;

	CLayoutGroupObj *VGroup(LPCRECT lpRect = NULL, LPCTSTR szString = NULL)
		{
		return(m_LayoutGroup.privAddGroup(VGROUP_LAYOUT, lpRect, szString));
		}

	CLayoutGroupObj *HGroup(LPCRECT lpRect = NULL, LPCTSTR szString = NULL)
		{
		return(m_LayoutGroup.privAddGroup(HGROUP_LAYOUT, lpRect, szString));
		}

	CLayoutGroupObj *AddVGrpCtrl(UINT id, long type = IS_A_GROUP_WINDOW, long lFlags = 0, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, VGROUP_LAYOUT, 0, type, lFlags, m_Color));
		}

	CLayoutGroupObj *AddHGrpCtrl(UINT id, long type = IS_A_GROUP_WINDOW, long lFlags = 0, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, HGROUP_LAYOUT, 0, type, lFlags, m_Color));
		}

	CLayoutGroupObj *AddVGrpTitleCtrl(UINT id, UINT wID, long flags = 0, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, VGROUP_LAYOUT, wID, 0, flags, m_Color));
		}

	CLayoutGroupObj *AddHGrpTitleCtrl(UINT id, UINT wID, long flags = 0, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, HGROUP_LAYOUT, wID, 0, flags, m_Color));
		}

	CLayoutGroupObj *AddVisibleVGroup(bool bVisible = true, LPCRECT lpRect = NULL, bool m_bRecalc = true)
		{
		return(m_LayoutGroup.privAddVisibleGroup(VGROUP_LAYOUT, bVisible, lpRect, m_bRecalc));
		}

	CLayoutGroupObj *AddVisibleHGroup(bool bVisible = true, LPCRECT lpRect = NULL, bool m_bRecalc = true)
		{
		return(m_LayoutGroup.privAddVisibleGroup(HGROUP_LAYOUT, bVisible, lpRect, m_bRecalc));
		}

	CLayoutGroupObj *AddLFVGroup(LPCRECT lpRect = NULL)
		{
		return(m_LayoutGroup.privAddLFGroup(VGROUP_LAYOUT, lpRect));
		}

	CLayoutGroupObj *AddLFHGroup(LPCRECT lpRect = NULL)
		{
		return(m_LayoutGroup.privAddLFGroup(HGROUP_LAYOUT, lpRect));
		}


	void ShowVisibleGroup(CLayoutGroupObj *m_pGrp, bool bShow, bool bRefresh = false);
	
	void SetButtonHeight(UINT ids[])
		{
		sSetButtonHeight(this, ids);
		}
	
	void SetReSize(int bVert = -1, int bHori = -1)
		{
		m_LayoutGroup.SetReSize(bVert, bHori);
		}
	
	void SetDlgName(LPCTSTR szString)
		{
		m_LayoutGroup.SetDlgName(szString);
		}
	
	void EndGroup();
	
	void SetAlign(long mode)
		{
		m_LayoutGroup.privSetAlign(mode);
		}
	
	void SetCalcExtra(long lWidth)
		{
		m_LayoutGroup.privSetCalcExtra(lWidth);
		}
	
	void SetBkgColor(COLORREF crBkh = -1);
	void SetGroupBoxColor(COLORREF crColor = -1);
	void DisableGLLEraseBackground(bool m_NoErase = false);
	
	void EndLFGroup()
		{
		m_LayoutGroup.privEndLFGroup();
		}// muss nach InitLFGroup() aufgerufen werden

	LPCTSTR GetDlgName()
		{
		return m_LayoutGroup.GetDlgName();
		}

	bool InitLFGroup(CLayoutGroupObj *pLFGrp)
		{
		return m_LayoutGroup.privInitLFGroup(pLFGrp);
		}

	CLayoutGroupObj *AddLine(long lFlags = 0, LPCTSTR szString = NULL, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddLine(lFlags, szString, m_Color));
		}

	CLayoutGroupObj *AddChild(UINT id, DWORD mode = 0, DWORD lPercent = 0, DWORD lFlags = 0, DWORD dwMaxSize = 0)
		{
		return(m_LayoutGroup.privAddChild(id, mode, lPercent, lFlags, dwMaxSize));
		}

	CLayoutGroupObj *AddChild(CWnd *pWnd, DWORD mode = 0, DWORD lPercent = 0, DWORD lFlags = 0, DWORD dwMaxSize = 0)
		{
		return(m_LayoutGroup.privAddChild(pWnd, mode, lPercent, lFlags, dwMaxSize));
		}

	CLayoutGroupObj *AddSpace(long space, long InitalSpace = 0)
		{
		return(m_LayoutGroup.privAddSpace(space, InitalSpace));
		}

	CLayoutGroupObj *AddSpreader(long xspace = 1, long yspace = 0, long mode = 0)
		{
		return(m_LayoutGroup.privAddSpreader(xspace, yspace, mode));
		}

	CLayoutGroupObj *AddSpreaderLike(CWnd *w, long mode = 0)
		{
		return m_LayoutGroup.privAddSpreaderLike(w, mode);
		}

	CLayoutGroupObj *AddSpreaderLike(UINT id, long mode = 0)
		{
		return m_LayoutGroup.privAddSpreaderLike(id, mode);
		}

	CLayoutGroupObj  *AddSplitter(long lFirstPercent = 0, bool bRealTimeLayout = true, LPCTSTR m_Name = NULL, long lBackGroundColor = -1)
		{
		return(m_LayoutGroup.privAddSplitter(lFirstPercent, bRealTimeLayout, m_Name, lBackGroundColor));
		}

	int  GetGroupID()
		{
		return m_LayoutGroup.GetGroupID();
		}

	CSize GetMinSize();

	bool m_IsThisNT; // Fix fr Windows98-Bug

// Dialogfelddaten
	//{{AFX_DATA(CPropertyPageLayout)
		// HINWEIS - Der Klassen-Assistent fgt hier Datenelemente ein.
		//    Innerhalb dieser generierten Quellcodeabschnitte NICHTS BEARBEITEN!
	//}}AFX_DATA


// berschreibungen
	// Der Klassen-Assistent generiert virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CPropertyPageLayout)
	public:
	virtual BOOL OnSetActive();
#ifndef UNDER_CE
// Because the current version of Windows CE does not support wizards, MFC for Windows CE does not support the OnWizardBack, OnWizardNext, or OnWizardFinish methods of the CPropertyPage class.
	virtual LRESULT OnWizardNext();
	virtual LRESULT OnWizardBack();
#endif
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL


// Implementierung
protected:
	// Generierte Nachrichtenzuordnungsfunktionen
	//{{AFX_MSG(CPropertyPageLayout)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
public:
	virtual afx_msg LRESULT OnPageResize(WPARAM, LPARAM);
protected:
	DECLARE_MESSAGE_MAP()
	CPoint m_DlgSize;
	CBrush m_BkGBrush;
};

/*********************************************************************/
/*********************************************************************/

class CFormViewLayout : public CFormView
{
protected:
	CFormViewLayout(UINT nID, LPCTSTR strName = NULL);   // standard constructor
	DECLARE_DYNCREATE(CFormViewLayout)

// Formulardaten
public:
	//{{AFX_DATA(CFormViewLayout)
		// HINWEIS: Der Klassen-Assistent fgt hier Datenelemente ein
	//}}AFX_DATA

// Attribute
public:
	void ResizeParentToFit(BOOL bShrinkOnly=true);
// Operationen
public:

// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CFormViewLayout)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

public:

	CLayoutGroupObj *VGroup(LPCRECT lpRect = NULL, LPCTSTR szString = NULL)
		{
		return(m_LayoutGroup.privAddGroup(VGROUP_LAYOUT, lpRect, szString));
		}

	CLayoutGroupObj *HGroup(LPCRECT lpRect = NULL, LPCTSTR szString = NULL)
		{
		return(m_LayoutGroup.privAddGroup(HGROUP_LAYOUT, lpRect, szString));
		}

	CLayoutGroupObj *AddVGrpCtrl(UINT id, long type = IS_A_GROUP_WINDOW, long lFlags = 0, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, VGROUP_LAYOUT, 0, type, lFlags, m_Color));
		}

	CLayoutGroupObj *AddHGrpCtrl(UINT id, long type = IS_A_GROUP_WINDOW, long lFlags = 0, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, HGROUP_LAYOUT, 0, type, lFlags, m_Color));
		}

	CLayoutGroupObj *AddVGrpTitleCtrl(UINT id, UINT wID, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, VGROUP_LAYOUT, wID, 0, 0, m_Color));
		}

	CLayoutGroupObj *AddHGrpTitleCtrl(UINT id, UINT wID, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddGrpCtrl(id, HGROUP_LAYOUT, wID, 0, 0, m_Color));
		}

	CLayoutGroupObj *AddVisibleVGroup(bool bVisible = true, LPCRECT lpRect = NULL, bool m_bRecalc = true)
		{
		return(m_LayoutGroup.privAddVisibleGroup(VGROUP_LAYOUT, bVisible, lpRect, m_bRecalc));
		}

	CLayoutGroupObj *AddVisibleHGroup(bool bVisible = true, LPCRECT lpRect = NULL, bool m_bRecalc = true)
		{
		return(m_LayoutGroup.privAddVisibleGroup(HGROUP_LAYOUT, bVisible, lpRect, m_bRecalc));
		}

	CLayoutGroupObj *AddLFVGroup(LPCRECT lpRect = NULL)
		{
		return(m_LayoutGroup.privAddLFGroup(VGROUP_LAYOUT, lpRect));
		}

	CLayoutGroupObj *AddLFHGroup(LPCRECT lpRect = NULL)
		{
		return(m_LayoutGroup.privAddLFGroup(HGROUP_LAYOUT, lpRect));
		}


	void ShowVisibleGroup(CLayoutGroupObj *m_pGrp, bool bShow, bool bRefresh = false);

	void SetButtonHeight(UINT ids[])
		{
		sSetButtonHeight(this, ids);
		}

	void SetReSize(int bVert = -1, int bHori = -1)
		{
		m_LayoutGroup.SetReSize(bVert, bHori);
		}

	void SetDlgName(LPCTSTR szString)
		{
		m_LayoutGroup.SetDlgName(szString); m_strRegStore = szString;
		}

	void EndGroup();

	void SetAlign(long mode)
		{
		m_LayoutGroup.privSetAlign(mode);
		}

	void SetBkgColor(COLORREF crBkh = -1);
	void SetGroupBoxColor(COLORREF crColor = -1);
	void DisableGLLEraseBackground(bool m_NoErase = false);

	void EndLFGroup()
		{
		m_LayoutGroup.privEndLFGroup();
		}// muss nach InitLFGroup() aufgerufen werden

	bool InitLFGroup(CLayoutGroupObj *pLFGrp)
		{
		return m_LayoutGroup.privInitLFGroup(pLFGrp);
		}

	CLayoutGroupObj *AddLine(long lFlags = 0, LPCTSTR szString = NULL, long m_Color = -1)
		{
		return(m_LayoutGroup.privAddLine(lFlags, szString, m_Color));
		}

	CLayoutGroupObj *AddChild(UINT id, long mode = 0, long lPercent = 0, long lFlags = 0, DWORD dwMaxSize = 0)
		{
		return(m_LayoutGroup.privAddChild(id, mode, lPercent, lFlags, dwMaxSize));
		}

	CLayoutGroupObj *AddChild(CWnd *pWnd, long mode = 0, long lPercent = 0, long lFlags = 0, DWORD dwMaxSize = 0)
		{
		return(m_LayoutGroup.privAddChild(pWnd, mode, lPercent, lFlags, dwMaxSize));
		}

	CLayoutGroupObj *AddSpace(long space, long InitalSpace = 0)
		{
		return(m_LayoutGroup.privAddSpace(space, InitalSpace));
		}

	CLayoutGroupObj *AddSpreader(long xspace = 1, long yspace = 0, long mode = 0)
		{
		return(m_LayoutGroup.privAddSpreader(xspace, yspace, mode));
		}

	CLayoutGroupObj *AddSpreaderLike(CWnd *w, long mode = 0)
		{
		return m_LayoutGroup.privAddSpreaderLike(w, mode);
		}

	CLayoutGroupObj *AddSpreaderLike(UINT id, long mode = 0)
		{
		return m_LayoutGroup.privAddSpreaderLike(id, mode);
		}

	CLayoutGroupObj *AddSplitter(long lFirstPercent = 0, bool bRealTimeLayout = true, LPCTSTR m_Name = NULL, long lBackGroundColor = -1)
		{
		return(m_LayoutGroup.privAddSplitter(lFirstPercent, bRealTimeLayout, m_Name, lBackGroundColor));
		}

	LPCTSTR GetDlgName()
		{
		return m_LayoutGroup.GetDlgName();
		}

	int  GetGroupID()
		{
		return m_LayoutGroup.GetGroupID();
		}

	CSize GetMinSize();

//privat
	CString m_strRegStore;
	CLayoutGroup m_LayoutGroup;

	CRect initRect;
// Implementierung
protected:
	virtual ~CFormViewLayout();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	CBrush m_BkGBrush;
	// Generierte Nachrichtenzuordnungsfunktionen
	//{{AFX_MSG(CFormViewLayout)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/**********************************************************************/

class CFormViewBox : public CStatic
{
// Konstruktion
public:
	DECLARE_DYNAMIC(CFormViewBox)
	CFormViewBox();
	BOOL SetView(CRuntimeClass *pViewClass, CDocument* pDoc/*=NULL*/);

	CView *GetView()
		{
		return m_pTheView;
		};

	void SetSimpleRefresh()
		{
		m_bSimpleRefresh = true;
		}
// Attribute
public:
// Operationen
public:

// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CFormViewBox)
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CFormViewBox();

	// Generierte Nachrichtenzuordnungsfunktionen
protected:
	//{{AFX_MSG(CFormViewBox)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnEnable(BOOL bEnable);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	CView* m_pTheView;
	bool m_bSimpleRefresh;
};

/*********************************************************************/


#endif // !defined(AFX_LAYOUTGROUP_H__34051C7A_F99E_4517_9916_7137261DFEEE__INCLUDED_)

/////////////////////////////////////////////////////////////////////////////
