// LayoutGroup.cpp: Implementierung der Klasse CLayoutGroup.
//
// GUILayoutLib V2
//////////////////////////////////////////////////////////////////////


/**********************************************************************/


#include "stdafx.h"
#include "Afxpriv.h"


//ToDo: Pfad ggf. anpassen!
#ifdef _GLL_DEMO_
#include "LayoutGroup.h"
#else
#include <Classes/GUILayoutLib/LayoutGroup.h>
#endif 

#include  <math.h>


#define SM_XVIRTUALSCREEN       76
#define SM_YVIRTUALSCREEN       77
#define SM_CXVIRTUALSCREEN      78
#define SM_CYVIRTUALSCREEN      79
#define SM_CMONITORS            80
#define SM_SAMEDISPLAYFORMAT    81
#define xPRIMARY_MONITOR ((HMONITOR)0x12340042)
#define MONITOR_DEFAULTTONULL       0x00000000
#define MONITOR_DEFAULTTOPRIMARY    0x00000001
#define MONITOR_DEFAULTTONEAREST    0x00000002

#define MONITORINFOF_PRIMARY        0x00000001


#define GLLGetSizeWidth(x) LOWORD(x)
#define GLLGetSizeHeight(x) HIWORD(x)



//#C Obviously, some rarely used stuff was lost in CE. We try defining it in an extra header.
//#A Dirk Gaudian
//#D 18.06.2002
//#V 2.01
#ifdef UNDER_CE
#include "forgotten.h"
#endif


/**********************************************************************/

#define GLLASSERT(x) {ASSERT(x);if(x == NULL)return;}
#define GLLASSERT2(x,y) {ASSERT(x);VERIFY(y);if(x == NULL)return;if(y == NULL)return;}
#define GLLASSERT_T(x) {ASSERT(x);if(x == NULL)return true;}
#define GLLASSERT_F(x) {ASSERT(x);if(x == NULL)return false;}
#define GLLASSERT_N(x) {ASSERT(x);if(x == NULL)return NULL;}

/**********************************************************************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CGroupStatic, CButton)
IMPLEMENT_DYNAMIC(CPropertySheetLayout, CPropertySheet)
IMPLEMENT_DYNCREATE(CPropertyPageLayout, CPropertyPage)
IMPLEMENT_DYNAMIC(CDialogLayout, CDialog)
IMPLEMENT_DYNAMIC(CFormViewLayout, CFormView)
IMPLEMENT_DYNAMIC(CFormViewBox, CStatic)

static UINT auIDStatusBar[] = 
{ 
  ID_SEPARATOR
};


const UINT WM_PROPPAGE_SIZED_SHEET = RegisterWindowMessage(_T("WM_PROPPAGE_SIZED_SHEET"));
const UINT WM_VISIBLEGROUP_RESIZED = RegisterWindowMessage(_T("WM_VISIBLEGROUP_RESIZED")); //V2.2
const UINT WM_VIEW_SCROLL_PARAM = RegisterWindowMessage(_T("WM_VIEW_SCROLL_PARAM"));
const UINT WM_GET_LINE_BKGCOLOR_ = RegisterWindowMessage(_T("WM_GET_LINE_BKGCOLOR_"));
const UINT WM_OPEN_LAZY_FETCHING_GROUP = RegisterWindowMessage(_T("WM_OPEN_LAZY_FETCHING_GROUP")); // v2.7


#define GRP_CTRL_FIX 16


static UINT
	n1 = 0,
	n2 = 0,
	n3 = 0,
	n4 = 0,
	n5 = 0,
	n6 = 0,
	n8 = 0,
	n10 = 0,
	n12 = 0,
	n20 = 0,
	n21 = 0;

/**********************************************************************/

UINT ScaleInit()
{
	n1 = GLL_GetDPI()->ScaleX(1),
	n2 = GLL_GetDPI()->ScaleX(2),
	n3 = GLL_GetDPI()->ScaleX(3),
	n4 = GLL_GetDPI()->ScaleX(4),
	n5 = GLL_GetDPI()->ScaleX(5),
	n6 = GLL_GetDPI()->ScaleX(6),
	n8 = GLL_GetDPI()->ScaleX(8),
	n10 = GLL_GetDPI()->ScaleX(10),
	n12 = GLL_GetDPI()->ScaleX(12),
	n20 = GLL_GetDPI()->ScaleX(20),
	n21 = GLL_GetDPI()->ScaleX(21);
	return n1;
}

/**********************************************************************/

static UINT scall = ScaleInit();

/*********************************************************************/


/************************************************************************
* Danke Microsoft, ist eine super Idee ohne richtiges Manifest GetVersionEx
* falsche Werte liefern zu lassen.
* x und 90 GLL_CompareWindowsVersion-Aufrufe sind ja auch viel schneller als
* if(osvi->dwMajorVersion >= 6L && osvi->dwMinorVersion >= 2)
* <kopfschttel>
************************************************************************/

#define GLLVER_SET_CONDITION(_m_,_t_,_c_)  ((_m_)=pfnGLLVerSetConditionMask((_m_),(_t_),(_c_)))
typedef ULONGLONG (WINAPI* GLLPFNVerSetConditionMask)(ULONGLONG dwlConditionMask, DWORD dwTypeBitMask, BYTE dwConditionMask);
typedef BOOL (WINAPI* GLLPFNVerifyVersionInfo)(LPOSVERSIONINFOEX lpVersionInfo, DWORD dwTypeMask, DWORDLONG dwlConditionMask);
static GLLPFNVerSetConditionMask pfnGLLVerSetConditionMask = NULL;
static GLLPFNVerifyVersionInfo pfnGLLVerifyVersionInfo = NULL;

/**********************************************************************/

bool GLL_CompareWindowsVersion(DWORD dwMajorVersion, DWORD dwMinorVersion)
{
	if(pfnGLLVerifyVersionInfo == NULL || pfnGLLVerSetConditionMask == NULL)
	return false;

	OSVERSIONINFOEX ver;
	DWORDLONG dwlConditionMask = 0;

	ZeroMemory(&ver, sizeof(OSVERSIONINFOEX));
	ver.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	ver.dwMajorVersion = dwMajorVersion;
	ver.dwMinorVersion = dwMinorVersion;

    GLLVER_SET_CONDITION(dwlConditionMask, VER_MAJORVERSION, VER_EQUAL);
    GLLVER_SET_CONDITION(dwlConditionMask, VER_MINORVERSION, VER_EQUAL);

	return pfnGLLVerifyVersionInfo((LPOSVERSIONINFOEX) &ver, VER_MAJORVERSION | VER_MINORVERSION, dwlConditionMask) ? true : false;
}

/**********************************************************************/

#include <WINDOWSX.H>
#pragma comment(lib, "Version.lib") //GlobalAllocPtr
static DWORD GetOSVersion(LPTSTR szFile/*, DWORD& dwWindowsBuild*/)
{
	DWORD dwUseless = 0;
	UINT iBufSize = 0;
	VS_FIXEDFILEINFO* lpFFI = NULL;
	DWORD dwVersion;
	DWORD dwVer1 = 0, dwVer2 = 0;
	LPVOID lpVI = NULL;

	DWORD dwLen = GetFileVersionInfoSize(szFile, &dwUseless);
	if(dwLen == 0)
		return 0;
	
	lpVI = GlobalAllocPtr(GHND, dwLen);
	GetFileVersionInfo(szFile, NULL, dwLen, lpVI);
	VerQueryValue(lpVI, __TEXT("\\"), reinterpret_cast<LPVOID*>(&lpFFI), &iBufSize);
	
	dwVer1 = lpFFI->dwFileVersionMS;
	dwVer2 = lpFFI->dwFileVersionLS;
	//dwWindowsBuild = HIWORD(dwVer2);
	GlobalFreePtr(lpVI);
	dwVersion = HIWORD(dwVer1) * 10 + LOWORD(dwVer1);
	return dwVersion;
}

/**********************************************************************/
#pragma warning (disable:4996)
int GLL_GetWindowsVers()
{
	int m_bIsNT = 0;
	DWORD winVer;
	OSVERSIONINFO *osvi;

	m_bIsNT = false;
	winVer = GetVersion();
	HMODULE hKernel32 = GetModuleHandle(_T("KERNEL32.DLL"));

	if(hKernel32)
		{
		pfnGLLVerSetConditionMask = (GLLPFNVerSetConditionMask) GetProcAddress(hKernel32, "VerSetConditionMask");
		pfnGLLVerifyVersionInfo = (GLLPFNVerifyVersionInfo) GetProcAddress(hKernel32, "VerifyVersionInfoA");
		}

	if(winVer < 0x80000000)
		{
		osvi = (OSVERSIONINFO *) malloc(sizeof(OSVERSIONINFO));
		if(osvi != NULL)
			{
			memset(osvi, 0, sizeof(OSVERSIONINFO));
			osvi->dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
			GetVersionEx(osvi);

			if(osvi->dwMajorVersion == 4L)
				m_bIsNT = 40;

			else if(osvi->dwMajorVersion == 5L && osvi->dwMinorVersion == 0) // Window2000
				m_bIsNT = 50;
			
			else if(osvi->dwMajorVersion == 5L && osvi->dwMinorVersion >= 1) // XP/2003
				m_bIsNT = 51;
			
			else if(osvi->dwMajorVersion == 6L && osvi->dwMinorVersion == 0) // Vista
				m_bIsNT = 60;
			
			else if(osvi->dwMajorVersion == 6L && osvi->dwMinorVersion == 1) // Windows 7 
				m_bIsNT = 61;
			
			else if(osvi->dwMajorVersion == 6L && osvi->dwMinorVersion >= 2) // Windows 8
				{
				m_bIsNT = 62;
				
				if(GLL_CompareWindowsVersion(6, 3))
					m_bIsNT = 63;
				else if(GLL_CompareWindowsVersion(6, 4)) // ??
					m_bIsNT = 100;

				if(m_bIsNT == 62) // hm echt, oder altes Manifest?
					{
					TCHAR szFileName[_MAX_PATH + 1] = { 0 };
					
					if(GetSystemDirectory(szFileName, _MAX_PATH))
						{
						_tcsncat(szFileName, _T("\\HAL.DLL"), _MAX_PATH);
						DWORD dwVersion = GetOSVersion(szFileName);
						if(dwVersion >= 100)
							m_bIsNT = dwVersion;
						}
					}
				}
			else if(osvi->dwMajorVersion == 10L)
				{
				m_bIsNT = 100;
				}

			free(osvi);
			}
		}

	pfnGLLVerSetConditionMask = NULL;
	pfnGLLVerifyVersionInfo = NULL;
	return m_bIsNT;
}
#pragma warning(default: 4996)
/*********************************************************************/

void SetGroupBorder(CLayoutGroupObj *pGrp, LONG left, LONG top, LONG right, LONG bottom)
{
	ASSERT(pGrp);
	
	if(pGrp)
		pGrp->rcBorder.SetRect(GLL_GetDPI()->ScaleX(left), GLL_GetDPI()->ScaleY(top), GLL_GetDPI()->ScaleX(right), GLL_GetDPI()->ScaleY(bottom));
}

/*********************************************************************/

void SetGroupBorder(CLayoutGroupObj *pGrp, LPCRECT lpRect)
{
	ASSERT(pGrp);
	ASSERT(lpRect);
	
	if(pGrp && lpRect)
		SetGroupBorder(pGrp, lpRect->left, lpRect->top, lpRect->right, lpRect->bottom);
}

/*********************************************************************/

#define IncOrDec(a,b) if(a>=0){b += a;} else {b -= a;}

void AddGroupBorder(CLayoutGroupObj *pGrp, LONG left, LONG top, LONG right, LONG bottom)
{
	ASSERT(pGrp);
	
	if(pGrp)
		{
		left = GLL_GetDPI()->ScaleX(left);
		top = GLL_GetDPI()->ScaleY(top);
		right = GLL_GetDPI()->ScaleX(right);
		bottom = GLL_GetDPI()->ScaleY(bottom);

		IncOrDec(left, pGrp->rcBorder.left);
		IncOrDec(top, pGrp->rcBorder.top);
		IncOrDec(right, pGrp->rcBorder.right);
		IncOrDec(bottom, pGrp->rcBorder.bottom);
		}
}

/*********************************************************************/

/************************************************************************
* Der Nachteil, wenn man m_RootGroup "protected"
************************************************************************/
void CLayoutGroup::SetRootBorderSite(UINT nSite, LONG nSpace, bool m_bScale)
{
	LONG nBorder = 0;

	if(nSpace)
		{
		if(m_bScale)
			nSpace = GLL_GetDPI()->ScaleX(nSpace);

		switch(nSite)
			{
			case _GLBS_LEFT:
				nBorder = m_RootGroup.rcBorder.left;
				break;
			case _GLBS_TOP:
				nBorder = m_RootGroup.rcBorder.top;
				break;
			case _GLBS_RIGHT:
				nBorder = m_RootGroup.rcBorder.right;
				break;
			case _GLBS_BOTTOM:
				nBorder = m_RootGroup.rcBorder.bottom;
				break;
			}

		IncOrDec(nSpace, nBorder);
		}

	switch(nSite)
		{
		case _GLBS_LEFT:
			m_RootGroup.rcBorder.left = nBorder;
			break;
		case _GLBS_TOP:
			m_RootGroup.rcBorder.top = nBorder;
			break;
		case _GLBS_RIGHT:
			m_RootGroup.rcBorder.right = nBorder;
			break;
		case _GLBS_BOTTOM:
			m_RootGroup.rcBorder.bottom = nBorder;
			break;
		}
}

/**********************************************************************/

void AddGroupBorder(CLayoutGroupObj *pGrp, LPCRECT lpRect)
{
	ASSERT(pGrp);
	ASSERT(lpRect);
	
	if(pGrp && lpRect)
		SetGroupBorder(pGrp, lpRect->left, lpRect->top, lpRect->right, lpRect->bottom);
}

/*********************************************************************/

COLORREF GLL_LightenColor(COLORREF col, double factor)
{
	if(factor > 0.0 && factor <= 1.0)
		{
		BYTE red, green, blue, lightred, lightgreen, lightblue;
		red = GetRValue(col);
		green = GetGValue(col);
		blue = GetBValue(col);
		lightred = (BYTE) ((factor*(255 - red)) + red);
		lightgreen = (BYTE) ((factor*(255 - green)) + green);
		lightblue = (BYTE) ((factor*(255 - blue)) + blue);
		col = RGB(lightred, lightgreen, lightblue);
		}
	return(col);
}

/**********************************************************************/
/*
	START: MFC-Gednz unter anderem Namen um Konflikte zu vermeiden

	INFO:
	Achtung! Dies ist Code der MFC(4.x) und unterliegt dem Copyright von Microsoft.
	Es wurde der Name der Klassen angepasst, damit es keine Kollisionen gibt.
*/
class CGUILayoutLibMonitor : public CObject
{
protected:
	DECLARE_HANDLE(HMONITOR);


	typedef struct tagMONITORINFO
		{
		DWORD   cbSize;
		RECT    rcMonitor;
		RECT    rcWork;
		DWORD   dwFlags;
		} MONITORINFO, *LPMONITORINFO;
	

#ifdef __cplusplus
typedef struct tagMONITORINFOEXA : public tagMONITORINFO
{
	CHAR        szDevice[CCHDEVICENAME];
} MONITORINFOEXA, *LPMONITORINFOEXA;
typedef struct tagMONITORINFOEXW : public tagMONITORINFO
{
	WCHAR       szDevice[CCHDEVICENAME];
} MONITORINFOEXW, *LPMONITORINFOEXW;
#ifdef UNICODE
	typedef MONITORINFOEXW MONITORINFOEX;
	typedef LPMONITORINFOEXW LPMONITORINFOEX;
#else
	typedef MONITORINFOEXA MONITORINFOEX;
	typedef LPMONITORINFOEXA LPMONITORINFOEX;
#endif // UNICODE
#else // ndef __cplusplus
typedef struct tagMONITORINFOEXA
{
	MONITORINFO;
	CHAR        szDevice[CCHDEVICENAME];
} MONITORINFOEXA, *LPMONITORINFOEXA;
typedef struct tagMONITORINFOEXW
{
	MONITORINFO;
	WCHAR       szDevice[CCHDEVICENAME];
} MONITORINFOEXW, *LPMONITORINFOEXW;
#ifdef UNICODE
	typedef MONITORINFOEXW MONITORINFOEX;
	typedef LPMONITORINFOEXW LPMONITORINFOEX;
#else
	typedef MONITORINFOEXA MONITORINFOEX;
	typedef LPMONITORINFOEXA LPMONITORINFOEX;
#endif // UNICODE
#endif

enum  {
    MDT_EFFECTIVE_DPI = 0,
    MDT_ANGULAR_DPI = 1,
    MDT_RAW_DPI = 2,
    MDT_DEFAULT = MDT_EFFECTIVE_DPI
};

public:
//construction destruction
	CGUILayoutLibMonitor();
	virtual ~CGUILayoutLibMonitor();
	typedef int      (WINAPI* PFNGetSystemMetrics)(int);
	typedef HMONITOR (WINAPI* PFNMonitorFromWindow)(HWND, DWORD);
	typedef HMONITOR (WINAPI* PFNMonitorFromRect)(LPCRECT, DWORD);
	typedef HMONITOR (WINAPI* PFNMonitorFromPoint)(POINT, DWORD);
	typedef BOOL     (WINAPI* PFNGetMonitorInfo)(HMONITOR, LPMONITORINFO);
	typedef HRESULT  (WINAPI* PFNGetDpiForMonitor)(HMONITOR hmonitor, DWORD dpiType, UINT *dpiX, UINT *dpiY);

	
	CRect GetWorkArea()
		{
		POINT point;
		::GetCursorPos(&point);

		return GetWorkArea(point);
		}
	CRect GetWorkArea(HWND hWnd)
		{
		return GetWorkArea(InitMultipleMonitorStubs() ? m_pfnMonitorFromWindow(hWnd, 0) : 0);
		}
	CRect GetWorkArea(POINT ptScreenCoords)
		{
		return GetWorkArea(InitMultipleMonitorStubs() ? m_pfnMonitorFromPoint(ptScreenCoords, 0) : 0);
		}
	CRect GetWorkArea(LPCRECT lprcScreenCoords)
		{
		return GetWorkArea(InitMultipleMonitorStubs() ? m_pfnMonitorFromRect(lprcScreenCoords, 0) : 0);
		}

	BOOL GetMonitorInfo(HANDLE hMonitor, void* lpMInfo)
		{
		LPMONITORINFO lpMI = (LPMONITORINFO) lpMInfo;
		HMONITOR hm = (HMONITOR) hMonitor;
		if(m_pfnGetMonitorInfo && hm && lpMI)
			return m_pfnGetMonitorInfo(hm, lpMI);
		return false;
		}

	HANDLE MonitorFromRect(LPCRECT lprect, DWORD dwFlags)
		{
		if(m_pfnMonitorFromRect == NULL)
			return NULL;
		return (HANDLE) m_pfnMonitorFromRect(lprect, dwFlags);
		}
	
	HANDLE MonitorFromPoint(POINT pt, DWORD dwFlags)
		{
		if(m_pfnMonitorFromPoint == NULL)
			return NULL;
		return (HANDLE) m_pfnMonitorFromPoint(pt, dwFlags);
		}

	void GetMonitorDPI(HWND hWnd, UINT* dpiX, UINT* dpiY)
		{
		InitMultipleMonitorStubs();
		if(m_pfnGetDpiForMonitor && hWnd)
			{
			m_pfnGetDpiForMonitor(m_pfnMonitorFromWindow(hWnd, MONITOR_DEFAULTTONEAREST), MDT_DEFAULT, dpiX, dpiY);
			}
		}

private:
	BOOL InitMultipleMonitorStubs();

	CRect GetWorkArea(HMONITOR hMonitor)
		{
		if(hMonitor && m_pfnGetMonitorInfo)
			{
			ASSERT(sizeof(MONITORINFO) == 40);

			MONITORINFO info;
			info.cbSize = sizeof(MONITORINFO);

			if (m_pfnGetMonitorInfo(hMonitor, (MONITORINFO*)&info))
				return info.rcWork;
			}

		RECT rcWork = {0};
		::SystemParametersInfo(SPI_GETWORKAREA, NULL, &rcWork, 0);
		return rcWork;
		}

	HMONITOR m_hMonitor;
	PFNGetSystemMetrics m_pfnGetSystemMetrics;
	PFNMonitorFromWindow m_pfnMonitorFromWindow;
	PFNMonitorFromRect m_pfnMonitorFromRect;
	PFNMonitorFromPoint m_pfnMonitorFromPoint;
	PFNGetMonitorInfo m_pfnGetMonitorInfo;
	PFNGetDpiForMonitor m_pfnGetDpiForMonitor;
	HMODULE hShcore, hUser32;
	BOOL m_fMultiMonInitDone;
};

/*
	ENDE: MFC-Gednz unter anderem Namen um Konflikte zu vermeiden
*/

/**********************************************************************/

CGUILayoutLibMonitor m_GUILayoutLibMonitor;

CGLLHiDpi::CGLLHiDpi()
	: m_bInitialized(FALSE), 
	m_idpiX(CGLLHiDpi::m_iDefaultDpi), 
	m_idpiY(CGLLHiDpi::m_iDefaultDpi)
{
}

/**********************************************************************/

void CGLLHiDpi::Invalidate()
{
	m_bInitialized = FALSE;
	ScaleInit();
}

/**********************************************************************/
int CGLLHiDpi::m_iDefaultDpi = 96;

AFX_INLINE void CGLLHiDpi::_Init()
{
#ifdef _GLL_AUTO_SCALE_
	if (m_bInitialized == FALSE)
		{
		HDC hdc = ::GetDC(NULL);

		if (hdc)
			{
			m_idpiX = GetDeviceCaps(hdc, LOGPIXELSX);
			m_idpiY = GetDeviceCaps(hdc, LOGPIXELSY);
			ReleaseDC(NULL, hdc);
			}

		HWND hWnd = NULL;
		if(AfxGetMainWnd())
			hWnd = AfxGetMainWnd()->GetSafeHwnd();

		m_GUILayoutLibMonitor.GetMonitorDPI(hWnd, (UINT*)&m_idpiX, (UINT*)&m_idpiY);
		m_bInitialized = TRUE;
		}
#endif
}

/**********************************************************************/

BOOL GLL_GetMonitorInfo(HANDLE hMonitor, void* lpMInfo)
{
	return m_GUILayoutLibMonitor.GetMonitorInfo(hMonitor, lpMInfo);
}

/**********************************************************************/

HANDLE GLL_MonitorFromRect(LPCRECT lprect, DWORD dwFlags)
{
	return m_GUILayoutLibMonitor.MonitorFromRect(lprect, dwFlags);
}

/**********************************************************************/

HANDLE GLL_MonitorFromPoint(POINT pt, DWORD dwFlags)
{
	return m_GUILayoutLibMonitor.MonitorFromPoint(pt, dwFlags);
}
/**********************************************************************/

int CGLLHiDpi::GetDPIX()
{
	_Init(); 
	return m_idpiX;
}

/**********************************************************************/

int CGLLHiDpi::GetDPIY()
{
	_Init(); 
	return m_idpiY;
}

/**********************************************************************/

int CGLLHiDpi::ScaleX(int x, int iDpiScaleAbove)
{
#ifdef _GLL_AUTO_SCALE_
	if(x == 0)
		return x;
	_Init();
	return (m_idpiX > iDpiScaleAbove) ? MulDiv(x, m_idpiX, CGLLHiDpi::m_iDefaultDpi) : x;
#else
	UNUSED(iDpiScaleAbove);
	return x;
#endif
}

/**********************************************************************/

int CGLLHiDpi::ScaleY(int y, int iDpiScaleAbove)
{
#ifdef _GLL_AUTO_SCALE_
	if(y == 0)
		return y;
	_Init();
	return (m_idpiY > iDpiScaleAbove) ? MulDiv(y, m_idpiY, CGLLHiDpi::m_iDefaultDpi) : y;
#else
	UNUSED(iDpiScaleAbove);
	return y;
#endif
}

/**********************************************************************/

void CGLLHiDpi::ScaleRect(PRECTL pRect)
{
#ifdef _GLL_AUTO_SCALE_
	pRect->left = ScaleX(pRect->left);
	pRect->right = ScaleX(pRect->right);
	pRect->top = ScaleY(pRect->top);
	pRect->bottom = ScaleY(pRect->bottom);
#else
	UNUSED(pRect);
#endif
}

/**********************************************************************/

CGLLHiDpi* GLL_GetDPI()
{
	static CGLLHiDpi s_instance;
	return &s_instance;
}

/**********************************************************************/

CRect AKGetWorkArea(LPCRECT rc)
{
	return m_GUILayoutLibMonitor.GetWorkArea(rc);
}

/**********************************************************************/

COLORREF CLayoutGroup::GetDlgBKColor()
{
	if(m_crBackGrdColor == -1)
		return ::GetSysColor(COLOR_BTNFACE);
	return m_crBackGrdColor;
}

/**********************************************************************/

COLORREF CLayoutGroup::GetGroupBoxColor()
{
	return m_crGroupBoxBorderColor;
}

/**********************************************************************/

int AKGetWindowWidth(CWnd *m_pWnd)
{
	CRect rcWnd(0, 0, 0, 0);
	GLLASSERT_F(m_pWnd);
	m_pWnd->GetWindowRect(rcWnd);
	return(rcWnd.Width());
}

/*********************************************************************/

int AKGetWindowHeight(CWnd *m_pWnd)
{
	CRect rcWnd(0, 0, 0, 0);
	GLLASSERT_F(m_pWnd);
	m_pWnd->GetWindowRect(rcWnd);
	return(rcWnd.Height());
}

/*********************************************************************/

int AKGetWindowWidth(CWnd *m_pWnd,UINT ID)
{
	GLLASSERT_F(m_pWnd);
	return AKGetWindowWidth(m_pWnd->GetDlgItem(ID));
}

/**********************************************************************/

int AKGetWindowHeight(CWnd *m_pWnd,UINT ID)
{
	GLLASSERT_F(m_pWnd);
	return AKGetWindowHeight(m_pWnd->GetDlgItem(ID));
}
/*********************************************************************/

void AKSetWindowWidth(CWnd *m_pWnd, long m_lWidth)
{
	CRect rcWnd(0, 0, 0, 0);
	GLLASSERT(m_pWnd);

	m_pWnd->GetWindowRect(rcWnd);
	rcWnd.right = rcWnd.left + m_lWidth;
	m_pWnd->MoveWindow(rcWnd, false);
}

/*********************************************************************/

void AKSetWindowHeight(CWnd *m_pWnd, long m_lHeight)
{
	CRect rcWnd(0, 0, 0, 0);
	GLLASSERT(m_pWnd);

	m_pWnd->GetWindowRect(rcWnd);
	rcWnd.bottom = rcWnd.top + m_lHeight;
	m_pWnd->MoveWindow(rcWnd, false);
}

/*********************************************************************/

void AKSetWindowWidth(CWnd *m_pWnd,UINT ID,long m_lWidth)
{
	GLLASSERT(m_pWnd); 
	AKSetWindowWidth(m_pWnd->GetDlgItem(ID),m_lWidth);
}

/**********************************************************************/

void AKSetWindowHeight(CWnd *m_pWnd,UINT ID,long m_lHeight)
{
	GLLASSERT(m_pWnd);
	AKSetWindowHeight(m_pWnd->GetDlgItem(ID),m_lHeight);
}

/*********************************************************************/

void AKSetWindowSize(CWnd *m_pSouceWnd,CWnd *m_pDestWnd)
{
	CRect rcWnd(0, 0, 0, 0);
	GLLASSERT(m_pSouceWnd);
	GLLASSERT(m_pDestWnd);

	m_pSouceWnd->GetWindowRect(rcWnd);
	m_pDestWnd->MoveWindow(rcWnd, false);
}

/*********************************************************************/

void AKSetWindowSize(CWnd *m_pParentWnd,UINT SourceID,UINT DestID)
{
	GLLASSERT(m_pParentWnd);
	AKSetWindowSize(m_pParentWnd->GetDlgItem(SourceID),m_pParentWnd->GetDlgItem(DestID));
}
/*********************************************************************/

void AKReSize(CWnd *m_pWnd)
{
	CRect rcWnd;
	GLLASSERT(m_pWnd);
	m_pWnd->GetWindowRect(rcWnd);
	m_pWnd->SetWindowPos(NULL, 0, 0, rcWnd.Width() + 1, rcWnd.Height(), SWP_NOZORDER | SWP_NOMOVE);
	m_pWnd->SetWindowPos(NULL, 0, 0, rcWnd.Width() - 1, rcWnd.Height(), SWP_NOZORDER | SWP_NOMOVE);
}

/**********************************************************************/

static void GetControlTyp(CWnd *m_pWnd, bool &m_bIsComboBox, bool &m_bIsStatic, bool &m_bIsButton)
{
	TCHAR szClassName[MAX_PATH + 1] = { 0 };
	GLLASSERT(m_pWnd);
	
	m_bIsStatic = false;
	m_bIsButton = false;
	m_bIsComboBox = false;

	::GetClassName(m_pWnd->GetSafeHwnd(), szClassName, MAX_PATH);

	if(_tcsicmp(szClassName, _T("static")) == 0)
		m_bIsStatic = true;
	if(_tcsicmp(szClassName, _T("button")) == 0)
		m_bIsButton = true;
	if(_tcsicmp(szClassName, _T("combobox")) == 0)
		m_bIsComboBox = true;
}

/*********************************************************************/

void sSetButtonHeight(CWnd *pParentWnd,UINT ids[])
{
	CRect rcWnd;
	CWnd *pWnd;
	int i = 0, iFontHeight = 0;

	GLLASSERT(pParentWnd);

	CFont *pFont = pParentWnd->GetFont();

	if(pFont)
		{
		LOGFONT LogFont;
		pFont->GetLogFont(&LogFont);
		iFontHeight = GLL_GetDPI()->ScaleY(abs(LogFont.lfHeight) + GLL_GetDPI()->ScaleY(11 + 1));
		}

	do
		{
		pWnd = pParentWnd->GetDlgItem(ids[i++]);
		if(pWnd)
			{
			pWnd->GetWindowRect(rcWnd);
			rcWnd.bottom = rcWnd.top + iFontHeight;
			pWnd->MoveWindow(rcWnd);
			}
		}
	while(pWnd);
}

/**********************************************************************/

#ifdef _USE_GLL_THEME_
static  CGLL_Theme_Helper *theGLLExternTheme = NULL;
void GLLSetThemeHelper(CGLL_Theme_Helper* pTheme)
	{
	theGLLExternTheme = pTheme;
	}
#endif

/**********************************************************************/

class CMemDCLayout : public CDC 
{
private:
	CBitmap*	m_bitmap;
	CBitmap*	m_oldBitmap;
	CDC*		m_pDC;
	CRect		m_rcBounds;

public:
	CMemDCLayout(CDC* pDC, const CRect& rcBounds) : CDC()
		{
		CreateCompatibleDC(pDC);
		m_bitmap = new CBitmap;
		m_bitmap->CreateCompatibleBitmap(pDC, rcBounds.Width(), rcBounds.Height());
		m_oldBitmap = SelectObject(m_bitmap);
		m_pDC = pDC;
		m_rcBounds = rcBounds;
		}

	~CMemDCLayout() 
		{
		m_pDC->BitBlt(
			m_rcBounds.left,
			m_rcBounds.top,
			m_rcBounds.Width(),
			m_rcBounds.Height(),
			this,
			m_rcBounds.left,
			m_rcBounds.top,
			SRCCOPY);

		SelectObject(m_oldBitmap);
		if (m_bitmap != NULL) 
			delete m_bitmap;
		}

	CMemDCLayout* operator->() {return this;}
};

/**********************************************************************/

static void GLLDoPaintMessageLoop()
{
	MSG message1;

	while(::PeekMessage(&message1,NULL,WM_PAINT,WM_PAINT, PM_REMOVE))
		{
		::TranslateMessage(&message1);
		::DispatchMessage(&message1);
		}
}

/**********************************************************************/

void CLayoutGroup::LayoutInit()
{
	ResetGroup();

	m_RootGroup.InitGroupObj();
	m_RootGroup.Art = IS_THE_ROOT;
	m_RootGroup.rcBorder.right = 0;
	m_RootGroup.rcBorder.left = 0;
	m_RootGroup.m_hTheWnd = NULL;
	m_RootGroup.m_TheWnd = NULL;
	m_crBackGrdColor = -1;
	m_crGroupBoxBorderColor = -1;
	m_bMWRedrawWindow = false;
	m_NoGLLEraseBackGround = false;

	pTheWindow = NULL;
	ID = 0;
	iStatusBarHeight = 0;
	lTheWindowIsA = 0;
	m_ViewSize.cx = 0;
	m_ViewSize.cy = 0;
	m_lCalcExtra = n5;
	m_bIsThemeActive = false;
	m_NTVersion = GLL_GetWindowsVers();
	if(m_NTVersion >= 50)
		m_bIsThemeActive = AKIsThemeActive();
	m_FIFO.RemoveAll();
	
	if(m_pCWFont == NULL)
		{
		m_pCWFont = new CFont;
		if (m_pCWFont->CreateStockObject(DEFAULT_GUI_FONT) == FALSE)
			{
			ASSERT(0);
			delete m_pCWFont;
			m_pCWFont = NULL;
			}
		}
}

/**********************************************************************/

CLayoutGroup::CLayoutGroup()
{
	m_pCWFont = NULL;
	LayoutInit();
}

/**********************************************************************/

CLayoutGroup::~CLayoutGroup()
{
	ResetGroup();
	if(m_pCWFont)
		delete m_pCWFont;
	m_pCWFont = NULL;
}

/**********************************************************************/

void CLayoutGroup::ResetGroup()
{
	GLLDoPaintMessageLoop();
	
	register CLayoutGroupObj *m_Entry = NULL;

	for(register int i = 0; i < m_Childs.GetSize(); i++)
		{
		if((m_Entry = m_Childs[i]) != NULL)
			{
			if(m_Entry->Art == IS_A_GROUP_WINDOW || m_Entry->Art == IS_A_LINE)
				{
				if(m_Entry->m_Group)
					{
					m_Entry->m_Group->DestroyWindow();
					delete m_Entry->m_Group;
					}
				}

			if(m_Childs[i]->Art == IS_A_SPLITTER)
				{
				ASSERT(m_Entry->m_Splitter);
				if(m_Entry->m_Splitter)
					{
					if(m_Entry->m_Name.IsEmpty() == FALSE)
						{
						AfxGetApp()->WriteProfileInt(m_Name, m_Entry->m_Name,
							(int) m_Entry->m_Splitter->GetFirstGrpPercent());
						}
					m_Entry->m_Splitter->DestroyWindow();
					delete m_Entry->m_Splitter;
					}
				}
		
			delete m_Entry;
			}
		}

	m_Childs.RemoveAll();
}

/**********************************************************************/

void CLayoutGroup::SetReSize(int bVert,int bHori)
{
	CLayoutGroupObj *pGrp;
	
	pGrp = GetGroup();
	
	if(bVert != -1)
		pGrp->ReSizeVertInit = bVert ? true :false;
	if(bHori != -1)
		pGrp->ReSizeHoriInit = bHori ? true :false;
}

/*********************************************************************/

CLayoutGroupObj * CLayoutGroup::GetGroup()
{
	CLayoutGroupObj *pParentGrp = NULL;
	
	if(m_FIFO.GetCount())
		pParentGrp = m_FIFO.GetAt(m_FIFO.GetHeadPosition());
	else
		pParentGrp = &m_RootGroup;

	ASSERT(pParentGrp);
	return pParentGrp;
}

/*********************************************************************/

int CLayoutGroup::GetGroupID()
{
	CLayoutGroupObj *pParentGroup = GetGroup();
	return pParentGroup->ID;
}

/*********************************************************************/

CLayoutGroupObj *CLayoutGroup::privAddVisibleGroup(long mode, bool bVisible, LPCRECT lpRect, bool bReCalc)
{
	CLayoutGroupObj *pGrp,*pNew_Grp;
	
	pGrp = GetGroup();
	pNew_Grp = NewGroup(pGrp,mode);
	GLLASSERT_N(pNew_Grp);

	pNew_Grp->bVisible = bVisible;
	m_FIFO.AddHead(pNew_Grp);

	if(lpRect)
		pNew_Grp->rcBorder = lpRect;

	if(bReCalc == false)
		pNew_Grp->dwFlags |= NO_RECALC;
	return pNew_Grp;
}

/**********************************************************************/

CLayoutGroupObj *CLayoutGroup::privAddGroup(int mode, LPCRECT lpRect, LPCTSTR szString)
{
	CLayoutGroupObj *pGrp,*pNew_Grp;
	
	pGrp = GetGroup();

	pNew_Grp = NewGroup(pGrp,mode);
	GLLASSERT_N(pNew_Grp);

	if(lpRect)
		{
		GLL_GetDPI()->ScaleRect((PRECTL)lpRect);
		pNew_Grp->rcBorder = lpRect;
		}

	pNew_Grp->m_Name = szString ? szString : _T("");
	m_FIFO.AddHead(pNew_Grp);

	return pNew_Grp;
}	

/**********************************************************************/

CLayoutGroupObj *CLayoutGroup::privAddLine(long m_lFlags, LPCTSTR szString, long m_Color)
{
	CLayoutGroupObj *pParentGrp, *pNew_Grp;
	UINT nID;
	long w, h, iFontHeight = 0;

	pParentGrp = GetGroup();

	pNew_Grp = NewGroup(pParentGrp, pParentGrp->Ausrichtung);
	GLLASSERT_N(pNew_Grp);

	pNew_Grp->Art = IS_A_LINE;
	pNew_Grp->WinArt = IS_A_LINE;
	pNew_Grp->Space = 10;

	if(m_lFlags & LINE_FULL_WIDTH)
		{
		pNew_Grp->dwFlags = m_lFlags;
		}

	if(szString)
		{
		CFont *pFont = pTheWindow->GetFont();

		if(pFont)
			{
			LOGFONT LogFont;
			pFont->GetLogFont(&LogFont);
			iFontHeight = abs(LogFont.lfHeight) / 2 + 4;
			}
		}

	if(pParentGrp->Ausrichtung == VGROUP_LAYOUT)
		{
		w = 2;
		h = 10;
		pNew_Grp->ReSizeVert = false;


		if((m_lFlags & CENTER_TEXT) == 0 &&
			(m_lFlags & LEFT_TEXT) == 0 &&
			(m_lFlags & RIGHT_TEXT) == 0 &&
			szString)
			{
			pNew_Grp->dwFlags |= CENTER_TEXT;
			}
		else
			pNew_Grp->dwFlags = m_lFlags;
		}
	else
		{
		w = 10;
		h = 2;
		pNew_Grp->ReSizeHori = false;
		}


	for(nID = 32767; nID != 1; --nID)
		if(pTheWindow->GetDlgItem(nID) == 0)
			break;

	pNew_Grp->m_Group = (CGroupStatic *) new CGroupStatic();
	ASSERT(pNew_Grp);
	if(pNew_Grp == NULL)
		return pNew_Grp;

	if(m_lFlags & BOLD_FONT)
		pNew_Grp->m_Group->m_UseBoldFont = true;


	pNew_Grp->m_Group->m_RootGroup = pNew_Grp->m_RootGroup;

	if(m_Color != -1)
		pNew_Grp->m_Group->m_BkColor = m_Color;

	if(pNew_Grp->m_Group->Create(_T(""),
		WS_VISIBLE | WS_CHILD,
		CRect(10, 10, 10 + w, 10 + h + iFontHeight), pTheWindow, nID))
		{
		pNew_Grp->m_Group->m_lFlags = pNew_Grp->dwFlags;
		pNew_Grp->m_hTheWnd = pNew_Grp->m_Group->GetSafeHwnd();
		if(szString)
			pNew_Grp->m_Group->SetTitle(szString);
		}

	pNew_Grp->m_TheWnd = pNew_Grp->m_Group;
	pNew_Grp->m_Name = szString;
	return pNew_Grp;
}

/**********************************************************************/

CLayoutGroupObj *CLayoutGroup::privAddSplitter(long lFirstPercent, bool bRealTimeLayout, LPCTSTR szString, long lBackGroundColor)
{
	CLayoutGroupObj *pParentGrp, *pNew_Grp = NULL;
	UINT nID;

	if(lFirstPercent > 95 || lFirstPercent < 5)
		lFirstPercent = 0;

	pParentGrp = GetGroup();

	for(nID = 32767; nID != 1; --nID)
		if(pTheWindow->GetDlgItem(nID) == 0)
			break;

	pNew_Grp = NewGroup(pParentGrp, pParentGrp->Ausrichtung);
	GLLASSERT_N(pNew_Grp);

	if(pParentGrp->Ausrichtung == VGROUP_LAYOUT)
		pNew_Grp->ReSizeVert = false;
	else
		pNew_Grp->ReSizeHori = false;

	pNew_Grp->Art = IS_A_WINDOW;

	pNew_Grp->m_Splitter = new CGroupSplitter();
	GLLASSERT_N(pNew_Grp->m_Splitter);

	pNew_Grp->m_Splitter->m_BackGroundColor = lBackGroundColor;
	pNew_Grp->m_Splitter->m_LayoutGroup = this;


	if(pNew_Grp->m_Splitter->Create(_T(""),
		WS_VISIBLE | WS_CHILD | WS_EX_STATICEDGE | SS_NOTIFY,
		CRect(0, 0,
		n4 + 4,
		n3 + 4),
		pTheWindow, nID))
		{
		pNew_Grp->m_hTheWnd = pNew_Grp->m_Splitter->GetSafeHwnd();
		pNew_Grp->m_Splitter->SetData(pTheWindow,
			pParentGrp->Ausrichtung == VGROUP_LAYOUT ? false : true, lFirstPercent);
		pNew_Grp->m_Splitter->bRealTimeLayout = bRealTimeLayout;
		pNew_Grp->m_TheWnd = pNew_Grp->m_Splitter;
		pNew_Grp->Art = IS_A_SPLITTER;
		pNew_Grp->m_Name = szString;
		pNew_Grp->nPercent = lFirstPercent;
		return pNew_Grp;
		}
	return NULL;
}

/**********************************************************************/

CLayoutGroupObj *CLayoutGroup::privAddGrpCtrl(UINT nID, long mode,UINT wID, long type, long lFlags, long m_Color)
{
	CLayoutGroupObj *pGrp, *pNew_Grp;

	long
		m_lTextTop = 0,
		m_lLeft = n10,
		m_lRight = n10,
		m_lBottom = n8;

	pGrp = GetGroup();

	if((pTheWindow->GetDlgItem(nID)) == NULL)
		return NULL;

	if((type == IS_A_GROUP_WINDOW || type == IS_A_TABCONTROL) == FALSE)
		type = IS_A_GROUP_WINDOW;

	ASSERT(pGrp);

	CFont *pFont = pTheWindow->GetFont();
	if(pFont) // Nur wenn in m_WinTitle was steht
		{
		LOGFONT LogFont;
		pFont->GetLogFont(&LogFont);
		m_lTextTop = abs(LogFont.lfHeight) + n6;
		}

	if(wID)
		m_lTextTop += n3;

	if(type == IS_A_TABCONTROL)
		{
		CRect mRect(0, 0, 0, 0);
		CTabCtrl *m_Tab;
		m_Tab = (CTabCtrl *) pTheWindow->GetDlgItem(nID);
		
		if(m_Tab)
			{
			DWORD style = GetWindowLong(m_Tab->GetSafeHwnd(), GWL_STYLE);
			SetWindowLong(m_Tab->GetSafeHwnd(), GWL_STYLE, style | WS_CLIPSIBLINGS);

			m_Tab->AdjustRect(TRUE, &mRect);
			m_lLeft = abs(mRect.left) + n1;
			m_lTextTop = abs(mRect.top) + n2;
			m_lRight = mRect.right + n2;
			m_lBottom = mRect.bottom + n2;

			if(m_Tab->GetStyle() & TCS_BOTTOM)
				{
				m_lTextTop = abs(mRect.top);
				}
			}
		}

	pNew_Grp = NewGroup(pGrp, mode);
	ASSERT(pNew_Grp);
	if(pNew_Grp == NULL)
		return NULL;


	pNew_Grp->dwFlags = lFlags;
	pNew_Grp->rcBorder.SetRect(m_lLeft, m_lTextTop, m_lRight, m_lBottom);

	if(type == IS_A_GROUP_WINDOW)
		{
		pTheWindow->GetDlgItem(nID)->GetWindowText(pNew_Grp->m_Name);
		pTheWindow->GetDlgItem(nID)->SetWindowText(_T(""));

		pNew_Grp->m_Group = (CGroupStatic *) new CGroupStatic();
		ASSERT(pNew_Grp->m_Group);
		if(pNew_Grp->m_Group == NULL)
			return NULL;

		pNew_Grp->m_Group->m_RootGroup = pNew_Grp->m_RootGroup;


		if(lFlags & BOLD_FONT)
			pNew_Grp->m_Group->m_UseBoldFont = true;

		pNew_Grp->m_Group->SubclassDlgItem(nID, pTheWindow);
		pNew_Grp->m_Group->SetTitle(pNew_Grp->m_Name);
		pNew_Grp->m_TheWnd = pNew_Grp->m_Group;
		pNew_Grp->m_Group->m_BkColor = m_Color;

		if(wID)
			{
			if(pNew_Grp->m_Group->SetTitleCtrl(pTheWindow->GetDlgItem(wID)))
				pNew_Grp->rcBorder.top = AKGetWindowHeight(pTheWindow->GetDlgItem(wID)) + n5;
			}

		if(pNew_Grp->m_Name.GetLength() < 1)
			{
			if(wID == 0)
				pNew_Grp->rcBorder.top = n8;
			}
		}

	pNew_Grp->Art = IS_A_GROUP_WINDOW;
	pNew_Grp->m_hTheWnd = pTheWindow->GetDlgItem(nID)->GetSafeHwnd();

	pNew_Grp->WinArt = type;
	m_FIFO.AddHead(pNew_Grp);
	return pNew_Grp;
}

/**********************************************************************/

CLayoutGroupObj *CLayoutGroup::privAddLFGroup(int mode, LPCRECT lpRect)
{
	CLayoutGroupObj *pNew_Grp = privAddVisibleGroup(mode, false, lpRect, false);
	ASSERT(pNew_Grp);
	if(pNew_Grp)
		{
		pNew_Grp->dwFlags |= IS_LF_GROUP;
		}

	return pNew_Grp;
}

/**********************************************************************/

bool CLayoutGroup::privInitLFGroup(CLayoutGroupObj *pLFGrp)
{
	ASSERT(pLFGrp);
	
	if(pLFGrp)
		{
		//Schon initialisiert?
		if(pLFGrp->m_Childs.GetSize())
			return false;

		//Vermutlich falscher/direkter Aufruf.
		ASSERT(m_FIFO.IsEmpty());

		if(m_FIFO.IsEmpty())
			{
			m_FIFO.AddTail(pLFGrp);
			return true;
			}
		}
	return false;
}

/**********************************************************************/

void CLayoutGroup::privEndLFGroup()
{
	CLayoutGroupObj *pGrp = m_FIFO.RemoveHead();
	if(pGrp == NULL)
		pGrp = &m_RootGroup;
	InitGroups(pGrp);
}

/**********************************************************************/

void CLayoutGroup::SearchForGroupStatics(CLayoutGroupObj *pGroup, CLayoutGroupObj *pLGroup)
{
	register CLayoutGroupObj *m_Entry = NULL;

	for(register int i = 0; i < pGroup->m_Childs.GetSize(); i++)
		{
		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			if(m_Entry->Art == IS_A_LAYOUT_GROUP)
				SearchForGroupStatics(m_Entry, pLGroup);

			if(m_Entry->Art == IS_A_GROUP_WINDOW //IS_A_TABCONTROL
				&& (m_Entry->WinArt == IS_A_GROUP_WINDOW || m_Entry->WinArt == IS_A_TABCONTROL))
				{
				SearchForGroupStatics(m_Entry, m_Entry);
				if(pLGroup)
					if(pLGroup->m_Group)
						pLGroup->m_Group->AddMember(m_Entry->m_hTheWnd);
				}

			if(m_Entry->Art == IS_A_WINDOW || m_Entry->Art == IS_A_LINE || m_Entry->Art == IS_A_SPLITTER)
				{
				if(pLGroup)
					{
					if(pLGroup->m_Group)
						pLGroup->m_Group->AddMember(m_Entry->m_hTheWnd);
					}
				}
			}
		}
}

/*********************************************************************/

CLayoutGroupObj * CLayoutGroup::privAddSpreader(long xspace,long yspace,long mode)
{
	CLayoutGroupObj *m_pParentGrp, *New_Grp = NULL;

	m_pParentGrp = GetGroup();

	New_Grp = NewGroup(m_pParentGrp, m_pParentGrp->Ausrichtung);

	if(New_Grp)
		{
		if(mode & FIX_HORI)
			New_Grp->ReSizeHori = false;

		if(mode & FIX_VERT)
			New_Grp->ReSizeVert = false;

		if(mode == NORESIZE_CW)
			{
			New_Grp->ReSizeHori = false;
			New_Grp->ReSizeVert = false;
			}

		New_Grp->rcMinSize.right = xspace;
		New_Grp->rcMinSize.bottom = yspace;
		New_Grp->Art = IS_A_SPREADER;
		New_Grp->WinArt = IS_A_SPREADER;
		}

	return New_Grp;
}

/*********************************************************************/

CLayoutGroupObj *CLayoutGroup::privAddSpreaderLike(CWnd *w,long mode)
{
	GLLASSERT_F(w);
	return(privAddSpreader(AKGetWindowWidth(w),AKGetWindowHeight(w),mode));
}

/*********************************************************************/

CLayoutGroupObj *CLayoutGroup::privAddSpreaderLike(UINT nID,long mode)
{
	CWnd *w = pTheWindow->GetDlgItem(nID);
	GLLASSERT_F(w);
	return(privAddSpreader(AKGetWindowWidth(w),AKGetWindowHeight(w),mode));
}

/*********************************************************************/

CLayoutGroupObj *CLayoutGroup::privAddSpace(long nSpace, long nInitalSpace)
{
	CLayoutGroupObj *m_pParentGrp,*New_Grp;

	m_pParentGrp = GetGroup();

	New_Grp = NewGroup(m_pParentGrp, m_pParentGrp->Ausrichtung);
	if(New_Grp)
		{

		if(nSpace)
			{
			if(m_pParentGrp->Ausrichtung == HGROUP_LAYOUT)
				nSpace = GLL_GetDPI()->ScaleX(nSpace);
			else
				nSpace = GLL_GetDPI()->ScaleY(nSpace);
			}

		if(nInitalSpace)
			{
			if(m_pParentGrp->Ausrichtung == HGROUP_LAYOUT)
				nInitalSpace = GLL_GetDPI()->ScaleX(nInitalSpace);
			else
				nInitalSpace = GLL_GetDPI()->ScaleY(nInitalSpace);
			}

		New_Grp->ReSizeHori = false;
		New_Grp->ReSizeVert = false;
		New_Grp->InitalSpace = nInitalSpace;


		New_Grp->Art = IS_A_SPACE;
		if(m_pParentGrp->Ausrichtung == HGROUP_LAYOUT)
			{
			New_Grp->rcMinSize.right = nSpace;
			if(nSpace == 0)
				{
				New_Grp->ReSizeHori = true;
				New_Grp->rcMinSize.right = 1;
				}
			}
		else
			{
			New_Grp->rcMinSize.bottom = nSpace;
			if(nSpace == 0)
				{
				New_Grp->ReSizeVert = true;
				New_Grp->rcMinSize.bottom = 1;
				}
			}

		New_Grp->m_TheWnd = NULL;
		New_Grp->m_hTheWnd = NULL;
		if(nSpace > 100)
			nSpace = 100;
		New_Grp->Space = nSpace;
		}

	return New_Grp;
}

/*********************************************************************/

void CLayoutGroup::privSetAlign(long mode)
{
	CLayoutGroupObj *m_pParentGrp;

	m_pParentGrp = GetGroup();
	
	if(mode < RIGHT && mode > BOTTOM)
		m_pParentGrp->Align = LEFT;
	else 
		m_pParentGrp->Align = mode;
}

/**********************************************************************/

CLayoutGroupObj *CLayoutGroup::privAddChild(UINT id, DWORD lSpread, DWORD lPercent, DWORD lFlags, DWORD dwMaxSize)
{
	CLayoutGroupObj *m_pParentGrp, *New_Grp = NULL;

	m_pParentGrp = GetGroup();

	New_Grp = NewItem(m_pParentGrp,id,lSpread);
	ASSERT(New_Grp);
	
	if(New_Grp)
		{
		New_Grp->dwFlags = lFlags;
		New_Grp->nPercent = lPercent;
		New_Grp->dwMaxSize = dwMaxSize;

		if((lSpread & FULL_WIDTH) == FULL_WIDTH)
			New_Grp->dwFlags |= LINE_FULL_WIDTH;

		if((lSpread & FULL_HEIGHT) == FULL_HEIGHT)
			New_Grp->dwFlags |= LINE_FULL_HEIGHT;

		if((lSpread & ON_DLG_TOP) == ON_DLG_TOP)
			New_Grp->dwFlags |= PRIVAT4;

		if((lSpread & 	ON_DLG_TOP2) == ON_DLG_TOP2)
			New_Grp->dwFlags |= PRIVAT5;


		if((lSpread & MOVE_OCX) == MOVE_OCX)
			New_Grp->bUse_CWnd_Move = true;
		}
	return New_Grp;
}

/*********************************************************************/

CLayoutGroupObj *CLayoutGroup::privAddChild(CWnd *w, DWORD lSpread, DWORD lPercent, DWORD lFlags, DWORD dwMaxSize)
{
	CLayoutGroupObj *m_pParentGrp, *New_Grp = NULL;

	m_pParentGrp = GetGroup();

	New_Grp = NewItem(m_pParentGrp, w, lSpread);
	ASSERT(New_Grp);

	if(New_Grp)
		{
		New_Grp->dwFlags = lFlags;
		New_Grp->nPercent = lPercent;
		New_Grp->dwMaxSize = dwMaxSize;

		if((lSpread & FULL_WIDTH) == FULL_WIDTH)
			New_Grp->dwFlags |= LINE_FULL_WIDTH;

		if((lSpread & FULL_HEIGHT) == FULL_HEIGHT)
			New_Grp->dwFlags |= LINE_FULL_HEIGHT;

		if((lSpread & ON_DLG_TOP) == ON_DLG_TOP)
			New_Grp->dwFlags |= PRIVAT4;

		if((lSpread & 	ON_DLG_TOP2) == ON_DLG_TOP2)
			New_Grp->dwFlags |= PRIVAT5;


		if((lSpread & MOVE_OCX) == MOVE_OCX)
			New_Grp->bUse_CWnd_Move = true;
		}

	return New_Grp;
}

/*********************************************************************/

CLayoutGroupObj * CLayoutGroup::NewItem(CLayoutGroupObj *m_pParentGrp,CWnd *pWnd,long lSpread)
{
	CLayoutGroupObj *pGroup = NewGroup(m_pParentGrp,m_pParentGrp->Ausrichtung);
	bool m_bIsStatic = false, m_bIsButton = false, m_bComboBox;
	pGroup->Art = IS_A_WINDOW;
	pGroup->m_TheWnd = pWnd;
	GLLASSERT_N(pGroup->m_TheWnd);
	
	GetControlTyp(pWnd, m_bComboBox, m_bIsStatic, m_bIsButton);

	if(m_bComboBox)
		{
		if(lSpread != NORESIZE)
			lSpread = FIX_VERT;
		}

	/*******************
	** Da -1 von der Controlbreite abgezogen wird,
	** werden Icons z.B. nur 31 breit
	********************/
	if(m_bIsStatic)
		{
		long m_lStyle = pWnd->GetStyle();
		if((m_lStyle & SS_ICON) == SS_ICON)
			{
			CRect rcWnd;
			pWnd->GetWindowRect(rcWnd);
			rcWnd.right = rcWnd.Width() + 1;
			rcWnd.left = 0;
			pWnd->MoveWindow(rcWnd,false);
			}
		}

	//------------------------------------------------

	if(lSpread == NORESIZE_CALCWIDTH)
		{
		CWnd *pCWParent;
		CDC *m_pCalcDC = NULL;
		CFont *pCalcFont = NULL;
		CRect m_CalcRC;
		CString m_Text;
		long m_width;

		pCWParent = AfxGetMainWnd();

		if(pWnd)
			{
			if(pCWParent == NULL)
				pCWParent = pWnd->GetParent();

			pWnd->GetWindowText(m_Text);
			
			if(m_Text.IsEmpty() == FALSE)
				{
				if(pCWParent)
					m_pCalcDC = pCWParent->GetDC();
			
				if(m_pCalcDC)
					{
					long m_lStyle = pWnd->GetStyle();
					CFont *pBackFont = NULL;
					ASSERT(pCWParent);

					if(m_pCWFont)
						pCalcFont = m_pCWFont;
					else
						pCalcFont = pCWParent->GetFont();

					if(pCalcFont)
						{
						pBackFont = m_pCalcDC->SelectObject(pCalcFont);
						
						m_CalcRC.SetRectEmpty();
						m_pCalcDC->DrawText(m_Text, &m_CalcRC, DT_CALCRECT | DT_EXPANDTABS );
						m_width = m_CalcRC.Width();
						m_pCalcDC->SelectObject(pBackFont);
						
						pWnd->GetWindowRect(m_CalcRC);
						m_CalcRC.right = m_CalcRC.left + m_width + m_lCalcExtra;

						if(m_bIsButton)
							{
							if(((m_lStyle & BS_AUTOCHECKBOX) ) ||
							   ((m_lStyle & BS_AUTORADIOBUTTON) ))
								{
								m_CalcRC.right += n21;
								}
							else
								{
								// 6px + (WinBorder+1) * 2 + 6px
								m_CalcRC.right += ((GetSystemMetrics(SM_CXBORDER) + 1) * 2) + n12;
								}

							}
						
						pWnd->MoveWindow(m_CalcRC);
						}
					pCWParent->ReleaseDC(m_pCalcDC);
					}
				}
			}
		lSpread = NORESIZE;
		}

	//------------------------------------------------

	pGroup->m_hTheWnd = pWnd->GetSafeHwnd();
	ASSERT(pGroup->m_hTheWnd);

	if(lSpread & FIX_HORI)
		pGroup->ReSizeHori = false;
	
	if(lSpread & FIX_VERT)
		pGroup->ReSizeVert = false;
	
	pGroup->pParentGroup = m_pParentGrp;
	pGroup->m_RootGroup = this;


	return(pGroup);
}

/**********************************************************************/

CLayoutGroupObj * CLayoutGroup::NewItem(CLayoutGroupObj *m_pParentGrp,UINT nID,long lSpread)
{
	return NewItem(m_pParentGrp,pTheWindow->GetDlgItem(nID),lSpread);
}

/**********************************************************************/

CLayoutGroupObj * CLayoutGroup::NewGroup(CLayoutGroupObj *m_pParentGrp, long Ausrichtung)
{
	GLLASSERT_N(m_pParentGrp);
	CLayoutGroupObj* pGroup = new CLayoutGroupObj();
	
	ASSERT(pTheWindow);
	ASSERT(pGroup);

	if(pGroup == NULL || pTheWindow == NULL || Ausrichtung == NULL)
		{
		ASSERT(0);
		return NULL;
		}

	pGroup->Art = IS_A_LAYOUT_GROUP;
	pGroup->m_Name = _T("");
	pGroup->pParentGroup = m_pParentGrp;
	pGroup->Ausrichtung = Ausrichtung;
	pGroup->ID = ++ID;
	pGroup->m_RootGroup = this;
	m_pParentGrp->m_Childs.Add(pGroup);
	m_Childs.Add(pGroup);
	return pGroup;
}

/**********************************************************************/

void CLayoutGroup::privEndGroup()
{
	if(m_FIFO.GetCount() > 1)
		{
		CLayoutGroupObj *pGrp = m_FIFO.RemoveHead();
		if(pGrp->m_Childs.GetSize() == 0)
			{
			if((pGrp->dwFlags & IS_LF_GROUP) == 0)
				{
				AfxMessageBox(_T("Group is empty!"));
				}
			}
		}
	else
		{
		InitGroups(&m_RootGroup);
		SearchForGroupStatics(&m_RootGroup,NULL);
		CalcGroups(&m_RootGroup);
		SetPosGroups(&m_RootGroup, m_RootGroup.rcBorder.left, m_RootGroup.rcBorder.top);
		}
}

/**********************************************************************/

void CLayoutGroup::ShowGroups(CLayoutGroupObj *pGroup,bool bVisible, bool bInit)
{
	register CLayoutGroupObj *m_Entry;

	for(register int i = 0; i < pGroup->m_Childs.GetSize(); i++)
		{
		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			if(m_Entry->Art == IS_A_LAYOUT_GROUP || m_Entry->Art == IS_A_GROUP_WINDOW)
				{
				ShowGroups(m_Entry, (bInit && !m_Entry->bVisible) ? false : bVisible, bInit);

				if(m_Entry->Art == IS_A_GROUP_WINDOW)
					{
					ShowWindow(m_Entry->m_hTheWnd, bVisible);
					}
				continue;
				}

			if(m_Entry->Art == IS_A_WINDOW
				|| m_Entry->Art == IS_A_LINE
				|| m_Entry->Art == IS_A_GROUP_WINDOW
				|| m_Entry->Art == IS_A_SPLITTER)
				{
				if(m_Entry->m_TheWnd)
					{
					if(bVisible)	// fix 2.4.7
						::SetWindowPos(m_Entry->m_hTheWnd, NULL, 2000, 2000, 0, 0, SWP_NOREDRAW | SWP_NOACTIVATE | SWP_NOZORDER | SWP_NOSENDCHANGING);


					if(m_NTVersion > 40)
						{
						ShowWindow(m_Entry->m_hTheWnd, bVisible);
						}
					else
						{
						::SetWindowPos(m_Entry->m_hTheWnd, NULL, 0, 0, 0, 0,
							SWP_NOREDRAW | SWP_NOACTIVATE | SWP_NOZORDER | SWP_NOSIZE | SWP_NOMOVE |
							(bVisible ? SWP_SHOWWINDOW : SWP_HIDEWINDOW));
						}
					}
				}
			}
		}
}

/**********************************************************************/

void CLayoutGroup::privShowVisibleGroup(CLayoutGroupObj *pGroup, bool bShow, bool bRefresh)
{
	ASSERT(pGroup);
	if(pGroup == NULL)
		return;

	if(pGroup->bVisible == bShow)
		{
		ShowGroups(pGroup, bShow, false);

		if(bRefresh == false)
			return;
		}

	if(pGroup->dwFlags & IS_LF_GROUP)
		{
		if(pGroup->m_Childs.GetSize() == 0)
			{
			ASSERT(pTheWindow);
			if(pTheWindow)
				{
				pGroup->bVisible = bShow;
				pTheWindow->SendMessage(WM_OPEN_LAZY_FETCHING_GROUP, (WPARAM)pGroup, (LPARAM)this);
				bRefresh = true;
				}
			}
		}

	pGroup->bVisible = bShow;
	ShowGroups(pGroup, bShow, false);
	ReInitGroups(&m_RootGroup);
	ReInitGroupSplitter(&m_RootGroup);

	if(bRefresh)
		Size(&m_RootGroup);
}

/*********************************************************************/

void CLayoutGroup::ReInitGroupSplitter(CLayoutGroupObj *pGroup)
{
	CLayoutGroupObj *m_Entry;
	for(register int i = 0; i < pGroup->m_Childs.GetSize(); i++)
		{
		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			if(m_Entry->Art == IS_A_LAYOUT_GROUP || m_Entry->Art == IS_A_GROUP_WINDOW)
				{
				ReInitGroupSplitter(m_Entry);
				}
			if(m_Entry->Art == IS_A_SPLITTER)
				{
				if(m_Entry->m_Splitter && (m_Entry->bVisible || !m_Entry->m_Splitter->IsWindowVisible())) // 2.4.1
					{
					m_Entry->m_Splitter->ReInitTopBottomGroups();
					::SetWindowPos(m_Entry->m_Splitter->GetSafeHwnd(),
						HWND_TOP, 0, 0, 0, 0, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);
					}
				}
			}
		}
}

/**********************************************************************/

void CLayoutGroup::ReInitGroups(CLayoutGroupObj *pGroup)
{
	CLayoutGroupObj *m_Entry;
	CRect rcGroup(0, 0, 0, 0), rcWnd;
	CSize m_Size;
	int FixGroups = 0;
	register DWORD i;

	pGroup->rcMinSize.SetRect(0, 0, 0, 0);
	pGroup->rcAktSize.SetRect(0, 0, 0, 0);

	/*************
	** Fix 2.4.2
	*************/

	pGroup->ReSizeHori = false;
	pGroup->ReSizeVert = false;

	if(pGroup->ReSizeVertInit != -1)
		pGroup->ReSizeVert = pGroup->ReSizeVertInit ? true : false;

	if(pGroup->ReSizeHoriInit != -1)
		pGroup->ReSizeHori = pGroup->ReSizeHoriInit ? true : false;


	/**********************************************************************/

	if(pGroup->bVisible == false)
		return;

	DWORD dwChildCount = (DWORD)pGroup->m_Childs.GetSize();

	for(i = 0; i < dwChildCount; i++)
		{
		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			if(m_Entry->Art == IS_A_LAYOUT_GROUP || m_Entry->Art == IS_A_GROUP_WINDOW)
				{
				if((pGroup->dwFlags & NO_RECALC) == 0)
					m_Entry->nPercent = 0.0; // fix 2.2
				ReInitGroups(m_Entry);
				}

			if(pGroup->Ausrichtung == HGROUP_LAYOUT)
				{
				rcGroup.bottom = max(rcGroup.bottom, m_Entry->rcMinSize.Height());
				rcGroup.right += m_Entry->rcMinSize.Width();

				if(m_Entry->bVisible == false || !m_Entry->ReSizeHori)
					FixGroups++;

				}
			else
				{
				rcGroup.right = max(rcGroup.right, m_Entry->rcMinSize.Width());
				rcGroup.bottom += m_Entry->rcMinSize.Height();

				if(m_Entry->bVisible == false || !m_Entry->ReSizeVert)
					FixGroups++;

				}
			}

		/*************
		** Fix 2.4.2
		*************/

		if(m_Entry->Art != IS_A_LINE)
			{
			if(m_Entry->ReSizeHori)
				{
				pGroup->ReSizeHori = true;
				}

			if(m_Entry->ReSizeVert)
				{
				pGroup->ReSizeVert = true;
				}
			}

		/**********************************************************************/


		}

	//-----------------------------

	int Width = 0, Height = 0;
	for(i = 0; i < dwChildCount; i++)
		{
		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			if(m_Entry->Art == IS_A_SPACE)
				{
				if(m_Entry->Space == 0)
					{
					if(pGroup->Ausrichtung == HGROUP_LAYOUT)
						{
						Width += m_Entry->rcMinSize.right;
						}
					else
						{
						Height += m_Entry->rcMinSize.bottom;
						}
					}
				}
			}
		}

	rcGroup.right += Width;
	rcGroup.bottom += Height;
	//-----------------------------

	/**********************************************************************
	**	Fix 2.2 fr VisibleGroups
	**********************************************************************/

	if((pGroup->dwFlags & NO_RECALC) == 0) // nicht in TABCONTROL
		{
		double dWidth, dHeight;
		dWidth = rcGroup.Width();
		dHeight = rcGroup.Height();

		for(i = 0; i < dwChildCount; i++)
			{
			if((m_Entry = pGroup->m_Childs[i]) != NULL)
				{
				if(pGroup->Ausrichtung == HGROUP_LAYOUT)
					{
					if(m_Entry->ReSizeHori == false)
						dWidth -= m_Entry->rcAktSize.Width();
					}
				else
					{
					if(m_Entry->ReSizeVert == false)
						dHeight -= m_Entry->rcAktSize.Height();
					}
				}
			}

		long lEntrySize;
		for(i = 0; i < dwChildCount; i++)
			{
			if((m_Entry = pGroup->m_Childs[i]) != NULL)
				{
				if(pGroup->Ausrichtung == HGROUP_LAYOUT)
					{
					if(m_Entry->ReSizeHori == false)
						m_Entry->nPercent = 0.0;
					else
						{
						lEntrySize = m_Entry->rcAktSize.Width();
						if(m_Entry->nPercent == 0.0)
							{
							if(lEntrySize)
								m_Entry->nPercent = (lEntrySize*100.0) / dWidth;
							else
								m_Entry->nPercent = 100.0;
							}
						}
					}
				else
					{

					if(m_Entry->ReSizeVert == false)
						m_Entry->nPercent = 0.0;
					else
						{
						lEntrySize = m_Entry->rcAktSize.Height();
						if(m_Entry->nPercent == 0.0)
							{
							if(lEntrySize)
								m_Entry->nPercent = (lEntrySize*100.0) / dHeight;
							else
								m_Entry->nPercent = 100.0;
							}
						}
					}
				}
			}
		}

	/**Fix 2.2 ********************************************************************/


	/*********************************************************************
	** Sorgt dafr, dass das (Group)Control nie kleiner ist als das Titelcontrol
	*********************************************************************/

	if(pGroup->Art == IS_A_GROUP_WINDOW)
		{
		HWND m_phWnd = NULL;
		if(pGroup->m_Group)
			m_phWnd = pGroup->m_Group->GetTitleCtrl();
		if(m_phWnd)
			{
			CRect mRect(0, 0, 0, 0);
			::GetWindowRect(m_phWnd, mRect);
			AKScreenToClient(pTheWindow->GetSafeHwnd(), mRect);
			rcGroup.right = max(rcGroup.right, mRect.Width() + GRP_CTRL_FIX);
			}
		}
	/*********************************************************************
	** Gleiche Breite/Hhe bei TabControl-Grp
	*********************************************************************/

	if(pGroup->Art == IS_A_GROUP_WINDOW && pGroup->WinArt == IS_A_TABCONTROL)
		{
		if(pGroup->dwFlags & USE_INIT_HEIGHT)
			{
			if(pGroup->m_iInitialHeight)
				rcGroup.bottom = pGroup->m_iInitialHeight;
			}

		if(pGroup->dwFlags & USE_INIT_WIDTH)
			{
			if(pGroup->m_iInitialWidth)
				rcGroup.right = pGroup->m_iInitialWidth;
			}
		}


	if(pGroup->bVisible == false)
		{
		rcGroup.SetRect(0, 0, 0, 0);
		}


	if(pGroup->bVisible == true) // Fix 2.2. 09.03.03
		{
		rcGroup.right += pGroup->rcBorder.left + pGroup->rcBorder.right;
		rcGroup.bottom += pGroup->rcBorder.top + pGroup->rcBorder.bottom;
		}

	pGroup->rcMinSize = rcGroup;
	pGroup->rcAktSize = rcGroup;
}

/*********************************************************************/

void CLayoutGroup::InitGroups(CLayoutGroupObj *pGroup)
{
	CLayoutGroupObj *m_Entry;
	CRect rcGroup(0, 0, 0, 0), rcWnd;
	CSize m_Size;
	TCHAR szClassName[MAX_PATH + 1] = { 0 };
	int NoFixCounter = 0;
	register int i, iChildSize;

	if(pGroup->m_Childs.GetSize() == 0)
		return;

	//if(pGroup->Art == IS_A_LAYOUT_GROUP || pGroup->Art == IS_THE_ROOT || pGroup->Art == IS_A_GROUP_WINDOW)
		{
		pGroup->rcMinSize.SetRect(0, 0, 0, 0);
		pGroup->ReSizeHori = false;
		pGroup->ReSizeVert = false;

		if(pGroup->ReSizeVertInit != -1)
			pGroup->ReSizeVert = pGroup->ReSizeVertInit ? true : false;

		if(pGroup->ReSizeHoriInit != -1)
			pGroup->ReSizeHori = pGroup->ReSizeHoriInit ? true : false;

		iChildSize = (int) pGroup->m_Childs.GetSize();

		for(int i2 = 0; i2 < iChildSize; i2++)
			{
			if((m_Entry = pGroup->m_Childs[i2]) != NULL)
				{
				if(m_Entry->Art != IS_A_LINE)
					if(pGroup->Ausrichtung == HGROUP_LAYOUT)
						if(iChildSize > 1 && i2 < iChildSize - 1)
							m_Entry->rcBorder.right++;

				if(m_Entry->Art == IS_A_LAYOUT_GROUP || m_Entry->Art == IS_A_GROUP_WINDOW)
					{
					InitGroups(m_Entry);
					}

				if(m_Entry->Art == IS_A_SPLITTER)
					{
					GLLASSERT(m_Entry->m_Splitter);

					if(i2 > 0 && pGroup->m_Childs.GetSize() > i2 + 1)
						{
						m_Entry->m_Splitter->SetTopBottomGroups(pGroup->m_Childs[i2 - 1], pGroup->m_Childs[i2 + 1]);

						if(m_Entry->m_Name.IsEmpty() == FALSE)
							m_Entry->nPercent = AfxGetApp()->GetProfileInt(m_Name, m_Entry->m_Name, (int) m_Entry->nPercent);
						else
							TRACE0("name nicht gesetzt. bitte fr splitter SetDlgName() nutzen\n");

						if(m_Entry->nPercent > 95.0)
							m_Entry->nPercent = 50.0;

						pGroup->m_Childs[i2 - 1]->nPercent = m_Entry->nPercent;
						pGroup->m_Childs[i2 + 1]->nPercent = 100.0 - m_Entry->nPercent;
						m_Entry->m_Splitter->SetPercent(m_Entry->nPercent);
						m_Entry->nPercent = 0.0;
						}
					else
						{
#ifdef _DEBUG
						CString m_Info;
						m_Info.Format(_T("Splitter-Error\nChild-Count: %ld, Pos: %ld"), pGroup->m_Childs.GetSize(), i2);
						AfxMessageBox(m_Info);
#endif
						ASSERT(0);
						}
					}

				if(m_Entry->Art == IS_A_SPREADER)
					m_Entry->rcAktSize = m_Entry->rcMinSize;

				if(m_Entry->Art == IS_A_SPLITTER
					|| m_Entry->Art == IS_A_WINDOW
					|| m_Entry->Art == IS_A_LINE)
					{
					GLLASSERT2(m_Entry->m_TheWnd, m_Entry->m_hTheWnd);

					m_Entry->m_TheWnd->GetWindowRect(rcWnd);
					m_Size = rcWnd.Size();
					m_Entry->rcMinSize.SetRect(0, 0, m_Size.cx, m_Size.cy);
					m_Entry->rcAktSize = m_Entry->rcMinSize;

					/*********************************************************************/
					// Splittergre anpassen, wenn Top- & Bottom-Control fix sind
					/*********************************************************************/

					if(m_Entry->Art == IS_A_SPLITTER)
						{
						if(pGroup->Ausrichtung == HGROUP_LAYOUT)
							{
							if(pGroup->m_Childs[i2 - 1]->ReSizeVert == false && pGroup->m_Childs[i2 + 1]->ReSizeVert == false)
								{
								m_Entry->ReSizeVert = false;
								m_Entry->rcMinSize.bottom = max(
									AKGetWindowHeight(pGroup->m_Childs[i2 - 1]->m_TheWnd),
									AKGetWindowHeight(pGroup->m_Childs[i2 + 1]->m_TheWnd));
								}
							}
						else
							{
							if(pGroup->m_Childs[i2 - 1]->ReSizeHori == false && pGroup->m_Childs[i2 + 1]->ReSizeHori == false)
								{
								m_Entry->ReSizeHori = false;
								m_Entry->rcMinSize.right = max(
									AKGetWindowWidth(pGroup->m_Childs[i2 - 1]->m_TheWnd),
									AKGetWindowWidth(pGroup->m_Childs[i2 + 1]->m_TheWnd));
								}
							}
						}

					//-----------------------------		
					::GetClassName(m_Entry->m_hTheWnd, szClassName, MAX_PATH);

					if(_tcscmp(szClassName, _T("msctls_updown32")) == 0)
						{
						if(::GetWindowLong(m_Entry->m_hTheWnd, GWL_STYLE) & UDS_AUTOBUDDY)
							{
							HWND hWnd;
							register CLayoutGroupObj *m_Entry2 = NULL;
							//#C GetNextWindow was replaced by HWND GetWindow(HWND hWnd, UINT uCmd ); 
							//#A Dirk Gaudian
							//#D 18.06.2002
							//#V 2.01

							//							hWnd = ::GetNextWindow(m_Entry->m_hTheWnd,GW_HWNDPREV);
							hWnd = ::GetWindow(m_Entry->m_hTheWnd, GW_HWNDPREV);

							if(hWnd)
								{
								m_Entry2 = FindGroup(hWnd);
								if(m_Entry2)
									{
									if(::GetWindowLong(m_Entry->m_hTheWnd, GWL_STYLE) & UDS_ALIGNRIGHT)
										{
										m_Entry2->dwFlags |= IS_UPDOWN32RIGHT;
										}
									if(::GetWindowLong(m_Entry->m_hTheWnd, GWL_STYLE) & UDS_ALIGNLEFT)
										{
										m_Entry2->dwFlags |= IS_UPDOWN32LEFT;
										}
									}
								}
							}
						}

					//-----------------------------		

					if(_tcscmp(szClassName, _T("ListBox")) == 0 ||
						_tcscmp(szClassName, _T("SysTabControl32")) == 0 ||
						_tcscmp(szClassName, _T("SysTreeView32")) == 0 ||
						_tcscmp(szClassName, _T("SysListView32")) == 0 ||
						_tcscmp(szClassName, _T("msctls_progress32")) == 0)
						{
						m_Entry->bUse_RDW_ERASE = true;
						}
					else
						m_Entry->bUse_RDW_ERASE = false;
					//-----------------------------		

					}


				if(pGroup->Ausrichtung == HGROUP_LAYOUT)
					{
					rcGroup.bottom = max(rcGroup.bottom, m_Entry->rcMinSize.Height());
					rcGroup.right += m_Entry->rcMinSize.Width();

					if(m_Entry->ReSizeHori)
						if(m_Entry->Art != IS_A_SPACE)
							NoFixCounter++;
					}
				else
					{
					rcGroup.right = max(rcGroup.right, m_Entry->rcMinSize.Width());
					rcGroup.bottom += m_Entry->rcMinSize.Height();

					if(m_Entry->ReSizeVert)
						if(m_Entry->Art != IS_A_SPACE)
							NoFixCounter++;
					}

				/*************
				** Fix 2.4.2
				*************/

				if(m_Entry->bVisible == false)
					continue;

				/**********************************************************************/

				if(m_Entry->Art != IS_A_LINE)
					{
					if(m_Entry->ReSizeHori)
						{
						pGroup->ReSizeHori = true;
						}

					if(m_Entry->ReSizeVert)
						{
						pGroup->ReSizeVert = true;
						}
					}
				}
			}
		}

	//-----------------------------
	int Width = 0, Height = 0, dazu;
	for(i = 0; i < pGroup->m_Childs.GetSize(); i++)
		{
		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			dazu = 0;
			if(m_Entry->Art == IS_A_SPACE)
				{
				if(m_Entry->Space == 0)
					{
					if(pGroup->Ausrichtung == HGROUP_LAYOUT)
						{
						if(NoFixCounter)
							dazu = rcGroup.Width() / (int) pGroup->m_Childs.GetSize();
						else
							m_Entry->nPercent = 100.0;
						m_Entry->ReSizeHori = true;
						Width += m_Entry->rcMinSize.right = m_Entry->InitalSpace + dazu;
						}
					else
						{
						if(NoFixCounter)
							dazu = rcGroup.Height() / (int) pGroup->m_Childs.GetSize();
						else
							m_Entry->nPercent = 100.0;
						m_Entry->ReSizeVert = true;
						Height += m_Entry->rcMinSize.bottom = m_Entry->InitalSpace + dazu;
						}
					}
				m_Entry->rcAktSize = m_Entry->rcMinSize;
				}
			}
		}

	rcGroup.right += Width;
	rcGroup.bottom += Height;
	//-----------------------------

	for(i = 0; i < pGroup->m_Childs.GetSize(); i++)
		{
		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			if(m_Entry->Art == IS_A_LAYOUT_GROUP || m_Entry->Art == IS_A_GROUP_WINDOW)
				{
				if(pGroup->Ausrichtung == HGROUP_LAYOUT)
					{
					m_Entry->rcMinSize.bottom = m_Entry->rcAktSize.bottom = rcGroup.bottom;
					}
				else
					{
					m_Entry->rcMinSize.right = m_Entry->rcAktSize.right = rcGroup.right;
					}
				}
			}
		}

	//-----------------------------


	double dWidth, dHeight;
	dWidth = rcGroup.Width();
	dHeight = rcGroup.Height();

	for(i = 0; i < pGroup->m_Childs.GetSize(); i++)
		{
		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			if(pGroup->Ausrichtung == HGROUP_LAYOUT)
				{
				if(m_Entry->ReSizeHori == false)
					dWidth -= m_Entry->rcAktSize.Width();
				}
			else
				{
				if(m_Entry->ReSizeVert == false)
					dHeight -= m_Entry->rcAktSize.Height();
				}
			}
		}

	long lEntrySize = 0;
	for(i = 0; i < pGroup->m_Childs.GetSize(); i++)
		{
		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			if(pGroup->Ausrichtung == HGROUP_LAYOUT)
				{
				if(m_Entry->ReSizeHori == false)
					m_Entry->nPercent = 0.0;
				else
					{
					lEntrySize = m_Entry->rcAktSize.Width();
					if(m_Entry->nPercent == 0.0)
						{
						if(lEntrySize)
							m_Entry->nPercent = (lEntrySize*100.0) / dWidth;
						else
							m_Entry->nPercent = 100.0;
						}
					}
				}
			else
				{

				if(m_Entry->ReSizeVert == false)
					m_Entry->nPercent = 0.0;
				else
					{
					lEntrySize = m_Entry->rcAktSize.Height();
					if(m_Entry->nPercent == 0.0)
						{
						if(lEntrySize)
							m_Entry->nPercent = (lEntrySize*100.0) / dHeight;
						else
							m_Entry->nPercent = 100.0;
						}
					}
				}
			}
		}

	/*********************************************************************
	** Sorgt dafr, dass das (Group)Control nie kleiner ist als das Titelcontrol
	*********************************************************************/

	if(pGroup->Art == IS_A_GROUP_WINDOW)
		{
		HWND m_phWnd = NULL;
		if(pGroup->m_Group)
			m_phWnd = pGroup->m_Group->GetTitleCtrl();
		if(m_phWnd)
			{
			CRect mRect(0, 0, 0, 0);
			::GetWindowRect(m_phWnd, mRect);
			AKScreenToClient(pTheWindow->GetSafeHwnd(), mRect);
			rcGroup.right = max(rcGroup.right, mRect.Width() + GRP_CTRL_FIX);
			}
		}

	/*********************************************************************
	** Gleiche Breite/Hhe bei TabControl-Grp
	*********************************************************************/

	if(pGroup->Art == IS_A_GROUP_WINDOW && pGroup->WinArt == IS_A_TABCONTROL)
		{
		if(pGroup->dwFlags & USE_INIT_HEIGHT)
			{
			if(pGroup->m_iInitialHeight)
				rcGroup.bottom = pGroup->m_iInitialHeight;
			else
				pGroup->m_iInitialHeight = rcGroup.bottom;
			}

		if(pGroup->dwFlags & USE_INIT_WIDTH)
			{
			if(pGroup->m_iInitialWidth)
				rcGroup.right = pGroup->m_iInitialWidth;
			else
				pGroup->m_iInitialWidth = rcGroup.right;
			}
		}

	if(pGroup->bVisible == false)
		{
		rcGroup.SetRect(0, 0, 0, 0);
		}

	if(pGroup->bVisible == true) // Fix 2.2. 09.03.03
		{
		rcGroup.right += pGroup->rcBorder.left + pGroup->rcBorder.right;
		rcGroup.bottom += pGroup->rcBorder.top + pGroup->rcBorder.bottom;
		}

	pGroup->rcAktSize = rcGroup;
	pGroup->rcMinSize = rcGroup;

	if(pGroup == &m_RootGroup)
		ShowGroups(&m_RootGroup, true, true);
}

/*********************************************************************/
// BRD fr Border ;-)

#define BRD_Width (pGroup->rcBorder.left + pGroup->rcBorder.right)
#define BRD_Height (pGroup->rcBorder.top + pGroup->rcBorder.bottom)


void CLayoutGroup::SetParentWindow(CWnd *pParentN)
{
	pTheWindow = pParentN;
}

/**********************************************************************/

COLORREF CLayoutGroup::GetBkgColor()
{
	return m_crBackGrdColor;
}

/**********************************************************************/

void CLayoutGroup::SetBkgColor(COLORREF crColor)
{
	m_crBackGrdColor = crColor;
}

/**********************************************************************/

void CLayoutGroup::SetPosGroups(CLayoutGroupObj *pGroup, int posx, int posy)
{
	CLayoutGroupObj *m_Entry;
	int iCtrlWidth = 0, iCtrlHeight = 0, iCtrlMaxWidth = 0, iCtrlMaxHeight = 0;

	posx += pGroup->rcBorder.left;
	posy += pGroup->rcBorder.top;

	if(pGroup->bVisible == false)
		return;


	/*********************************************************************/
	// Ausrichtung bercksichtigen
	/*********************************************************************/

	if(pGroup->Align)
		{
		for(register int i = 0; i < pGroup->m_Childs.GetSize(); i++)
			{
			if((m_Entry = pGroup->m_Childs[i]) != NULL)
				{
				if(m_Entry->bVisible == false)
					continue;
				iCtrlWidth += m_Entry->rcAktSize.right;
				iCtrlHeight += m_Entry->rcAktSize.bottom;

				iCtrlMaxWidth = max(iCtrlMaxWidth, m_Entry->rcAktSize.right);
				iCtrlMaxHeight = max(iCtrlMaxHeight, m_Entry->rcAktSize.bottom);
				}
			}

		if(pGroup->Ausrichtung == HGROUP_LAYOUT)
			{
			if(pGroup->Align == CENTER)
				posx += (pGroup->rcAktSize.right - iCtrlWidth) / 2;

			if(pGroup->Align == RIGHT)
				{
				posx += (pGroup->rcAktSize.right - iCtrlWidth - BRD_Width);
				}

			}
		else
			{
			if(pGroup->Align == CENTER)
				posy += (pGroup->rcAktSize.bottom - iCtrlHeight) / 2;

			if(pGroup->Align == BOTTOM)
				posy += (pGroup->rcAktSize.bottom - iCtrlHeight - BRD_Height);

			if(pGroup->Align == RIGHT)
				posx += (pGroup->rcAktSize.bottom - iCtrlHeight - BRD_Width);
			}
		}

	/*********************************************************************/

	int iPosXDazu = posx, iPosYDazu = posy;

	for(register int i = 0; i < pGroup->m_Childs.GetSize(); i++)
		{

		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			if(m_Entry->bVisible == false)
				continue;

			iPosXDazu = 0;
			iPosYDazu = 0;


			if(pGroup->Align == HCENTER)
				iPosXDazu = abs(m_Entry->rcAktSize.right - iCtrlMaxWidth) / 2;

			if(pGroup->Align == VRIGHT)
				iPosXDazu += abs((pGroup->rcAktSize.right - BRD_Width) - m_Entry->rcAktSize.right);

			if(pGroup->Align == VCENTER)
				iPosYDazu = abs(m_Entry->rcAktSize.bottom - iCtrlMaxHeight) / 2;

			if(pGroup->Align == HBOTTOM)
				iPosYDazu += abs((pGroup->rcAktSize.bottom - BRD_Height) - m_Entry->rcAktSize.bottom);


			if(m_Entry->Art == IS_A_LAYOUT_GROUP || m_Entry->Art == IS_A_GROUP_WINDOW)
				{
				SetPosGroups(m_Entry, posx, posy);

				if(m_Entry->Art == IS_A_GROUP_WINDOW)
					{
					CSize m_Size = m_Entry->rcAktSize.Size();
					m_Entry->rcWinSize = m_Entry->rcAktSize;
					/*
					#ifdef _DEBUG
					int error = (posx+(m_Entry->rcBorder.left/2)-1);
					ASSERT(error >= 0);
					#endif
					*/


// 					m_Entry->rcWinSize.SetRect(
// 						(posx + (m_Entry->rcBorder.left / 2) - 1), /// ABS war hier Bockmist (Views)!
// 						posy + 2,
// 						posx + m_Size.cx - ((m_Entry->rcBorder.right / 2) - 1),
// 						posy + m_Size.cy);



					//Fix: 2.7.5
					// WINDOWS 10 -1
					
					m_Entry->rcWinSize.SetRect(
						posx , //- 1,
						posy + n2,
						posx + m_Size.cx, // - 1,
						posy + m_Size.cy);
					}
				}

			if(m_Entry->Art == IS_A_SPLITTER || m_Entry->Art == IS_A_WINDOW || m_Entry->Art == IS_A_LINE)
				{
				CSize m_Size = m_Entry->rcAktSize.Size();

				if(m_Entry->ReSizeHori == false)
					m_Size.cx = m_Entry->rcMinSize.Width();

				if(m_Entry->ReSizeVert == false)
					m_Size.cy = m_Entry->rcMinSize.Height();

				m_Size.cx = max(m_Size.cx, m_Entry->rcMinSize.Width());
				m_Size.cy = max(m_Size.cy, m_Entry->rcMinSize.Height());

				if(m_Entry->Art == IS_A_WINDOW)
					{
					if(m_Entry->dwFlags & IS_UPDOWN32LEFT)
						{
						posx -= 3;
						m_Size.cx += 3;
						}

					if(m_Entry->dwFlags & IS_UPDOWN32RIGHT)
						{
						m_Size.cx += 3;
						}
					}

				m_Entry->rcWinSize.SetRect(
					iPosXDazu + posx + m_Entry->rcBorder.left,
					iPosYDazu + posy + m_Entry->rcBorder.top,
					iPosXDazu + posx + m_Size.cx - (m_Entry->rcBorder.right),
					iPosYDazu + posy + m_Size.cy - (m_Entry->rcBorder.bottom));

				if(m_Entry->dwFlags & LINE_FULL_WIDTH)
					{
					CRect rcWin;
					pTheWindow->GetClientRect(rcWin);

					if(pGroup->Ausrichtung == HGROUP_LAYOUT)
						{
						m_Entry->rcWinSize.top = 0;
						m_Entry->rcWinSize.bottom = rcWin.Height();
						}
					else
						{
						m_Entry->rcWinSize.left = 0;
						m_Entry->rcWinSize.right = rcWin.Width();
						}
					}

				//2.4.6
				if(m_Entry->dwFlags & PRIVAT4 || m_Entry->dwFlags & PRIVAT5)//ON_DLG_TOP
					{
					int iTop, iHeight = m_Entry->rcWinSize.Height();
					iTop = m_Entry->rcWinSize.top;
					m_Entry->rcWinSize.top = 0;
					m_Entry->rcWinSize.bottom = iHeight;

					if(m_Entry->dwFlags & PRIVAT5)//ON_DLG_TOP
						m_Entry->rcWinSize.bottom += iTop;
					}
				}

			if(pGroup->Ausrichtung == HGROUP_LAYOUT)
				posx += m_Entry->rcAktSize.Width();
			else
				posy += m_Entry->rcAktSize.Height();
			}
		}

	if(pGroup == &m_RootGroup)
		MoveWindows();
}

/*********************************************************************/

void CLayoutGroup::Size(CLayoutGroupObj *pGroup)
{
	GLLASSERT(pGroup);

	CalcGroups(pGroup);

	SetPosGroups(&m_RootGroup,
		m_RootGroup.rcBorder.left,
		m_RootGroup.rcBorder.top);

	if(pGroup != &m_RootGroup)
		MoveWindows();
}

/*********************************************************************/

CSize CLayoutGroup::privGetMinSize()
{
	return m_RootGroup.rcMinSize.Size();
}

/**********************************************************************/

void CLayoutGroup::MoveWindows()
{
	if(pTheWindow == NULL)
		return;

#ifndef UNDER_CE
	register int refresh;
#endif
	register CLayoutGroupObj *m_Entry = NULL;
	bool m_MWReDraw = false;

	CRect	rcClient;
	CDC *pDC = NULL;

	if(m_NoGLLEraseBackGround == false)
		pDC = pTheWindow->GetDC();

	pTheWindow->GetClientRect(rcClient);

	for(register int i = 0; i < m_Childs.GetSize(); i++)
		{
		if((m_Entry = m_Childs[i]) != NULL)
			{
			//Fix 2.5.3
			if(m_bMWRedrawWindow)
				m_MWReDraw = true;
			else
				m_MWReDraw = false;

			if(m_Entry->bVisible == false)
				continue;

			if(m_Entry->Art == IS_A_WINDOW
				|| m_Entry->Art == IS_A_LINE
				|| m_Entry->Art == IS_A_GROUP_WINDOW
				|| m_Entry->Art == IS_A_SPLITTER)
				{
				CRect mRect;

				//Fix 2.5.3
				if(m_Entry->WinArt == IS_A_TABCONTROL)
					m_MWReDraw = true;


				GetWindowRect(m_Entry->m_hTheWnd, &mRect);
				AKScreenToClient(pTheWindow->GetSafeHwnd(), &mRect);


				if(mRect.EqualRect(m_Entry->rcWinSize) == 0 ||
					m_Entry->Art == IS_A_GROUP_WINDOW)
					{
#ifndef UNDER_CE
					long lRefresh = RDW_INVALIDATE | RDW_UPDATENOW | RDW_ALLCHILDREN | RDW_FRAME;

					if(mRect.Width() == m_Entry->rcWinSize.Width() &&
						mRect.Height() == m_Entry->rcWinSize.Height())
						lRefresh |= RDW_ERASE;
#endif


					if(m_Entry->bUse_CWnd_Move)
						{
						m_Entry->m_TheWnd->MoveWindow(
							m_Entry->rcWinSize.left,
							m_Entry->rcWinSize.top,
							m_Entry->rcWinSize.Width(),
							m_Entry->rcWinSize.Height(),
							m_MWReDraw);
						}
					else
						{
						::MoveWindow(m_Entry->m_hTheWnd,
							m_Entry->rcWinSize.left,
							m_Entry->rcWinSize.top,
							m_Entry->rcWinSize.Width(),
							m_Entry->rcWinSize.Height(),
							m_MWReDraw);
						}

					/**********************************************************************/

					//Fix: 2.4.7 TabControls
					if(m_Entry->Art == IS_A_LINE)
						if(m_Entry->m_TheWnd && m_Entry->m_TheWnd->GetSafeHwnd()) // 2.4.13
							m_Entry->m_TheWnd->BringWindowToTop();

					/**********************************************************************/

					if(m_Entry->dwFlags & NO_REDRAW)
						continue;

					//#C CE does not support Redraw so I had to think of something different. I introduced else if at the same time
					//#A Dirk Gaudian
					//#D 18.06.2002
					//#V 2.01
#ifdef UNDER_CE
					if(m_Entry->bUse_RDW_ERASE)
						{
						if((m_Entry->dwFlags & NO_ERASE) != NO_ERASE)
							{
							InvalidateRect(m_Entry->m_hTheWnd, NULL, TRUE);
							continue;
							}
						}

					if(m_Entry->Art == IS_A_GROUP_WINDOW)
						{
						InvalidateRect(m_Entry->m_hTheWnd, NULL, TRUE);
						continue;
						}
					else if(m_Entry->Art == IS_A_LINE)
						InvalidateRect(m_Entry->m_hTheWnd, NULL, TRUE);
					else if(m_Entry->Art == IS_A_WINDOW || m_Entry->Art == IS_A_SPLITTER)
						InvalidateRect(m_Entry->m_hTheWnd, NULL, TRUE);

#else

					if(m_Entry->bUse_RDW_ERASE)
						{
						if((m_Entry->dwFlags & NO_ERASE) != NO_ERASE)
							{
							refresh = RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN | RDW_FRAME;
							RedrawWindow(m_Entry->m_hTheWnd, 0, 0, refresh);
							continue;
							}
						}
#endif			

					if(m_Entry->Art == IS_A_GROUP_WINDOW)
						{
						RedrawWindow(m_Entry->m_hTheWnd, 0, 0, RDW_INVALIDATE);
						if(m_Entry->m_Group)
							m_Entry->m_Group->RedrawTitleCtrl();
						continue;
						}

					if(m_Entry->Art == IS_A_LINE)
						RedrawWindow(m_Entry->m_hTheWnd, 0, 0, RDW_INVALIDATE);
					if(m_Entry->Art == IS_A_WINDOW || m_Entry->Art == IS_A_SPLITTER)
						RedrawWindow(m_Entry->m_hTheWnd, 0, 0, lRefresh);
					}
				}
			}
		}


	if(m_NoGLLEraseBackGround == false)
		{
		pDC->FillSolidRect(rcClient, GetDlgBKColor());
		pTheWindow->ReleaseDC(pDC);
		}
}

/*********************************************************************/

CLayoutGroupObj *CLayoutGroup::FindGroup(HWND hWnd,LPCTSTR szString)
{
	for(register int i = 0; i < m_Childs.GetSize(); i++)
		{
		if(hWnd)
			{
			if(m_Childs[i]->m_hTheWnd == hWnd)
				return m_Childs[i];
			}
		else
			{
			if(m_Childs[i]->m_Name.CompareNoCase(szString) == 0)
				return m_Childs[i];
			}
		}
	return NULL;
}

/*********************************************************************/

void CLayoutGroup::CalcGroups(CLayoutGroupObj *pGroup)
{
	CLayoutGroupObj *m_Entry;
	register DWORD i;
	bool m_bSplitter = false, m_bShrink = false;

	if(pTheWindow == NULL)
		return;

	if(pGroup == &m_RootGroup)
		{
		pTheWindow->GetClientRect(pGroup->rcAktSize);

		if(m_ViewSize.cx || m_ViewSize.cy)
			{
			pGroup->rcAktSize.right = max(m_ViewSize.cx, pGroup->rcAktSize.right);
			pGroup->rcAktSize.bottom = max(m_ViewSize.cy, pGroup->rcAktSize.bottom);
			}
		}


	if(pGroup->bVisible == false && pGroup->m_Childs.GetSize() == 0)
		return;

	/*********************************************************************/
	// breite/hhe je nach ausrichtung anpassen. min-size bercksichtigen
	/*********************************************************************/

	DWORD dwChildCount = (DWORD)pGroup->m_Childs.GetSize();
	bool m_bWeHaveMaxSizeControls = false;


	/**********************************************************************/


	for(i = 0; i < dwChildCount; i++)
		{
		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			if(m_Entry->bVisible == false)
				continue;

			if(m_Entry->Art == IS_A_LAYOUT_GROUP
				|| m_Entry->Art == IS_A_GROUP_WINDOW
				|| m_Entry->Art == IS_A_SPREADER
				|| m_Entry->Art == IS_A_LINE)
				{
				if(pGroup->Ausrichtung == HGROUP_LAYOUT)
					{
					pGroup->rcAktSize.bottom = max(pGroup->rcAktSize.bottom, pGroup->rcMinSize.bottom);
					m_Entry->rcAktSize.bottom = pGroup->rcAktSize.bottom;
					}
				else
					{
					pGroup->rcAktSize.right = max(pGroup->rcAktSize.right, pGroup->rcMinSize.right);
					m_Entry->rcAktSize.right = pGroup->rcAktSize.right;
					}
				}

			if(m_Entry->Art == IS_A_SPLITTER)
				m_bSplitter = true;

			/**********************************************************************/

			m_Entry->nPercentBackUp = m_Entry->nPercent;
			if(m_Entry->dwMaxSize)
				m_bWeHaveMaxSizeControls = true;
			}
		}

	/*********************************************************************/
	// die gre der fixen ctrl/groups ermitteln
	/*********************************************************************/

	double Width, Height;
	int FixGroups = 0;
	Width = pGroup->rcAktSize.Width();
	Height = pGroup->rcAktSize.Height();

	for(i = 0; i < dwChildCount; i++)
		{
		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			if(m_Entry->bVisible == false)
				continue;

			if(pGroup->Ausrichtung == HGROUP_LAYOUT)
				{
				if(m_Entry->ReSizeHori == false)
					{
					FixGroups++;
					Width -= m_Entry->rcMinSize.Width();
					}
				}
			else
				{
				if(m_Entry->ReSizeVert == false)
					{
					FixGroups++;
					Height -= m_Entry->rcMinSize.Height();
					}
				}
			}
		}


	/************************************************************************
	* Behandlung von MaxSize-Controls
	* Alle Controls die die Max-Gre ereichthaben, mssen aus der prozentualen
	* Berechnung raus. Dazu wird
	* -erst die aktuelle Grer ermittelt
	* -gerft ob es zu gr wrde
	* -die Prozent des Controls aufaddiert
	*  +m_Entry->nPercent auf 0 gesetzt und
	*  +MaxSize von Width / Height abgezogen
	* -die anzahl alle zu groen und festen Controls ermittelt
	************************************************************************/

	if(m_bWeHaveMaxSizeControls)
		{
		double wPercent = 0.0, hPercent = 0.0, nNewPercent = 0.0;
		DWORD dwPercentControls = 0, dwDummy;

		for(i = 0; i < dwChildCount; i++)
			{
			if((m_Entry = pGroup->m_Childs[i]) != NULL)
				{
				if(m_Entry->bVisible == false)
					continue;

				if(pGroup->Ausrichtung == HGROUP_LAYOUT)
					{
					if(m_Entry->ReSizeHori) // keine festen
						{
						if(m_Entry->dwMaxSize) // nur maxsize
							{
							m_Entry->rcAktSize.right = (long) ((Width*m_Entry->nPercent) / 100.0);
							if(GLLGetSizeWidth(m_Entry->dwMaxSize) <= m_Entry->rcAktSize.right)
								{
								wPercent += m_Entry->nPercent;
								m_Entry->nPercent = 0;
								dwPercentControls++;
								//Width -= GLLGetSizeWidth(m_Entry->dwMaxSize);
								}
							}
						}
					else
						dwPercentControls++;
					}
				else
					{
					if(m_Entry->ReSizeVert)
						{
						if(m_Entry->dwMaxSize)
							{
							m_Entry->rcAktSize.bottom = (long) ((Height*m_Entry->nPercent) / 100.0);
							if(GLLGetSizeHeight(m_Entry->dwMaxSize) <= m_Entry->rcAktSize.bottom)
								{
								hPercent += m_Entry->nPercent;
								m_Entry->nPercent = 0;
								dwPercentControls++;
								//Height -= GLLGetSizeHeight(m_Entry->dwMaxSize);
								}
							}
						}
					else
						dwPercentControls++;
					}
				}
			}


		/************************************************************************
		* Width/Height kann nicht in der schleife davor gendert werden.
		************************************************************************/
		for(i = 0; i < dwChildCount; i++)
			{
			if((m_Entry = pGroup->m_Childs[i]) != NULL)
				{
				if(m_Entry->bVisible == false)
					continue;

				if(pGroup->Ausrichtung == HGROUP_LAYOUT)
					{
					if(m_Entry->ReSizeHori && GLLGetSizeWidth(m_Entry->dwMaxSize) && m_Entry->nPercent == 0.0)
						Width -= GLLGetSizeWidth(m_Entry->dwMaxSize);
					}
				else
					{
					if(m_Entry->ReSizeVert && GLLGetSizeHeight(m_Entry->dwMaxSize) && m_Entry->nPercent == 0.0)
						Height -= GLLGetSizeHeight(m_Entry->dwMaxSize);
					}
				}
			}
		/************************************************************************
		* die Control-Anzahl abzglich der Anzahl alle zu groen und festen Controls
		* ergibt die Anzahl der Controls auf die die aufaddierten Prozente verteilt
		* werden mssen.
		************************************************************************/
		dwDummy = dwChildCount - dwPercentControls;
		if(dwDummy && dwPercentControls)
			{
			if(pGroup->Ausrichtung == HGROUP_LAYOUT)
				nNewPercent = wPercent / (dwDummy);
			else
				nNewPercent = hPercent / (dwDummy);


			for(i = 0; i < dwChildCount; i++)
				{
				if((m_Entry = pGroup->m_Childs[i]) != NULL)
					{
					if(m_Entry->bVisible == false)
						continue;

					if(pGroup->Ausrichtung == HGROUP_LAYOUT)
						{
						if(m_Entry->ReSizeHori && m_Entry->nPercent)
							{
							m_Entry->nPercent += nNewPercent;
							}

						}
					else
						{
						if(m_Entry->ReSizeVert && m_Entry->nPercent)
							{
							m_Entry->nPercent += nNewPercent;
							}
						}
					}
				}

			}
		}

	/************************************************************************
	* Ende der MaxSize-Vorarbeit
	************************************************************************/

	/*********************************************************************/
	// ausgleich ermitteln und feststellen, ob die percent-grer die
	// aktuelle grer bersteigt.
	/*********************************************************************/

	int BreiteHoehe = 0, iAusgleich = 0, iGesamtSize = 0, iBorder = 0;

	if(pGroup->Ausrichtung == HGROUP_LAYOUT)
		iBorder = pGroup->rcBorder.left + pGroup->rcBorder.right;
	else
		iBorder = pGroup->rcBorder.top + pGroup->rcBorder.bottom;

	Width -= pGroup->rcBorder.left + pGroup->rcBorder.right;
	Height -= pGroup->rcBorder.top + pGroup->rcBorder.bottom;

	for(i = 0; i < dwChildCount; i++)
		{
		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			m_Entry->rcAktSize.SetRect(0, 0, (long) Width, (long) Height);

			if(m_Entry->bVisible == false)
				continue;


			/*********************************************************************
			** Fixe Controls wieder auf MinSize setzen
			*********************************************************************/

			if(m_Entry->m_TheWnd)
				{
				if(m_Entry->ReSizeHori == false)
					m_Entry->rcAktSize.right = m_Entry->rcMinSize.right;

				if(m_Entry->ReSizeVert == false)
					m_Entry->rcAktSize.bottom = m_Entry->rcMinSize.bottom;
				}


			if(pGroup->Ausrichtung == HGROUP_LAYOUT)
				{
				if(m_Entry->ReSizeHori == false)
					{
					m_Entry->rcAktSize.right = m_Entry->rcMinSize.right;
					}
				else if(GLLGetSizeWidth(m_Entry->dwMaxSize) && m_Entry->nPercent == 0.0)
					{
					m_Entry->rcAktSize.right = GLLGetSizeWidth(m_Entry->dwMaxSize);
					}
				else
					{
					m_Entry->rcAktSize.right = (long) ((Width*m_Entry->nPercent) / 100.0);

					if(m_Entry->rcAktSize.right < m_Entry->rcMinSize.right)
						m_Entry->rcAktSize.right = m_Entry->rcMinSize.right;

					iAusgleich += m_Entry->rcAktSize.right;
					}
				iGesamtSize += m_Entry->rcAktSize.right;
				}
			else
				{
				if(m_Entry->ReSizeVert == false)
					{
					m_Entry->rcAktSize.bottom = m_Entry->rcMinSize.bottom;
					}
				else if(GLLGetSizeHeight(m_Entry->dwMaxSize) && m_Entry->nPercent == 0.0)
					{
					m_Entry->rcAktSize.bottom = GLLGetSizeHeight(m_Entry->dwMaxSize);
					}
				else
					{
					m_Entry->rcAktSize.bottom = (long) ((Height*m_Entry->nPercent) / 100.0);

					if(m_Entry->rcAktSize.bottom < m_Entry->rcMinSize.bottom)
						m_Entry->rcAktSize.bottom = m_Entry->rcMinSize.bottom;

					iAusgleich += m_Entry->rcAktSize.bottom;
					}
				iGesamtSize += m_Entry->rcAktSize.bottom;
				}
			}
		}


	/*********************************************************************/
	// test ob gesamt size gleich group size
	/*********************************************************************/

	int iShrinkSize = 0;

	if(pGroup->Ausrichtung == HGROUP_LAYOUT)
		{
		if(iGesamtSize > pGroup->rcAktSize.right - iBorder)
			{
			m_bShrink = true;
			iShrinkSize = iGesamtSize - (pGroup->rcAktSize.right - iBorder);
			}
		}
	else
		{
		if(iGesamtSize > pGroup->rcAktSize.bottom - iBorder)
			{
			m_bShrink = true;
			iShrinkSize = iGesamtSize - (pGroup->rcAktSize.bottom - iBorder);
			}
		}

	if(m_bShrink && iAusgleich == 0) // das DARF nicht passieren!
		m_bShrink = false;


	/*********************************************************************/

	if(m_bShrink && iAusgleich)
		{
		bool run = true;
		ASSERT(iShrinkSize > 0);
		int iShrinkSize2;

		do
			{
			iShrinkSize2 = iShrinkSize;
			for(register DWORD i2 = 0; i2 < dwChildCount; i2++)
				{
				if((m_Entry = pGroup->m_Childs[i2]) != NULL)
					{
					if(m_Entry->bVisible == false)
						continue;

					if(pGroup->Ausrichtung == HGROUP_LAYOUT)
						{
						if(m_Entry->ReSizeHori)
							{
							if(m_Entry->rcAktSize.right > m_Entry->rcMinSize.right)
								{
								iShrinkSize--;
								m_Entry->rcAktSize.right--;
								}
							}
						}
					else
						{
						if(m_Entry->ReSizeVert)
							{
							if(m_Entry->rcAktSize.bottom > m_Entry->rcMinSize.bottom)
								{
								iShrinkSize--;
								m_Entry->rcAktSize.bottom--;
								}
							}
						}


					if(iShrinkSize <= 0)
						break;
					}
				}

			if(iShrinkSize2 == iShrinkSize || iShrinkSize <= 0)
				{
				run = false;
				break;
				}

			}
		while(run);
		}

	/*********************************************************************/

	BreiteHoehe = (int) ((pGroup->Ausrichtung == HGROUP_LAYOUT) ? Width : Height);

	if(BreiteHoehe > iAusgleich)
		iAusgleich = BreiteHoehe - iAusgleich;
	else
		iAusgleich = 0;



	if(iAusgleich && dwChildCount && (m_Entry = pGroup->m_Childs[0]) != NULL)
		{
		if(pGroup->Ausrichtung == HGROUP_LAYOUT)
			{
			if(m_Entry->ReSizeHori)
				m_Entry->rcAktSize.right += iAusgleich;
			}
		else
			{
			if(m_Entry->ReSizeVert)
				m_Entry->rcAktSize.bottom += iAusgleich;
			}
		}

	//-----------------------------------------------

	if(m_bWeHaveMaxSizeControls)
		{
		for(i = 0; i < dwChildCount; i++)
			{
			if((m_Entry = pGroup->m_Childs[i]) != NULL)
				m_Entry->nPercent = m_Entry->nPercentBackUp;
			}
		}

	//-----------------------------------------------

	for(i = 0; i < dwChildCount; i++)
		{
		if((m_Entry = pGroup->m_Childs[i]) != NULL)
			{
			if(m_Entry->Art == IS_A_LAYOUT_GROUP || m_Entry->Art == IS_A_GROUP_WINDOW)
				{
				if(m_Entry->bVisible == false)
					continue;
				CalcGroups(m_Entry);
				}
			}
		}
}

/*********************************************************************/

void CLayoutGroupObj::InitGroupObj()
{
	rcAktSize.SetRectEmpty();
	rcMinSize.SetRectEmpty();
	rcBorder.SetRectEmpty();
	rcWinSize.SetRectEmpty();
	m_Childs.RemoveAll();

	dwMaxSize = 0;
	Align = 0;
	Ausrichtung = 0;
	Art = 0;
	WinArt = 0;
	Space = 0;
	InitalSpace = 0;
	dwFlags = 0;

	ReSizeHori = true;
	ReSizeVert = true;
	bVisible = true;
	bUse_RDW_ERASE = false;
	bUse_CWnd_Move = false;

	Ausrichtung = VGROUP_LAYOUT;
	pParentGroup = NULL;
	m_hTheWnd = NULL;
	m_TheWnd = NULL;
	m_Group = NULL;
	m_Splitter = NULL;

	WinArt = 0;
	nPercent = 0.0;
	dwFlags = 0;
	InitalSpace = 0;
	ID = 0;
	ReSizeVertInit = -1;
	ReSizeHoriInit = -1;
	m_iInitialWidth = 0;
	m_iInitialHeight = 0;
	m_RootGroup = NULL;
}

/*********************************************************************/

CLayoutGroupObj::CLayoutGroupObj()
{
	InitGroupObj();
}

CLayoutGroupObj::~CLayoutGroupObj()
{

}

/**********************************************************************
***********************************************************************
		CGroupStatic
***********************************************************************
**********************************************************************/

CGroupStatic::CGroupStatic()
{
	m_WinTitle.Empty();
	m_hTitleControl = NULL;
	m_lTextLen = 0;
	bIsDisabled = false;
	m_lFlags = 0;
	m_lTextLenInit = 0;
	m_RootGroup = NULL;
	m_BkColor = -1;

	pBoldFont = NULL;
	m_UseBoldFont = false;

#ifdef _USE_GLL_THEME_
	m_pTheme = NULL;
	hLoadedTheme = NULL;
#endif
}

/**********************************************************************/

CGroupStatic::~CGroupStatic()
{
#ifdef _USE_GLL_THEME_
	if(hLoadedTheme)
		if(m_pTheme)
			m_pTheme->CloseThemeData(hLoadedTheme);

	m_pTheme = NULL;
	hLoadedTheme = NULL;
#endif

	// Member entfernen
	m_Member.RemoveAll();
	if(pBoldFont)
		{
		pBoldFont->DeleteObject();
		delete pBoldFont;
		}
	
	DestroyWindow();
}

/**********************************************************************/

#ifdef _USE_GLL_THEME_
void CGroupStatic::SetThemeHelper(CGLL_Theme_Helper* pTheme)
{
	if(hLoadedTheme && pTheme)
		m_pTheme->CloseThemeData(hLoadedTheme);

	hLoadedTheme = NULL;
	if(pTheme)
		hLoadedTheme = pTheme->OpenThemeData(GetSafeHwnd(), L"BUTTON");

	m_pTheme = pTheme;
}
#endif
/**********************************************************************/

BEGIN_MESSAGE_MAP(CGroupStatic, CButton)
	//{{AFX_MSG_MAP(CGroupStatic)
	ON_WM_PAINT()
	ON_WM_WINDOWPOSCHANGED()
	ON_WM_ENABLE()
	ON_WM_SHOWWINDOW()
	ON_WM_ERASEBKGND()
	ON_WM_SETFOCUS()
	ON_WM_SYSCOLORCHANGE()
	ON_WM_GETDLGCODE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/**********************************************************************/
//#define _NO_FILL_

#ifndef  BP_GROUPBOX
#define BP_GROUPBOX 4
#define GBS_NORMAL 1
#define GBS_DISABLED 2
#endif


void CGroupStatic::PreSubclassWindow()
{
	CButton::PreSubclassWindow();
	ModifyStyle(0, BS_GROUPBOX );

#ifdef _USE_GLL_THEME_
	m_pTheme = NULL;
	hLoadedTheme = NULL;
	CGroupStatic::SetThemeHelper(theGLLExternTheme);
#endif
}

/**********************************************************************/

void CGroupStatic::RedrawTitleCtrl()
{
	if(m_hTitleControl && ::IsWindowVisible(m_hTitleControl))
		::RedrawWindow(m_hTitleControl,0,0,RDW_INVALIDATE|RDW_UPDATENOW|RDW_FRAME);
}

/**********************************************************************/





/**********************************************************************/

void CGroupStatic::GroupPaint(CDC *dc, bool bIsAMember)
{
	CFont *pFont = NULL;
	long lTextTop, lBackUp = 0, lTextWidth = 0
#ifndef UNDER_CE //Pedant - aber die Warnung strt mich - irgendwie
		,nStateFlag
#endif
		;
	bool bLineWithText = false;
	CMemDCLayout *memDC = NULL;
	CRect	winRect, winClip, winBox;
	COLORREF m_crBackground = m_RootGroup->GetDlgBKColor();
	long m_GLL_GroupBoxBorderColor = m_RootGroup->GetGroupBoxColor();

	if(m_BkColor != -1)
		m_crBackground = m_BkColor;

	/**********************************************************************/

	// Nur wo es gebraucht wird
	if(m_UseBoldFont && pBoldFont == NULL)
		{
		LOGFONT lf;
		CFont::FromHandle((HFONT) GetStockObject(DEFAULT_GUI_FONT))->GetLogFont(&lf);
		pBoldFont = new CFont();

		GLLASSERT(pBoldFont);
		lf.lfWeight = FW_BOLD;
		pBoldFont->CreateFontIndirect(&lf);
		}

	/**********************************************************************/


	GetWindowRect(&winRect);
	AKScreenToClient(GetSafeHwnd(), &winRect);

	lTextTop = winRect.top;

	if(m_WinTitle.IsEmpty() == false)
		{
		pFont = GetFont();

		if((m_lFlags & CENTER_TEXT) ||
			(m_lFlags & LEFT_TEXT) ||
			(m_lFlags & RIGHT_TEXT))
			{
			pFont = GetParent()->GetFont();
			bLineWithText = true;
			}
		}

	if(m_UseBoldFont)
		pFont = pBoldFont;

	if(m_Member.GetSize())
		{
		HWND hWnd;
		dc->GetClipBox(&winClip);

		/*
			Um den Text auf der Linie v. zu zentrieren
			*/
		if(pFont) // Nur wenn in m_WinTitle was steht
			{
			LOGFONT LogFont;
			pFont->GetLogFont(&LogFont);
			lTextWidth = LogFont.lfHeight;
			if(lTextWidth > 0)
				{
				lTextWidth = -lTextWidth;
				}

			lTextTop -= ((lTextWidth) / 2) + 2;
			if(m_UseBoldFont)
				lTextWidth -= lTextWidth / 3;
			}
		else
			if(m_hTitleControl == 0)
				lTextTop += 1;


		if(bIsAMember == false)
			{
			/*
				Ist RootGroup oder kein 'IsMember'
				oder normales OnPaint()
				*/
#ifndef _NO_FILL_
			memDC = new CMemDCLayout(dc, winRect);
#endif
			}
		else
			{
			/*
				Neuzeichnen kommt von der RootCGroupStatic.
				Also bergebenen CMemDCLayout nutzen
				*/
			memDC = (CMemDCLayout*) dc;
			}

		/*
			Alle 'Member' ausschneiden.
			*/
#ifndef _NO_FILL_
		for(int i = 0; i < m_Member.GetSize(); i++)
			{
			hWnd = (HWND) m_Member.GetAt(i);
			ASSERT(hWnd);

			if(hWnd && ::IsWindowVisible(hWnd))
				{
				::GetWindowRect(hWnd, &winBox);
				AKScreenToClient(GetSafeHwnd(), &winBox);
				dc->ExcludeClipRect(&winBox);
				//	::InvalidateRect(hWnd, NULL, false); 
				}
			}


		/*
			Verhindert flackern des Textes und des Rahmens.
			Es wird ja erst gelscht. Dann der Rahmen gezeichnet und
			anschlieend der Text rbergebgelt - das flackert!
			*/
		// Kse blitten. Na, bei den Lchern im CRect ;-)


		

		if(m_RootGroup)
			memDC->FillSolidRect(winRect, m_crBackground); //m_RootGroup->GetDlgBKColor());
#else
		memDC = (CMemDCLayout*)dc; 
#endif		


		

		lBackUp = winRect.top;
		winRect.top = lTextTop + 2;
		winRect.bottom -= 2;

		// Rahmen zeichnen


#ifdef _USE_GLL_THEME_
		if(m_pTheme)
			{
			if(m_GLL_GroupBoxBorderColor != -1 || hLoadedTheme == NULL)
				goto LABEL_Failed1;

			if(m_pTheme->DrawThemeBackground(hLoadedTheme, GetSafeHwnd(), memDC->m_hDC, BP_GROUPBOX, GBS_NORMAL, &winRect, NULL, false) == S_FALSE)
				goto LABEL_Failed1;
			}
		else
#endif
			{
LABEL_Failed1:
			if(m_GLL_GroupBoxBorderColor == -1)
				memDC->DrawEdge(&winRect, EDGE_ETCHED, BF_RECT);
			else
				{
				memDC->Draw3dRect(winRect, m_GLL_GroupBoxBorderColor, m_GLL_GroupBoxBorderColor);
				memDC->SetBkColor(m_crBackground);
				}
			}

		//memDC->FillSolidRect(winRect, RGB(255, 0, 0));

		if(pFont && !m_hTitleControl) // Titeltext oder TitelControl
			{
			CString m_Text;
			CFont *pBackFont = NULL;
			pBackFont = memDC->SelectObject(pFont);

			// Text 'centern'
			winRect.top = lBackUp;
			winRect.left -= lTextWidth;
			winRect.right += lTextWidth;

			// Space vor und hinter dem Text.
			m_Text = _T(" ") + m_WinTitle + _T(" ");


			if(bIsDisabled)
				{
				memDC->DrawText(m_Text, winRect, DT_LEFT);
#ifndef UNDER_CE
				// MFC for Windows CE does not support the following methods of the CDC class: [..] DrawState [..]
				nStateFlag = DSS_DISABLED;
				}
			else
				nStateFlag = DSS_NORMAL;

			if(m_UseBoldFont)
				memDC->SetTextColor(GLL_LightenColor(GetSysColor(COLOR_BTNTEXT), 0.3));

			memDC->DrawState(
				CPoint(winRect.left, winRect.top),
				CSize(0, 0),
				m_Text, DST_PREFIXTEXT | nStateFlag,
				TRUE, 0, (CBrush*) NULL);
			memDC->SelectObject(pBackFont);
#else
			}
#endif
			}

		if(m_hTitleControl && ::IsWindow(m_hTitleControl))
			{
			CRect titleRect;

			if(m_lTextLen == 0)
				{
				TCHAR str[257] = { 0 };
				CString m_TitleText = _T("");
				CSize m_Size;
				::GetWindowText(m_hTitleControl, str, 255);

				for(unsigned int i = 0; i < _tcslen(str); i++)
					{
					if(str[i] != _T('&'))
						m_TitleText += str[i];
					}

				if(pFont)
					{
					CFont *pBackFont = NULL;
					pBackFont = memDC->SelectObject(pFont);
					m_Size = memDC->GetTextExtent(m_TitleText);
					m_lTextLen = m_Size.cx;

					m_lTextLen += n20;

					memDC->SelectObject(pBackFont);
					}
				}



			GetWindowRect(&winRect);
			AKScreenToClient(GetParent()->GetSafeHwnd(), &winRect);

			::GetWindowRect(m_hTitleControl, &titleRect);

			AKScreenToClient(GetSafeHwnd(), &titleRect);
			winRect.left += 15;
			winRect.top -= 1; //-2 Fix 2.5 (CButton)


			::MoveWindow(m_hTitleControl, winRect.left, winRect.top,
				m_lTextLenInit ? m_lTextLenInit : m_lTextLen,
				titleRect.Height(), true);
			// Vor dem Control etwas von der Linie lschen
			// ... sieht besser aus

			memDC->FillSolidRect(
				8, 0, 10, titleRect.Height() - 2, m_crBackground);

			// und hinter dem Text
			memDC->FillSolidRect(
				10 + titleRect.Width(), 0,
				10, titleRect.Height() - 2, m_crBackground);


			/*
			char g[255];
			::GetWindowText(m_hTitleControl,g,200);
			memDC->DrawText(g,winRect,DT_TOP|DT_LEFT);
			*/
			}
#ifndef _NO_FILL_
		if(bIsAMember == false)
			delete memDC;
#endif
		memDC = NULL; // Nicht ntig. Aber besser...
		}
	else  // Keine Member. Sollte Linie sein...
		{
		// Control-Bereich lschen
		dc->FillSolidRect(winRect, m_crBackground);

		// Rahmen (eher Linie) zeichnen

		if(winRect.Height() > winRect.Width())
			{
			//vertikal
			winRect.left += winRect.Width() / 2 - 1;
			winRect.right = winRect.left + 2;

#ifdef _USE_GLL_THEME_
			if(m_pTheme)
				{
				if(m_GLL_GroupBoxBorderColor != -1 || hLoadedTheme == NULL)
					goto LABEL_Failed2;
				m_pTheme->DrawThemeEdge(hLoadedTheme, dc->m_hDC, BP_GROUPBOX, GBS_NORMAL, &winRect, EDGE_ETCHED, BF_LEFT | BF_RIGHT, NULL);
				}
			else
#endif		
				{

LABEL_Failed2:
				if(m_GLL_GroupBoxBorderColor == -1)
					dc->DrawEdge(&winRect, EDGE_ETCHED, BF_LEFT | BF_RIGHT);
				else
					{
					dc->FillSolidRect(winRect.left, winRect.top, 1, winRect.Height(), m_GLL_GroupBoxBorderColor);
					dc->SetBkColor(m_crBackground);
					}
				}
			}
		else
			{
			// das Gegenteil (Horiz)
			winRect.top += winRect.Height() / 2 - 2;
			winRect.bottom = winRect.top + 2;

#ifdef _USE_GLL_THEME_
			if(m_pTheme)
				{
				if(m_GLL_GroupBoxBorderColor != -1 || hLoadedTheme == NULL)
					goto LABEL_Failed3;
				m_pTheme->DrawThemeEdge(hLoadedTheme, dc->m_hDC, BP_GROUPBOX, GBS_NORMAL, &winRect, EDGE_ETCHED, BF_TOP | BF_BOTTOM, NULL);
				}
			else
#endif
				{
LABEL_Failed3:
				if(m_GLL_GroupBoxBorderColor == -1)
					dc->DrawEdge(&winRect, EDGE_ETCHED, BF_TOP | BF_BOTTOM);
				else 
					{
					dc->FillSolidRect(winRect.left, winRect.bottom-1, winRect.Width(), 1, m_GLL_GroupBoxBorderColor);
					dc->SetBkColor(m_crBackground);
					}
				}

			if(bLineWithText)
				{
				if(pFont) // Nur wenn in m_WinTitle was steht
					{
					long lState = DT_CENTER;
					CString m_Text;
					LOGFONT LogFont;
					pFont->GetLogFont(&LogFont);
					lTextTop = ((lTextWidth = LogFont.lfHeight) / 2);

					CFont *pBackFont = NULL;
					pBackFont = dc->SelectObject(pFont);
					m_Text = _T(" ") + m_WinTitle + _T(" ");
					winRect.top -= abs(lTextTop) + 1;
					winRect.left += 10;
					winRect.right -= 10;
					winRect.bottom += abs(lTextTop) + 2;

					if(m_lFlags & CENTER_TEXT)
						lState = DT_CENTER;
					if(m_lFlags & LEFT_TEXT)
						lState = DT_LEFT;
					if(m_lFlags & RIGHT_TEXT)
						lState = DT_RIGHT;

					if(m_UseBoldFont)
						dc->SetTextColor(GLL_LightenColor(GetSysColor(COLOR_BTNTEXT), 0.3));
					dc->DrawText(m_Text, m_Text.GetLength(), winRect, DT_NOPREFIX | lState);//|DT_CALCRECT);
					dc->SelectObject(pBackFont);
					}
				}
			}
		}
}

/**********************************************************************/

void CGroupStatic::OnSysColorChange()
{
	if(m_BkColor != -1 && GetParent())
		{
		LONG color = (LONG) GetParent()->SendMessage(WM_GET_LINE_BKGCOLOR_, 1, (LPARAM)this);
		if(color >= 1)
			m_BkColor = color;
		else
			m_BkColor = m_RootGroup->GetDlgBKColor();
		Invalidate();
		}
}

/**********************************************************************/

void CGroupStatic::OnPaint() 
{
	CPaintDC dc(this);
	GroupPaint(&dc,false);
}

/**********************************************************************/

BOOL CGroupStatic::OnEraseBkgnd(CDC* /*pDC*/) 
{
	return true;
}

/**********************************************************************/

UINT CGroupStatic::OnGetDlgCode() 
{
	return DLGC_STATIC;
}

/**********************************************************************/

void CGroupStatic::OnSetFocus(CWnd* pOldWnd) 
{
	if(pOldWnd)
		pOldWnd->SetFocus(); // Keinen Fokus fr das Teil
}

/**********************************************************************/

void CGroupStatic::OnWindowPosChanged(WINDOWPOS FAR* lpwndpos) 
{
	CButton::OnWindowPosChanged(lpwndpos);
	OnPaint();	
}

/**********************************************************************/

void CGroupStatic::SetTitle(CString m_Title)
{
	m_WinTitle = m_Title;
}

/**********************************************************************/

void CGroupStatic::RemoveAllMember()
{
	if(m_Member.GetSize())
		m_Member.RemoveAll();
}

/**********************************************************************/

void CGroupStatic::AddMember(UINT nID)
{
	CWnd *pWnd;

	pWnd = GetParent()->GetDlgItem(nID);
	GLLASSERT(pWnd);
	
	m_Member.Add(pWnd->GetSafeHwnd());
}

/**********************************************************************/

void CGroupStatic::AddMember(CWnd *pWnd)
{
	GLLASSERT(pWnd);
	m_Member.Add(pWnd->GetSafeHwnd());
}

/**********************************************************************/

void CGroupStatic::AddMember(HWND hWnd)
{
	GLLASSERT(hWnd);
	m_Member.Add(hWnd);

}
/**********************************************************************/

long CGroupStatic::SetTitleCtrl(CWnd *pWnd)
{
	GLLASSERT_N(pWnd);
	bool m_bDummy = false, m_bComboBox = false;
	m_hTitleControl = pWnd->GetSafeHwnd();

	GetControlTyp(pWnd, m_bComboBox, m_bDummy, m_bDummy);
	if(m_bComboBox)
		{
		CRect titleRect;
		::GetWindowRect(m_hTitleControl, &titleRect);
		m_lTextLenInit = titleRect.Width();
		}

	m_Member.Add(pWnd->GetSafeHwnd()); // Unterbindet das Flackern des TitleControls
	m_WinTitle = _T(" "); // "<SPACE>" nicht ""

	return m_bComboBox;
}
/**********************************************************************/

long CGroupStatic::SetTitleCtrl(UINT nID)
{
	CButton *pWnd;
	bool m_bDummy = false, m_bComboBox = false;
	pWnd = (CButton*) GetParent()->GetDlgItem(nID);
	GLLASSERT_N(pWnd);

	m_hTitleControl = pWnd->GetSafeHwnd();
	m_Member.Add(pWnd->GetSafeHwnd());  // Unterbindet das Flackern des TitleControls
	m_WinTitle = _T(" "); // "<SPACE>" nicht ""

	GetControlTyp(pWnd, m_bComboBox, m_bDummy, m_bDummy);
	if(m_bComboBox)
		{
		CRect titleRect;
		::GetWindowRect(m_hTitleControl, &titleRect);
		m_lTextLenInit = titleRect.Width();
		}
	return m_bComboBox;
}

/**********************************************************************/

void CGroupStatic::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CButton::OnShowWindow(bShow, nStatus);
	if(m_hTitleControl)
		::ShowWindow(m_hTitleControl, bShow);
}

/**********************************************************************/

void CGroupStatic::OnEnable(BOOL bEnable) 
{
	bIsDisabled = !bEnable;
	RedrawWindow();
}

/*********************************************************************/

#ifndef WS_EX_LAYOUTRTL
#define WS_EX_LAYOUTRTL                    0x00400000L
#endif

DWORD AKGetExStyle(HWND m_phWnd)
{
	ASSERT(::IsWindow(m_phWnd));
	return (DWORD)GetWindowLong(m_phWnd, GWL_EXSTYLE);
}

/**********************************************************************/

void AKScreenToClient(HWND m_phWnd, LPRECT lpRect)
{
	ASSERT(::IsWindow(m_phWnd));
	::ScreenToClient(m_phWnd, (LPPOINT) lpRect);
	::ScreenToClient(m_phWnd, ((LPPOINT) lpRect) + 1);
	if(AKGetExStyle(m_phWnd) & WS_EX_LAYOUTRTL)
		CRect::SwapLeftRight(lpRect);
}

/**********************************************************************/
/**********************************************************************
***********************************************************************
		CGroupSplitter
***********************************************************************
**********************************************************************/

CGroupSplitter::CGroupSplitter()
{
	bIsHori = false;
	m_Parent = NULL;
	pTopGroup = NULL;
	pBottomGroup = NULL;
	bRealTimeLayout = true;
	m_LayoutGroup = NULL;
	m_bIsThemeActive = 0;
	m_BackGroundColor = -1;
}

/**********************************************************************/

CGroupSplitter::~CGroupSplitter()
{
	//UnsubclassWindow();
	DestroyWindow();
}

/**********************************************************************/

BEGIN_MESSAGE_MAP(CGroupSplitter, CWnd)
	//{{AFX_MSG_MAP(CGroupSplitter)
	ON_WM_LBUTTONDOWN()
	ON_WM_SETCURSOR()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/**********************************************************************/

void CGroupSplitter::CalcPercent(double diff, bool m_UpdateWindow)
{
	long retval = 0;
	double proz, w1, w2;
	bool bDoIt = false, IsPositiv = false;
	CRect mRect;

	m_Parent->GetWindowRect(mRect);

	if(diff == 0)
		return;

	if(bIsHori)
		{
		if(diff > 0)
			IsPositiv = true;
		else
			diff = fabs(diff);

		w1 = pTopGroup->rcAktSize.Width();
		w2 = pBottomGroup->rcAktSize.Width();

		proz = 100 * (diff) / (w1 + w2);

		if(IsPositiv)
			{
			pBottomGroup->nPercent -= proz;
			pTopGroup->nPercent += proz;
			}
		else
			{
			pTopGroup->nPercent -= proz;
			pBottomGroup->nPercent += proz;
			}

		m_lFirstPercent = pTopGroup->nPercent;
		bDoIt = true;
		}
	else
		{
		if(diff > 0)
			IsPositiv = true;
		else
			diff = fabs(diff);


		w1 = pTopGroup->rcAktSize.Height();
		w2 = pBottomGroup->rcAktSize.Height();

		proz = 100 * (diff) / (w1 + w2);

		if(IsPositiv)
			{
			pBottomGroup->nPercent -= proz;
			pTopGroup->nPercent += proz;
			}
		else
			{
			pTopGroup->nPercent -= proz;
			pBottomGroup->nPercent += proz;
			}

		m_lFirstPercent = pTopGroup->nPercent;
		bDoIt = true;
		}

	int w, h;
	w = mRect.Width();
	h = mRect.Height();


	if(m_LayoutGroup->lTheWindowIsA == IS_CFormViewLayout)
		{
		retval = 0; proz = 0;
		CSize size;
		CFormView *pFView = (CFormView*) m_Parent;
		size = pFView->GetTotalSize();
		CPoint m_ViewPosition = pFView->GetScrollPosition();
		m_Parent->GetClientRect(mRect);
		w = mRect.Width();
		h = mRect.Height();

		w = __max(w, size.cx);
		h = __max(h, size.cy);

		if(m_LayoutGroup && bDoIt)
			{
			m_LayoutGroup->CalcGroups(&m_LayoutGroup->m_RootGroup);
			m_LayoutGroup->SetPosGroups(&m_LayoutGroup->m_RootGroup,
				m_LayoutGroup->m_RootGroup.rcBorder.left - m_ViewPosition.x,
				m_LayoutGroup->m_RootGroup.rcBorder.top - m_ViewPosition.y);
			m_LayoutGroup->MoveWindows();

			if(m_UpdateWindow)
				m_Parent->UpdateWindow();
			}
		}
	else
		{
		if(m_LayoutGroup && bDoIt)
			{
			m_LayoutGroup->Size(pTopGroup->pParentGroup);
			}

		if(m_UpdateWindow)
			m_Parent->UpdateWindow();
		}

	return;
}

/**********************************************************************/

void CGroupSplitter::OnLButtonDown(UINT nFlags, CPoint point) 
{
	long retval = 0;
	CLayoutGroupObj *pPrevGrp;

	UNUSED_ALWAYS(nFlags);

	if(pTopGroup == NULL || pBottomGroup == NULL)
		return;

	pPrevGrp = pTopGroup->pParentGroup;

	if(pTopGroup->nPercent == 0.0 || pBottomGroup->nPercent == 0.0)
		{
		pTopGroup->nPercent = pBottomGroup->nPercent = 50.0;
		}

	if(bIsHori)
		{
		if((retval = HoriSplitting(point)) != 0)
			CalcPercent(retval);
		}
	else
		{
		if((retval = VertSplitting(point)) != 0)
			CalcPercent(retval);
		}
}

/**********************************************************************/

BOOL CGroupSplitter::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	UNUSED_ALWAYS(pWnd);
	UNUSED_ALWAYS(nHitTest);
	UNUSED_ALWAYS(message);

	if(pTopGroup == NULL || pBottomGroup == NULL)
		{
		if(::SetCursor(AfxGetApp()->LoadCursor(AFX_IDC_NODROPCRSR)) == NULL)
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_CROSS));
		return true;
		}

	if(bIsHori)
		{
		if(::SetCursor(AfxGetApp()->LoadCursor(AFX_IDC_HSPLITBAR)) == NULL)
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_SIZEWE));
		}
	else
		{
		if(::SetCursor(AfxGetApp()->LoadCursor(AFX_IDC_VSPLITBAR)) == NULL)
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_SIZENS));
		}

	return true;
}

/**********************************************************************/
#define COLOR_GRADIENTACTIVECAPTION 27

COLORREF CGroupSplitter::GetBkGrColor()
{
	if(m_BackGroundColor == -1)
		return m_LayoutGroup->GetDlgBKColor();
	else
		return m_BackGroundColor;
}

/**********************************************************************/

void CGroupSplitter::OnPaint() 
{
	CPaintDC dc(this); 
	CRect winRect;
	GetWindowRect(&winRect);

	AKScreenToClient(GetSafeHwnd(), &winRect);

	dc.FillSolidRect(winRect, GetBkGrColor());
	if(bIsHori)
		{
		winRect.left += 2;
		winRect.right -= 2;
		}
	else
		{
		winRect.top += 2;
		winRect.bottom -= 2;
		}

	dc.DrawFrameControl(&winRect, DFC_BUTTON, DFCS_BUTTONPUSH | DFCS_PUSHED);
	winRect.left++;
	winRect.right--;
	winRect.top++;
	winRect.bottom--;

	if(m_bIsThemeActive)
		{
		if(m_bIsThemeActive == 1)
			dc.FillSolidRect(winRect, ::GetSysColor(COLOR_GRADIENTACTIVECAPTION));
		if(m_bIsThemeActive == 2)
			dc.FillSolidRect(winRect, ::GetSysColor(COLOR_HIGHLIGHT));
		return;
		}

	dc.FillSolidRect(winRect, ::GetSysColor(COLOR_HIGHLIGHT));
}

/**********************************************************************/

long CGroupSplitter::VertSplitting(CPoint point)
{
	if (::GetCapture() != NULL) 
		return 0;

	CRect rectMouseClip;
	GetWindowRect(&rectMouseClip);

	if(GetGroupRect(&rectMouseClip) == 0)
		return 0;

	::ClipCursor(&rectMouseClip);

	SetCapture();
	ASSERT(this == CWnd::GetCapture());

	CDC* pDrawDC;
	pDrawDC = m_Parent->GetWindowDC();
	ASSERT_VALID(pDrawDC);

	CRect rectOrg, rectCur, rectOld, rectWin;
	CSize sizeBar;

	m_Parent->GetClientRect(rectOld);
	m_Parent->GetWindowRect(rectWin);

	AKScreenToClient(m_Parent->GetSafeHwnd(), &rectWin);

	rectWin -= rectOld;
	rectWin.left = abs(rectWin.left);
	rectWin.top = abs(rectWin.top);

	GetWindowRect(rectOrg);
	sizeBar = CSize(rectOrg.Width(), rectOrg.Height());
	int curX, curY;
	int xDiff, yDiff = 0;


	AKScreenToClient(m_Parent->GetSafeHwnd(), &rectOrg);

	rectOrg.OffsetRect(rectWin.left, rectWin.top);

	if(bRealTimeLayout == false)
		pDrawDC->DrawDragRect(&rectOrg, sizeBar, NULL, sizeBar);
	rectOld = rectCur = rectOrg;
	int iOldPos = -1;

	for(;;)
		{
		MSG msg;
		VERIFY(::GetMessage(&msg, NULL, 0, 0));

		if(CWnd::GetCapture() != this)
			break;

		switch(msg.message)
			{

			case WM_MOUSEMOVE:
				curX = (int) (short) GLLGetSizeWidth(msg.lParam);
				curY = (int) (short) GLLGetSizeHeight(msg.lParam);

				xDiff = curX - point.x;
				yDiff = curY - point.y;

				rectCur = rectOrg;
				rectCur.top += yDiff;
				rectCur.bottom += yDiff;
				if(bRealTimeLayout == false)
					pDrawDC->DrawDragRect(&rectCur, sizeBar, &rectOld, sizeBar);
				rectOld = rectCur;

				if(yDiff != 0 && bRealTimeLayout)
					if(iOldPos != yDiff)
						CalcPercent(yDiff, true);
				iOldPos = yDiff;
				break;


			case WM_KEYDOWN:
				if(msg.wParam != VK_ESCAPE)
					break;
			case WM_LBUTTONUP:
			case WM_RBUTTONDOWN:
				goto ExitLoop;

			default:
				DispatchMessage(&msg);
				break;
			}
		}

ExitLoop:
	if(bRealTimeLayout == false)
		pDrawDC->DrawDragRect(&rectCur, sizeBar, NULL, sizeBar);

	m_Parent->ReleaseDC(pDrawDC);
	ReleaseCapture();
	::ClipCursor(NULL);

	return yDiff;
}

/**********************************************************************/

long CGroupSplitter::HoriSplitting(CPoint point)
{
	if (::GetCapture() != NULL)
		return 0;

	CRect rectMouseClip;
	GetWindowRect(&rectMouseClip);
	if(GetGroupRect(&rectMouseClip) == 0)
		return 0;

	::ClipCursor(&rectMouseClip);

	SetCapture();
	ASSERT(this == CWnd::GetCapture());

	CDC* pDrawDC;
	pDrawDC = m_Parent->GetWindowDC();
	ASSERT_VALID(pDrawDC);

	int curX, curY;
	int xDiff, yDiff;
	CRect rectOrg, rectCur, rectOld, rectWin;
	CSize sizeBar;

	m_Parent->GetClientRect(rectOld);
	m_Parent->GetWindowRect(rectWin);

	AKScreenToClient(m_Parent->GetSafeHwnd(), &rectWin);

	rectWin -= rectOld;
	rectWin.left = abs(rectWin.left);
	rectWin.top = abs(rectWin.top);

	GetWindowRect(rectOrg);
	rectMouseClip.OffsetRect(rectOld.left, rectOld.top + 100);
	sizeBar = CSize(rectOrg.Width(), rectOrg.Height());

	AKScreenToClient(m_Parent->GetSafeHwnd(), &rectOrg);

	rectOrg.OffsetRect(rectWin.left, rectWin.top);
	if(bRealTimeLayout == false)
		pDrawDC->DrawDragRect(&rectOrg, sizeBar, NULL, sizeBar);

	rectOld = rectCur = rectOrg;
	xDiff = yDiff = 0;

	int iOldPos = -1;

	for(;;)
		{
		MSG msg;
		VERIFY(::GetMessage(&msg, NULL, 0, 0));

		if(CWnd::GetCapture() != this)
			break;

		switch(msg.message)
			{
			case WM_MOUSEMOVE:
				curX = (int) (short) GLLGetSizeWidth(msg.lParam);
				curY = (int) (short) GLLGetSizeHeight(msg.lParam);

				xDiff = curX - point.x;
				yDiff = curY - point.y;

				rectCur = rectOrg;
				rectCur.left += xDiff;
				rectCur.right += xDiff;
				if(bRealTimeLayout == false)
					pDrawDC->DrawDragRect(&rectCur, sizeBar, &rectOld, sizeBar);
				rectOld = rectCur;

				if(xDiff != 0 && bRealTimeLayout)
					if(iOldPos != xDiff)
						CalcPercent(xDiff, true);
				iOldPos = xDiff;
				break;

			case WM_KEYDOWN:
				if(msg.wParam != VK_ESCAPE)
					break;
			case WM_LBUTTONUP:
			case WM_RBUTTONDOWN:
				goto ExitLoop;

			default:
				DispatchMessage(&msg);
				break;
			}
		}

ExitLoop:
	if(bRealTimeLayout == false)
		pDrawDC->DrawDragRect(&rectCur, sizeBar, NULL, sizeBar);

	m_Parent->ReleaseDC(pDrawDC);
	ReleaseCapture();
	::ClipCursor(NULL);

	return xDiff;
}

/**********************************************************************/

void CGroupSplitter::SetTopBottomGroups(CLayoutGroupObj *pTopGrp ,CLayoutGroupObj *pBottomGrp)
{
	pTopGroup = pTopGrp;
	pBottomGroup = pBottomGrp;
	m_bIsThemeActive = AKIsThemeActive();
}

/**********************************************************************/

void CGroupSplitter::ReInitTopBottomGroups()
{
	if(pBottomGroup && pTopGroup)
		{
		if(pBottomGroup->bVisible && pTopGroup->bVisible)
			{
			pBottomGroup->nPercent = 100 - m_lFirstPercent;
			pTopGroup->nPercent = m_lFirstPercent;
			EnableWindow(true);
			}

		else // Fix 2.3.3
			{
			if(pBottomGroup->bVisible)
				{
				pBottomGroup->nPercent = 100;
				pTopGroup->nPercent = 0;
				EnableWindow(false);
				}
			if(pTopGroup->bVisible)
				{
				pBottomGroup->nPercent = 0;
				pTopGroup->nPercent = 100;
				EnableWindow(false);
				}
			}
		}
}

/**********************************************************************/

bool CGroupSplitter::GetGroupRect(CRect *mRect)
{
	if(pTopGroup == NULL || pBottomGroup == NULL)
		return false;
	
	mRect->left -= ((pTopGroup->rcAktSize.Width()));
	mRect->top -= ((pTopGroup->rcAktSize.Height()));
	mRect->right += ((pBottomGroup->rcAktSize.Width()));
	mRect->bottom += ((pBottomGroup->rcAktSize.Height()));

	if(bIsHori)
		{
		int w = AKGetWindowWidth(this) / 2;
		mRect->left += ((pTopGroup->rcMinSize.Width()) + w);
		mRect->right -= ((pBottomGroup->rcMinSize.Width()) + w);
		if(mRect->right <= mRect->left)
			return false;
		}
	else
		{
		int h = AKGetWindowHeight(this) / 2;
		mRect->top += ((pTopGroup->rcMinSize.Height()) + h);
		mRect->bottom -= ((pBottomGroup->rcMinSize.Height()) + h);
		if(mRect->bottom <= mRect->top)
			return false;
		}
	return true;
}

/**********************************************************************/


#ifndef UNDER_CE
// WINDOWPLACEMENT and all functions around it do not exist on CE
// INI-Files do not exist on CE
// All Windows are full screen - so why bother?
/**********************************************************************/

#ifndef WPF_ASYNCWINDOWPLACEMENT
#define WPF_ASYNCWINDOWPLACEMENT    0x0004
#endif /*WPF_ASYNCWINDOWPLACEMENT */

CRect GrowSize(CRect rc, DWORD dwGrowSizeGLL)
{
	if(dwGrowSizeGLL)
		{
		DWORD sizex, sizey;
		sizex = GLLGetSizeWidth(dwGrowSizeGLL);
		sizey = GLLGetSizeHeight(dwGrowSizeGLL);
		if(sizex > 250) //250% Max
			sizex = 250;
		if(sizey > 250) //250% Max
			sizey = 250;
		sizex = sizex * rc.Width() / 100;
		sizey = sizey * rc.Height() / 100;

		rc.InflateRect(sizex / 2, sizey / 2);
		}
	return rc;
}

/**********************************************************************/

int RegLoadSetSize(CWnd *m_pWnd, LPCTSTR szString, long m_mode, int Type, DWORD dwGrowSizeGLL)
{
	WINDOWPLACEMENT wp = {0}, m_WP = {0};
	ASSERT(m_pWnd);
	int w, h;
	bool m_SetWindowPos = false;
	CWinApp *pApp = NULL;

	if(m_pWnd == NULL)
		return false;

	if(szString == NULL)
		return false;

	pApp = AfxGetApp();  // wenn das nicht klapp, aua!
	if(pApp == NULL)
		return false;

	//-----------------------------------
	// fix 2.0.7
	long lZumErstenMal = pApp->GetProfileInt(szString, _T("MinPositionX"), 4001);

	if(lZumErstenMal != 4001)
		lZumErstenMal = 0;

	/*
	Type = 3 = PropSheet
	hier mssen eh noch die PropPages ihren Senf dazugeben.
	alles hier, wre verschenkte Zeit.
	*/
	if(lZumErstenMal && Type == _RGL_TYPE_PROPSHEET_)
		{
		return 2;
		}
	//-----------------------------------

	CRect rcTemp;
	CRect rcScreen(0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));


	m_WP.length = sizeof(wp);

	m_pWnd->GetWindowPlacement(&wp);

	//Das macht unter xp murx, darum auf 300x200 setzen 
	//(wird nachher eh neu gesetzt)

	if(Type == _RGL_TYPE_PROPSHEET_)
		{
		wp.rcNormalPosition.left = pApp->GetProfileInt(szString, _T("Left"), wp.rcNormalPosition.left);
		wp.rcNormalPosition.top = pApp->GetProfileInt(szString, _T("Top"), wp.rcNormalPosition.top);

		if(m_mode & LOAD_SIZE)
			{
			wp.rcNormalPosition.right = pApp->GetProfileInt(szString, _T("Right"), wp.rcNormalPosition.right);
			wp.rcNormalPosition.bottom = pApp->GetProfileInt(szString, _T("Bottom"), wp.rcNormalPosition.bottom);
			}
		else
			{
			wp.rcNormalPosition.right = wp.rcNormalPosition.left + 300;
			wp.rcNormalPosition.bottom = wp.rcNormalPosition.top + 200;
			}
		}

	w = wp.rcNormalPosition.right - wp.rcNormalPosition.left;
	h = wp.rcNormalPosition.bottom - wp.rcNormalPosition.top;

	m_WP.length = sizeof(m_WP);

	m_WP.showCmd =
		pApp->GetProfileInt(szString, _T("ShowCmd"), wp.showCmd);

	m_WP.flags =
		pApp->GetProfileInt(szString, _T("Flags"), wp.flags);

	m_WP.ptMinPosition.x =
		pApp->GetProfileInt(szString, _T("MinPositionX"), wp.ptMinPosition.x);
	m_WP.ptMinPosition.y =
		pApp->GetProfileInt(szString, _T("MinPositionY"), wp.ptMinPosition.y);
	m_WP.ptMaxPosition.x =
		pApp->GetProfileInt(szString, _T("MaxPositionX"), wp.ptMaxPosition.x);

	m_WP.ptMaxPosition.y =
		pApp->GetProfileInt(szString, _T("MaxPositionY"), wp.ptMaxPosition.y);


	m_WP.rcNormalPosition.left = wp.rcNormalPosition.left;
	m_WP.rcNormalPosition.top = wp.rcNormalPosition.top;


	if(m_mode & LOAD_POS)
		{
		m_WP.rcNormalPosition.left =
			pApp->GetProfileInt(szString, _T("Left"), wp.rcNormalPosition.left);
		m_WP.rcNormalPosition.top =
			pApp->GetProfileInt(szString, _T("Top"), wp.rcNormalPosition.top);

		if(pApp->GetProfileInt(szString, _T("Left"), -1000) == -1000 && Type)
			{
			m_WP.rcNormalPosition.left = (rcScreen.Width() - w) / 2;
			m_WP.rcNormalPosition.top = (rcScreen.Height() - h) / 2;
			wp.rcNormalPosition.right = m_WP.rcNormalPosition.left + w;
			wp.rcNormalPosition.bottom = m_WP.rcNormalPosition.top + h;
			}
		}

	if(m_mode & LOAD_SIZE)
		{
		m_WP.rcNormalPosition.right =
			pApp->GetProfileInt(szString, _T("Right"), wp.rcNormalPosition.right);
		m_WP.rcNormalPosition.bottom =
			pApp->GetProfileInt(szString, _T("Bottom"), wp.rcNormalPosition.bottom);
		m_SetWindowPos = true;
		}
	else
		{
		m_WP.rcNormalPosition.right = m_WP.rcNormalPosition.left + w;
		m_WP.rcNormalPosition.bottom = m_WP.rcNormalPosition.top + h;
		}

	rcScreen = m_GUILayoutLibMonitor.GetWorkArea(CRect(m_WP.rcNormalPosition));


	rcTemp = m_WP.rcNormalPosition;
	rcTemp.NormalizeRect();
	m_WP.rcNormalPosition = rcTemp;


	if(::IntersectRect(&m_WP.rcNormalPosition, &rcTemp, &rcScreen))
		{
		if(rcTemp != m_WP.rcNormalPosition)
			{
			if(rcTemp.left<rcScreen.left)
				rcTemp.OffsetRect(rcScreen.left - rcTemp.left, 0);

			if(rcTemp.right>rcScreen.right)
				rcTemp.OffsetRect(rcScreen.right - rcTemp.right, 0);

			if(rcTemp.left < rcScreen.left)
				rcTemp.left = rcScreen.left;

			if(rcTemp.top<rcScreen.top)
				rcTemp.OffsetRect(0, rcScreen.top - rcTemp.top);

			if(rcTemp.bottom>rcScreen.bottom)
				rcTemp.OffsetRect(0, rcScreen.bottom - rcTemp.bottom);

			if(rcTemp.top < rcScreen.top)
				rcTemp.top = rcScreen.top;

			m_WP.rcNormalPosition = rcTemp;
			}
		}
	else
		{
		m_WP = wp;
		}

	if(m_WP.showCmd == SW_MINIMIZE && wp.showCmd != SW_MINIMIZE)
		{
		m_WP.showCmd = SW_RESTORE;
		}

	if(m_WP.showCmd != SW_MAXIMIZE && wp.showCmd == SW_MAXIMIZE)
		{
		m_WP.showCmd = SW_MAXIMIZE;
		}

	if(m_WP.showCmd == SW_SHOWMINIMIZED && wp.showCmd == SW_SHOWNORMAL)
		{
		if(AfxGetMainWnd() == m_pWnd)
			m_WP.showCmd = SW_SHOWNORMAL;
		}

	m_WP.flags |= WPF_ASYNCWINDOWPLACEMENT;


	/**********************************************************************/
	//2.6
	if(lZumErstenMal && dwGrowSizeGLL)
		m_WP.rcNormalPosition = GrowSize(m_WP.rcNormalPosition, dwGrowSizeGLL);

	/**********************************************************************/


	//Dies soll vom Fensteraufruf erledigt werden
	//sonst gibt es mit AddVisibleXGroup geflacker
	if(m_WP.showCmd == SW_SHOWNORMAL)
		m_WP.showCmd = 0;

	if(Type != _RGL_TYPE_PROPSHEET_)
		m_pWnd->SetWindowPlacement(&m_WP);
	else
		m_pWnd->SetWindowPos(NULL, rcTemp.left, rcTemp.top, rcTemp.Width(), rcTemp.Height(), SWP_NOZORDER);

	if((m_SetWindowPos == 0 && Type) || Type == _RGL_TYPE_MAINWND_)
		{
		// fix 2.0.7
		// rcTemp statt rcWnd
		m_pWnd->GetWindowRect(rcTemp);
		rcTemp.right--;
		m_pWnd->MoveWindow(rcTemp, false);
		rcTemp.right++;
		m_pWnd->MoveWindow(rcTemp, true);
		}

	return m_SetWindowPos;
}

/*********************************************************************/

void RegWriteSize(CWnd *m_pWnd, LPCTSTR szString)
{
	WINDOWPLACEMENT m_WP;
	CWinApp *pApp = NULL;
	ASSERT(m_pWnd);
	
	if(m_pWnd == NULL)
		return;

	if(szString == NULL)
		return;

	pApp = AfxGetApp();
	if(pApp == NULL)
		return;

	m_pWnd->GetWindowPlacement(&m_WP);
	m_WP.length = sizeof(m_WP);


	pApp->WriteProfileInt(szString, _T("ShowCmd"), m_WP.showCmd);
	pApp->WriteProfileInt(szString, _T("Flags"), m_WP.flags);
	pApp->WriteProfileInt(szString, _T("MinPositionX"), m_WP.ptMinPosition.x);
	pApp->WriteProfileInt(szString, _T("MinPositionY"), m_WP.ptMinPosition.y);
	pApp->WriteProfileInt(szString, _T("MaxPositionX"), m_WP.ptMaxPosition.x);
	pApp->WriteProfileInt(szString, _T("MaxPositionY"), m_WP.ptMaxPosition.y);
	pApp->WriteProfileInt(szString, _T("Left"), m_WP.rcNormalPosition.left);
	pApp->WriteProfileInt(szString, _T("Top"), m_WP.rcNormalPosition.top);
	pApp->WriteProfileInt(szString, _T("Right"), m_WP.rcNormalPosition.right);
	pApp->WriteProfileInt(szString, _T("Bottom"), m_WP.rcNormalPosition.bottom);
}

/*********************************************************************/

BOOL CGUILayoutLibMonitor::InitMultipleMonitorStubs()
{
	if(m_fMultiMonInitDone)
		{
		return m_pfnGetMonitorInfo != NULL;
		}

	hUser32 = GetModuleHandle(_T("USER32"));

	if(hUser32)
		{
		m_pfnGetSystemMetrics = (PFNGetSystemMetrics) GetProcAddress(hUser32, "GetSystemMetrics");
		m_pfnMonitorFromWindow = (PFNMonitorFromWindow) GetProcAddress(hUser32, "MonitorFromWindow");
		m_pfnMonitorFromRect = (PFNMonitorFromRect) GetProcAddress(hUser32, "MonitorFromRect");
		m_pfnMonitorFromPoint = (PFNMonitorFromPoint) GetProcAddress(hUser32, "MonitorFromPoint");
		m_pfnGetMonitorInfo = (PFNGetMonitorInfo) GetProcAddress(hUser32, "GetMonitorInfoW");
		
		hShcore = LoadLibrary(_T("Shcore.dll"));
		if(hShcore)
			{
			m_pfnGetDpiForMonitor = (PFNGetDpiForMonitor)GetProcAddress(hShcore, "GetDpiForMonitor");
			}
		
		m_fMultiMonInitDone = TRUE;


		return TRUE;
		}
	else
		{
		ASSERT(0);
		m_pfnGetSystemMetrics = NULL;
		m_pfnMonitorFromWindow = NULL;
		m_pfnMonitorFromRect = NULL;
		m_pfnMonitorFromPoint = NULL;
		m_pfnGetMonitorInfo = NULL;
		m_pfnGetDpiForMonitor = NULL;

		m_fMultiMonInitDone = TRUE;
		return FALSE;
		}
}


/**********************************************************************/

CGUILayoutLibMonitor::CGUILayoutLibMonitor()
	: m_pfnGetSystemMetrics(NULL)
	, m_pfnMonitorFromWindow(NULL)
	, m_pfnMonitorFromRect(NULL)
	, m_pfnMonitorFromPoint(NULL)
	, m_pfnGetMonitorInfo(NULL)
	, m_pfnGetDpiForMonitor(NULL)
	, hShcore(NULL)
	, hUser32(NULL)
	, m_fMultiMonInitDone(FALSE)

{
	InitMultipleMonitorStubs();
}

/**********************************************************************/

CGUILayoutLibMonitor::~CGUILayoutLibMonitor()
{
	if(hShcore)
		FreeLibrary(hShcore);
	if(hUser32)
		FreeLibrary(hUser32);
	hShcore = NULL;
	hUser32 = NULL;
}

/**********************************************************************/


#endif//#ifndef UNDER_CE
/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDialogLayout 


CDialogLayout::CDialogLayout(
	UINT nID,
	CWnd* pParent /*=NULL*/,
	LPCTSTR strName /*=NULL*/,
	bool bGripper /*=true*/,
	long lSpread /*GREEDY*/,
	DWORD lpGrowSize /*= NULL*/)
	: CDialog(nID, pParent)
{
	//{{AFX_DATA_INIT(CDialogLayout)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
	m_bGripper	= bGripper;

	if(strName)
		{
		m_strRegStore = strName;
		m_LayoutGroup.m_RootGroup.m_Name = strName;
		}
	m_lSpread = lSpread;
	if((m_lSpread & NORESIZE) == NORESIZE)
		m_bGripper = false;
	iStatusBarHeight = 0;
	lpInitialGrow = lpGrowSize;

	m_LayoutGroup.lTheWindowIsA = IS_CDialogLayout;
}

/*********************************************************************/
/*********************************************************************/


CDialogLayout::~CDialogLayout()
{
	if(m_StatusBar.GetSafeHwnd())
		m_StatusBar.DestroyWindow();
	DestroyWindow();
}

/*********************************************************************/

BOOL CDialogLayout::DestroyWindow() 
{
#ifndef UNDER_CE
	if(m_strRegStore.IsEmpty() == false && GetSafeHwnd())
		{
		RegWriteSize(this,m_strRegStore);
		}	
#endif
	return CDialog::DestroyWindow();
}

/*********************************************************************/


void CDialogLayout::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogLayout)
		// HINWEIS: Der Klassen-Assistent fgt hier DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}

/**********************************************************************/


BEGIN_MESSAGE_MAP(CDialogLayout, CDialog)
	//{{AFX_MSG_MAP(CDialogLayout)
	ON_WM_SIZE()
	ON_WM_SETCURSOR()
#ifndef UNDER_CE
// MFC for Windows CE does not support the following methods of the CWnd class: [..] OnGetMinMaxInfo [..]
	ON_WM_GETMINMAXINFO()
#endif
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(WM_PROPPAGE_SIZED_SHEET, OnPageResize)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDialogLayout 

BOOL CDialogLayout::OnInitDialog() 
{
	CDialog::OnInitDialog();
	ModifyStyle(0, WS_CLIPCHILDREN);

	m_LayoutGroup.LayoutInit();
	m_LayoutGroup.lTheWindowIsA = IS_CDialogLayout;

	if(m_lSpread & MOVEWINDOW_REDRAW)
		m_LayoutGroup.m_bMWRedrawWindow = true;

#ifdef WS_THICKFRAME
	if((GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_THICKFRAME) == false)
		{
		m_lSpread &= ~LOAD_SIZE;
		m_bGripper = false;
		}
#endif

	if((m_lSpread & NORESIZE) == NORESIZE)
		{
		m_bGripper = false;
		}

	if(m_bGripper)
		{
		RECT rectDlg;
		GetClientRect(&rectDlg);

		ASSERT(::IsWindow(::GetDlgItem(m_hWnd, AFX_IDW_STATUS_BAR)) == FALSE);
		if(::IsWindow(::GetDlgItem(m_hWnd, AFX_IDW_STATUS_BAR)) == FALSE)
			{
			m_StatusBar.Create(_T("SCROLLBAR"), _T(""), WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | SBS_SIZEBOX | SBS_SIZEGRIP | SBS_SIZEBOXBOTTOMRIGHTALIGN, rectDlg, this, AFX_IDW_STATUS_BAR);
			
			if(IsWindow(m_StatusBar.m_hWnd))
				{
				CRect rcSizeIcon;
				
				m_StatusBar.GetWindowRect(rcSizeIcon);

				m_StatusBarSize = rcSizeIcon.Size();
				iStatusBarHeight = abs(rcSizeIcon.Height());
				
				if((unsigned)iStatusBarHeight < n10)
					iStatusBarHeight = n10;

				iStatusBarHeight -= 5;

				if(GetExStyle() & WS_EX_TOOLWINDOW)
					{
					if(m_LayoutGroup.m_bIsThemeActive == false)
						{
						iStatusBarHeight = 4;
						}
					}

				}
			else
				AfxMessageBox(_T("Statusbar creation failed"));
			}
		}

	m_LayoutGroup.pTheWindow = this;
	m_LayoutGroup.SetDlgName(m_strRegStore);

	return TRUE;
}

/*********************************************************************/
//Fix 2.4.7
void CDialogLayout::DisableThickFrame()
{
	ModifyStyle(WS_THICKFRAME,0);

	if(m_StatusBar.GetSafeHwnd())
		{
		iStatusBarHeight = m_StatusBarSize.cx = m_StatusBarSize.cy = 0;
		m_StatusBar.ShowWindow(false);
		m_bGripper = false;
		}
}

/**********************************************************************/

BOOL CDialogLayout::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	CRect rectClient;
	CPoint ptCursor;

	if(m_bGripper)
		{
		GetWindowRect(rectClient);
		AKScreenToClient(GetSafeHwnd(), &rectClient);

		rectClient.left = rectClient.right - GetSystemMetrics(SM_CYVSCROLL);
		rectClient.top = rectClient.bottom - GetSystemMetrics(SM_CXVSCROLL);


		GetCursorPos(&ptCursor);
		ScreenToClient(&ptCursor);

		if(rectClient.PtInRect(ptCursor)) // Vergrerungs-Cursor
			{
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_SIZENWSE));
			return true;
			}
		}

	return CDialog::OnSetCursor(pWnd, nHitTest, message);
}

/**********************************************************************/

void CDialogLayout::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	if(m_StatusBar.GetSafeHwnd())
		{
		m_StatusBar.Invalidate();
		m_StatusBar.SetWindowPos(&wndBottom,
			cx - m_StatusBarSize.cx,
			cy - m_StatusBarSize.cy, 0, 0, SWP_NOSIZE | SWP_NOACTIVATE);
		}

	m_LayoutGroup.CalcGroups(&m_LayoutGroup.m_RootGroup);
	m_LayoutGroup.SetPosGroups(&m_LayoutGroup.m_RootGroup,
		m_LayoutGroup.m_RootGroup.rcBorder.left,
		m_LayoutGroup.m_RootGroup.rcBorder.top);
}

/**********************************************************************/

CSize CDialogLayout::GetMinSize()
{
	return m_LayoutGroup.privGetMinSize();
}

/*********************************************************************/
#ifndef UNDER_CE
// MFC for Windows CE does not support the following methods of the CWnd class: [..] OnGetMinMaxInfo [..]
void CDialogLayout::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	if(GetSafeHwnd())// && 1==2)
		{
		lpMMI->ptMinTrackSize = m_DlgSize;
		if(m_lSpread & FIX_VERT)
			lpMMI->ptMaxTrackSize.y = m_DlgSize.y;
		if(m_lSpread & FIX_HORI)
			lpMMI->ptMaxTrackSize.x = m_DlgSize.x;

		if(GetMenu() && (m_lSpread & INCLUDE_MENUHEIGHT))
			{
			lpMMI->ptMinTrackSize.y += GetSystemMetrics(SM_CYMENU);
			}
		}
	else
	CDialog::OnGetMinMaxInfo(lpMMI);
}
#endif
/*********************************************************************/

/***********************************************************************
 * Von Wegen GetSystemMetrics(SM_CXDLGFRAME)!
 * Unter Vista sieht das murxig aus.
 ***********************************************************************/

void AKGetWindowBorder(CWnd *pWnd, int& m_Top, int &m_Side, int &m_Bottom)
{
	CRect rc1,rc2;
	pWnd->GetClientRect(rc1);
	pWnd->GetWindowRect(rc2);

	AKScreenToClient(pWnd->GetSafeHwnd(), &rc2);

	rc1 -= rc2;
	m_Top = abs(rc1.top);
	m_Side = abs(rc1.left);

	m_Bottom = m_Side * 2;
}

/**********************************************************************/

void CDialogLayout::EndGroup(LPCRECT lpBorderRect /* = NULL */)
{
//	VERIFY(Art == IS_THE_ROOT);

	if(m_LayoutGroup.m_FIFO.GetCount() > 1)
		{
		CLayoutGroupObj *pGrp = m_LayoutGroup.m_FIFO.RemoveHead();
	
		if(pGrp->m_Childs.GetSize() == 0)
			{
			if((pGrp->dwFlags & IS_LF_GROUP) == 0)
				{
				AfxMessageBox(_T("Group is empty!"));
				}
			}
		}
	else
		{
		int iCaption = 0, m_OS10Fix = 0;
		int m_Top = 0, m_Side = 0, m_Bottom = 0, m_Dazu = 0;
		DWORD dwStyle = GetStyle();
		/************************************************************************
		* Nicht besonders schn :-(
		************************************************************************/
		
		AKGetWindowBorder(this, m_Top, m_Side, m_Bottom);
		if(m_LayoutGroup.OSVersion() >= 60)
			m_Dazu += m_Side;
		/**********************************************************************/

	
		if(dwStyle & WS_CAPTION)
			iCaption = m_Top;

		if(lpBorderRect == NULL)
			{
			UINT nW = GLL_GetDPI()->ScaleX(GetSystemMetrics(SM_CXDLGFRAME)),
				nH = GLL_GetDPI()->ScaleX(GetSystemMetrics(SM_CYDLGFRAME));
			
			// Fix Win 10
			if(m_LayoutGroup.OSVersion() == 100 && (dwStyle & WS_POPUP || dwStyle & WS_THICKFRAME))
				m_OS10Fix = nW - 1;
			
			m_LayoutGroup.m_RootGroup.rcBorder.SetRect(
				nW,
				nH,
				(nW * 2) + m_OS10Fix,
				nH * 2);

			if(iStatusBarHeight)
				m_LayoutGroup.m_RootGroup.rcBorder.bottom -= nH;
			}
		else
			m_LayoutGroup.m_RootGroup.rcBorder = lpBorderRect;

		m_LayoutGroup.InitGroups(&m_LayoutGroup.m_RootGroup);

		m_LayoutGroup.SearchForGroupStatics(&m_LayoutGroup.m_RootGroup, NULL);

		m_LayoutGroup.m_RootGroup.rcBorder.bottom += iStatusBarHeight;

		m_LayoutGroup.SetPosGroups(&m_LayoutGroup.m_RootGroup,
			m_LayoutGroup.m_RootGroup.rcBorder.left,
			m_LayoutGroup.m_RootGroup.rcBorder.top);


		m_DlgSize.x = m_LayoutGroup.m_RootGroup.rcMinSize.Width()
			+ m_LayoutGroup.m_RootGroup.rcBorder.left
			+ m_LayoutGroup.m_RootGroup.rcBorder.right + (m_Side * 2) + m_Dazu;

		m_DlgSize.y = m_LayoutGroup.m_RootGroup.rcMinSize.Height()
			+ iCaption
			+ m_LayoutGroup.m_RootGroup.rcBorder.top
			+ m_LayoutGroup.m_RootGroup.rcBorder.bottom;

		SetWindowPos(NULL, 0, 0, m_DlgSize.x + 1, m_DlgSize.y, SWP_NOZORDER | SWP_NOMOVE);
		SetWindowPos(NULL, 0, 0, m_DlgSize.x, m_DlgSize.y, SWP_NOZORDER | SWP_NOMOVE);

	#ifndef UNDER_CE
		if(m_strRegStore.IsEmpty() == false)
			{
			if((m_lSpread & LOAD_POS) || (m_lSpread & LOAD_SIZE))
				RegLoadSetSize(this, m_strRegStore, m_lSpread, _RGL_TYPE_DIALOG_, lpInitialGrow);
			}
	#endif
		m_LayoutGroup.m_FIFO.RemoveAll();
		}
}

/**********************************************************************/

void CDialogLayout::ShowVisibleGroup(CLayoutGroupObj *m_pGrp,bool bShow,bool bRefresh, BYTE bShrink)
{
	CPoint m_DlgSize1;
	bool m_Veraendert = false;
	int iCaption = 0;
	bool m_bIsVisible = IsWindowVisible() ? true : false;

	int m_Top, m_Side, m_Bottom, m_Dazu = 0;


	/************************************************************************
	* Nicht besonders schn :-(
	************************************************************************/

	AKGetWindowBorder(this, m_Top, m_Side, m_Bottom);

	if(GLL_GetWindowsVers() >= 60)
		m_Dazu += m_Side;

	/**********************************************************************/
	if(bShrink == false && m_bIsVisible)
		SetRedraw(false);
	/**********************************************************************/


	/************************************************************************
	* Irgend etwas klappt hier nicht richtig! :-(
	************************************************************************/
	if(GetStyle() & WS_CAPTION && !(GetStyle() & WS_THICKFRAME))
		iCaption = GetSystemMetrics(SM_CYCAPTION);

	if(m_bIsVisible)
		SetRedraw(false);

	m_LayoutGroup.privShowVisibleGroup(m_pGrp, bShow, bRefresh);

	if(bShrink && m_bIsVisible)
		SetRedraw(true);

	m_DlgSize1.x = m_LayoutGroup.m_RootGroup.rcMinSize.Width()
		+ m_LayoutGroup.m_RootGroup.rcBorder.left
		+ m_LayoutGroup.m_RootGroup.rcBorder.right + (m_Side * 2) + m_Dazu;

	m_DlgSize1.y = m_LayoutGroup.m_RootGroup.rcMinSize.Height()
		+ iCaption
		+ m_LayoutGroup.m_RootGroup.rcBorder.top
		+ m_LayoutGroup.m_RootGroup.rcBorder.bottom + m_Bottom + m_Dazu + iStatusBarHeight;


	if((m_DlgSize1.x > m_DlgSize.x || m_DlgSize1.y > m_DlgSize.y) &&
		(m_DlgSize1.x > AKGetWindowWidth(this) || m_DlgSize1.y > AKGetWindowHeight(this)) && bRefresh)
		{
		int w, h;

		w = max(m_DlgSize1.x, m_DlgSize.x);
		m_DlgSize.x = w;
		w = max(w, AKGetWindowWidth(this));

		h = max(m_DlgSize1.y, m_DlgSize.y);
		m_DlgSize.y = h;
		h = max(h, AKGetWindowHeight(this));

		SetWindowPos(NULL, 0, 0, w, h, SWP_NOZORDER | SWP_NOMOVE | SWP_NOSENDCHANGING);
		m_Veraendert = true;
		bShrink = false;
		}
	else
		{
		m_DlgSize = m_DlgSize1;

		if(bRefresh)
			{
			int w, h;
#ifdef UNDER_CE
			// SWP_NOREDRAW is not supported under CE
			long lRefresh = 0;
#else
			long lRefresh = SWP_NOREDRAW;
#endif
			w = max(m_DlgSize.x, AKGetWindowWidth(this));
			h = max(m_DlgSize.y, AKGetWindowHeight(this));
			if(w <= AKGetWindowWidth(this) || h <= AKGetWindowHeight(this))
				{
				lRefresh = 0;
				}
			if(m_bIsVisible)
				SetRedraw(false);
			SetWindowPos(NULL, 0, 0, w, h - 1, SWP_NOZORDER | SWP_NOMOVE | lRefresh | SWP_NOSENDCHANGING);
			SetWindowPos(NULL, 0, 0, w, h, SWP_NOZORDER | SWP_NOMOVE | SWP_DRAWFRAME);
			if(bShrink && m_bIsVisible)
				SetRedraw(true);
			//bShrink = false;
			}
		}

	if(bShrink)
		{
		if(bShrink == 2)
			SetWindowPos(NULL, 0, 0, AKGetWindowWidth(this), m_DlgSize.y, SWP_NOZORDER | SWP_NOMOVE);
		else if(bShrink == 3)
			SetWindowPos(NULL, 0, 0, m_DlgSize.x, AKGetWindowHeight(this), SWP_NOZORDER | SWP_NOMOVE);
		else
			SetWindowPos(NULL, 0, 0, m_DlgSize.x, m_DlgSize.y, SWP_NOZORDER | SWP_NOMOVE);
		}

	if(bRefresh)
		{
#ifdef UNDER_CE
		RedrawWindow();
#else
		RedrawWindow(0, 0, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ALLCHILDREN | RDW_FRAME);
#endif
		}

	if(GetParent())
		GetParent()->SendMessage(WM_VISIBLEGROUP_RESIZED, 0, (LPARAM)this);

	/**********************************************************************/
	if(m_bIsVisible)
		SetRedraw(true);
	RedrawWindow(0, 0, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	if(GetParent())
		GetDesktopWindow()->Invalidate();
	/**********************************************************************/

}

/*********************************************************************/

LRESULT CDialogLayout::OnPageResize(WPARAM /*wp*/, LPARAM lp)
{
	if(lp)
		{
		CWnd *pWnd = (CWnd*) lp;
		if(pWnd->IsKindOf(RUNTIME_CLASS(CPropertySheetLayout)))
			{
			CLayoutGroupObj *pGroup = m_LayoutGroup.FindGroup(pWnd->GetSafeHwnd());
			if(pGroup)
				{
				pGroup->rcMinSize.right = AKGetWindowWidth(pWnd);
				pGroup->rcMinSize.bottom = AKGetWindowHeight(pWnd);

				pGroup->bVisible = false;
				m_LayoutGroup.privShowVisibleGroup(pGroup, true, true);
				}
			}
		}
	SetSize();
	return TRUE; // Wichtig! Zeigt an, dass Message behandelt wird
}

/*********************************************************************/

void CDialogLayout::SetSize()
{
	int iCaption = 0;

	if(GetStyle() & WS_CAPTION)
		iCaption = GetSystemMetrics(SM_CYCAPTION);

	m_LayoutGroup.m_RootGroup.bVisible = false;
	m_LayoutGroup.privShowVisibleGroup(&m_LayoutGroup.m_RootGroup, true, true);


	//fix 2.4.5
	m_DlgSize.x = m_LayoutGroup.m_RootGroup.rcMinSize.Width()
		+ m_LayoutGroup.m_RootGroup.rcBorder.left
		+ m_LayoutGroup.m_RootGroup.rcBorder.right;

	m_DlgSize.y = m_LayoutGroup.m_RootGroup.rcMinSize.Height()
		+ iCaption
		- (GetSystemMetrics(SM_CYDLGFRAME))
		+ m_LayoutGroup.m_RootGroup.rcBorder.top
		+ iStatusBarHeight;

	int w, h;
	w = max(m_DlgSize.x, AKGetWindowWidth(this));
	h = max(m_DlgSize.y, AKGetWindowHeight(this));
	SetWindowPos(NULL, 0, 0, w, h, SWP_NOZORDER | SWP_NOMOVE);
}

/**********************************************************************/

CPropertySheetLayout::CPropertySheetLayout(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage,
	LPCTSTR strName /*=NULL*/, 
	bool bGripper /*=true*/,
	long lSpread /*=GREEDY*/,
	DWORD lpInitGrowSizeGLL /*= NULL*/)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	InitData();
	m_bGripper = bGripper;
	m_lSpread = lSpread;
	m_strRegStore = strName;
	m_IsThisNT = GLL_GetWindowsVers() ? true : false;
	lpInitialGrow = lpInitGrowSizeGLL;
}

/**********************************************************************/

CPropertySheetLayout::CPropertySheetLayout(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage,
	LPCTSTR strName /*=NULL*/, 
	bool bGripper /*=true*/,
	long lSpread,
	DWORD lpInitGrowSizeGLL /*= NULL*/)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	InitData();
	m_bGripper = bGripper;
	m_lSpread = lSpread;
	m_strRegStore = strName;
	m_IsThisNT = GLL_GetWindowsVers() ? true : false;
	lpInitialGrow = lpInitGrowSizeGLL;
}

/*********************************************************************/

CPropertySheetLayout::~CPropertySheetLayout()
{
	if(m_StatusBar.GetSafeHwnd())
		m_StatusBar.DestroyWindow();
	DestroyWindow();
}

/*********************************************************************/

BOOL CPropertySheetLayout::DestroyWindow() 
{
	if(m_BkGBrush.GetSafeHandle())
		m_BkGBrush.DeleteObject();

#ifndef UNDER_CE
	if(m_strRegStore.IsEmpty() == false && GetSafeHwnd())
		{
		RegWriteSize(this,m_strRegStore);
		}
#endif

	return CPropertySheet::DestroyWindow();
}

/*********************************************************************/

void CPropertySheetLayout::InitData()
{
	m_bGripper = false;
	m_bHideHelp = false;
	m_bNoTabCtrl = false;
	_INIT = false;
	m_lAdjust = LABEL_TOP;
	m_LayoutGroup.pTheWindow = NULL;
	iStatusBarHeight = 0;
	m_TabGroup = NULL;
	m_LayoutGroup.lTheWindowIsA = IS_CPropertySheetLayout;
}

BEGIN_MESSAGE_MAP(CPropertySheetLayout, CPropertySheet)
	//{{AFX_MSG_MAP(CPropertySheetLayout)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_SETCURSOR()
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
#ifndef UNDER_CE
// MFC for Windows CE does not support the following methods of the CWnd class: [..] OnGetMinMaxInfo [..]
	ON_WM_GETMINMAXINFO()
#endif
	//ON_MESSAGE(WM_PROPPAGE_SIZED_SHEET, OnPageResize)
	//ON_COMMAND(WM_PROPPAGE_SIZED_SHEET, OnPageResize)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CPropertySheetLayout 

void CPropertySheetLayout::OnSize(UINT nType, int cx, int cy) 
{
	CPropertySheet::OnSize(nType, cx, cy);

	if(m_LayoutGroup.pTheWindow == NULL)
		return;

	GLLASSERT(m_TabGroup);

	if(abs(cx) + abs(cy) > 0)
		{
		if(m_StatusBar.GetSafeHwnd())
			{
			m_StatusBar.Invalidate();
			m_StatusBar.SetWindowPos(&wndBottom,
				cx - m_StatusBarSize.cx,
				cy - m_StatusBarSize.cy, 0, 0, SWP_NOSIZE | SWP_NOACTIVATE);
			}

		m_LayoutGroup.CalcGroups(&m_LayoutGroup.m_RootGroup);
		m_LayoutGroup.SetPosGroups(&m_LayoutGroup.m_RootGroup,
			m_LayoutGroup.m_RootGroup.rcBorder.left,
			m_LayoutGroup.m_RootGroup.rcBorder.top);


		if(IsWizard())
			{
			CWnd *pWndFinish;
			pWndFinish = GetDlgItem(ID_WIZFINISH);

			if(pWndFinish)
				{
				CRect rcWnd;
				GetDlgItem(ID_WIZNEXT)->GetWindowRect(&rcWnd);
				AKScreenToClient(GetSafeHwnd(), &rcWnd);
				pWndFinish->MoveWindow(rcWnd);
#ifdef UNDER_CE
				pWndFinish->RedrawWindow();
#else
				pWndFinish->RedrawWindow(0, 0, RDW_INVALIDATE | RDW_UPDATENOW);
#endif
				}
			}


		CPropertyPageLayout* pPage = (CPropertyPageLayout*) GetActivePage();

		if(pPage)
			{
			CRect rcWnd;
			GetTabControl()->GetWindowRect(&rcWnd);
			AKScreenToClient(GetSafeHwnd(), &rcWnd);

			if(IsBottomLabel() && (IsWizard() == FALSE && IsNoTabCtrl() == false))
				pPage->m_LayoutGroup.m_RootGroup.rcBorder.bottom = GLL_GetDPI()->ScaleY(1);

			if(IsWizard() == FALSE)
				{
				GetTabControl()->AdjustRect(FALSE, &rcWnd);
				}
			else
				{
				rcWnd.bottom += GLL_GetDPI()->ScaleY(5);
				}

			if(IsModeLess() && IsNoTabCtrl())
				{
				rcWnd.SetRect(
					GetSystemMetrics(SM_CXDLGFRAME),
					GetSystemMetrics(SM_CYDLGFRAME),
					AKGetWindowWidth(this) - GetSystemMetrics(SM_CXDLGFRAME),
					AKGetWindowHeight(this) - GetSystemMetrics(SM_CYDLGFRAME));
				}

			m_rcAktPage = rcWnd;
			pPage->MoveWindow(m_rcAktPage);
			}

		if(IsWindowVisible())
			{
#ifdef UNDER_CE
			RedrawWindow();
#else
			RedrawWindow(0, 0, RDW_INVALIDATE | RDW_UPDATENOW);
#endif

			if(IsWizard() == FALSE)
#ifdef UNDER_CE
				GetTabControl()->RedrawWindow();
#else
				GetTabControl()->RedrawWindow(0, 0, RDW_INVALIDATE | RDW_UPDATENOW);
#endif
			}
		}
}

/*********************************************************************/

CSize CPropertySheetLayout::GetMinSize()
{
	return m_LayoutGroup.privGetMinSize();
}

/**********************************************************************/

#ifndef UNDER_CE
// MFC for Windows CE does not support the following methods of the CWnd class: [..] OnGetMinMaxInfo [..]
void CPropertySheetLayout::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	if(GetSafeHwnd())
		{
		lpMMI->ptMinTrackSize = m_DlgSize;
		if(m_lSpread & FIX_VERT)
			lpMMI->ptMaxTrackSize.y = m_DlgSize.y;
		if(m_lSpread & FIX_HORI)
			lpMMI->ptMaxTrackSize.x = m_DlgSize.x;

		}
	else
		CPropertySheet::OnGetMinMaxInfo(lpMMI);
}
#endif
/*********************************************************************/

void CPropertySheetLayout::SetSize(int ID)
{
	if(ID != 2056)
		return;

	int iCaption = 0, Ausgleich = 0;

	if(GetStyle() & WS_CAPTION)
		iCaption = GetSystemMetrics(SM_CYCAPTION);

	if(IsWizard() && IsNoTabCtrl())
		iCaption = 0;

	int m_Top = 0, m_Side = 0, m_Bottom = 0, m_Dazu = 0;
	AKGetWindowBorder(this, m_Top, m_Side, m_Bottom);

	if(GLL_GetWindowsVers() >= 60)
		m_Dazu += m_Side;

	m_TabGroup->bVisible = false;
	m_LayoutGroup.privShowVisibleGroup(m_TabGroup, true, false);


	m_LayoutGroup.m_RootGroup.bVisible = false;
	m_LayoutGroup.privShowVisibleGroup(&m_LayoutGroup.m_RootGroup, true, true);

	if(m_bNoTabCtrl || IsWizard())
		{
		GetTabControl()->ShowWindow(false);
		}

	m_DlgSize.x = m_LayoutGroup.m_RootGroup.rcMinSize.Width()
		+ /*(GetSystemMetrics(SM_CYDLGFRAME)*2)*/ (m_Side * 2) + m_Dazu
		+ m_LayoutGroup.m_RootGroup.rcBorder.left
		+ m_LayoutGroup.m_RootGroup.rcBorder.right;


	m_DlgSize.y = m_LayoutGroup.m_RootGroup.rcMinSize.Height()
		+ iCaption
		+ (GetSystemMetrics(SM_CYDLGFRAME) * 2)
		+ m_LayoutGroup.m_RootGroup.rcBorder.top
		+ iStatusBarHeight
		+ Ausgleich;

	int w, h;
	w = max(m_DlgSize.x, AKGetWindowWidth(this));
	h = max(m_DlgSize.y, AKGetWindowHeight(this));
	SetWindowPos(NULL, 0, 0, w, h, SWP_NOZORDER | SWP_NOMOVE);

	if(IsModeLess())
		{
		if(GetParent())
			GetParent()->SendMessage(WM_PROPPAGE_SIZED_SHEET, 0, (LPARAM)this);
		}
}

/*********************************************************************/

void CPropertySheetLayout::EndGroup(LPCRECT lpBorderRect /* = NULL */)
{
//	VERIFY(Art == IS_THE_ROOT);

	if(m_LayoutGroup.m_FIFO.GetCount() > 1)
		{
		CLayoutGroupObj *pGrp = m_LayoutGroup.m_FIFO.RemoveHead();
		if(pGrp->m_Childs.GetSize() == 0)
			{
			if((pGrp->dwFlags & IS_LF_GROUP) == 0)
				{
				AfxMessageBox(_T("Group is empty!"));
				}
			}
		}
	else
		{
		int m_Top = 0, m_Side = 0, m_Bottom = 0, m_Dazu = 0;

		AKGetWindowBorder(this, m_Top, m_Side, m_Bottom);
		if(GLL_GetWindowsVers() >= 60)
			m_Dazu += m_Side;

		if(IsModeLess() == FALSE)
			{
			m_LayoutGroup.m_RootGroup.rcBorder.SetRect(
				GetSystemMetrics(SM_CXDLGFRAME) - 1,
				GetSystemMetrics(SM_CYDLGFRAME),
				m_Side,
				m_Bottom);
			}
		else
			m_LayoutGroup.m_RootGroup.rcBorder.SetRect(0, 0, 0, 0);


		if(lpBorderRect)
			m_LayoutGroup.m_RootGroup.rcBorder;

		m_LayoutGroup.InitGroups(&m_LayoutGroup.m_RootGroup);

		m_LayoutGroup.SearchForGroupStatics(&m_LayoutGroup.m_RootGroup, NULL);

		//m_LayoutGroup.m_RootGroup.rcBorder.bottom += m_Dazu;

		m_LayoutGroup.SetPosGroups(&m_LayoutGroup.m_RootGroup,
			m_LayoutGroup.m_RootGroup.rcBorder.left,
			m_LayoutGroup.m_RootGroup.rcBorder.top);

		m_DlgSize.x = m_LayoutGroup.m_RootGroup.rcMinSize.Width()
			+ (GetSystemMetrics(SM_CYDLGFRAME) * 2)
			+ m_LayoutGroup.m_RootGroup.rcBorder.left
			+ m_LayoutGroup.m_RootGroup.rcBorder.right;

		m_DlgSize.y = m_LayoutGroup.m_RootGroup.rcMinSize.Height()
			+ GetSystemMetrics(SM_CYCAPTION)
			+ (GetSystemMetrics(SM_CYDLGFRAME) * 2)
			+ m_LayoutGroup.m_RootGroup.rcBorder.top;


		CenterWindow();
		int m_bSetPos = false; // fix 2.0.7 int statt bool

	#ifndef UNDER_CE
		if(m_strRegStore.IsEmpty() == FALSE && IsModeLess() == FALSE)
			{
			m_bSetPos = RegLoadSetSize(this, m_strRegStore, m_lSpread, _RGL_TYPE_PROPSHEET_);

			if(m_bSetPos == 2) // fix 2.0.7
				{
				SetWindowPos(NULL, 0, 0, m_DlgSize.x, m_DlgSize.y, SWP_NOZORDER | SWP_NOREDRAW);
				CenterWindow(GetDesktopWindow());
				}
			else
				lpInitialGrow = 0;
			}
	#endif

		if(m_bSetPos == 0)
			{
			SetWindowPos(NULL, 0, 0, m_DlgSize.x, m_DlgSize.y, SWP_NOZORDER | SWP_NOMOVE);
			}

		m_LayoutGroup.m_FIFO.RemoveAll();
		}
}

/*********************************************************************/

void CPropertySheetLayout::SetModeLess()
{
	m_psh.dwFlags |= PSH_MODELESS;
	m_bModeless = true;
	m_bGripper = false;
	HideHelpButton();
	HideApplyButton();
}

/**********************************************************************/

void CPropertySheetLayout::LabelAdjust(long lAdjust)
{
	m_lAdjust = LABEL_TOP;

	if(lAdjust == LABEL_BOTTOM)
		{
		if(m_hWnd && GetTabControl())
			GetTabControl()->ModifyStyle(TCS_MULTILINE, TCS_BOTTOM);
		m_lAdjust = LABEL_BOTTOM;

		// Fix: Positioniert Pages neu.
		// Im Nicht-Modeless wird noch mal
		// Size() aufgerufen.

		//		if(m_hWnd)
		//			ReSize(1,1);
		// ab 2.0  nicht mehr notig?
		}
}	

/**********************************************************************/

void CPropertySheetLayout::HideHelpButton()
{
	m_bHideHelp = true;
}

/*********************************************************************/

void CPropertySheetLayout::HideTabControl()
{
	m_bNoTabCtrl = true;
	m_lAdjust = LABEL_TOP;
}

/**********************************************************************/

void CPropertySheetLayout::HideApplyButton()
{
	m_psh . dwFlags |= (PSH_NOAPPLYNOW);
}

/**********************************************************************/

void CPropertySheetLayout::AddPage(CPropertyPage *page)
{
	ASSERT(page);
	if(page == NULL)
		return;

	if(page->IsKindOf(RUNTIME_CLASS(CPropertyPageLayout)))
		{
		((CPropertyPageLayout *) page)->m_Sheet = this;
		((CPropertyPageLayout *) page)->m_IsThisNT = m_IsThisNT;
		CPropertySheet::AddPage(page);
		}
	else
		{
		AfxMessageBox(_T("AddPage() failed.\nIs this page a CPropertyPageLayout?\n")
			_T("IMPLEMENT_DYNCREATE(CMyPropertyPage1, CPropertyPage)\nand not CPropertyPageLayout?"));
		}
}

/**********************************************************************/

long CPropertySheetMgrIDs[] =
{
	ID_WIZBACK,ID_WIZNEXT, IDOK, IDCANCEL,
	ID_APPLY_NOW, IDHELP//, ID_WIZFINISH+1 = Line
};

/**********************************************************************/

bool CPropertySheetLayout::AddTab(CWnd *w,long lSpread)
{
	CLayoutGroupObj *m_pParentGrp, *New_Grp;
	if(m_LayoutGroup.m_FIFO.GetCount())
		m_pParentGrp = m_LayoutGroup.m_FIFO.GetAt(m_LayoutGroup.m_FIFO.GetHeadPosition());
	else
		m_pParentGrp = &m_LayoutGroup.m_RootGroup;

	ASSERT(m_pParentGrp);

	New_Grp = m_LayoutGroup.NewItem(m_pParentGrp, w, lSpread);
	GLLASSERT_F(New_Grp);
	m_TabGroup = New_Grp;
	return true;
}

/*********************************************************************/

HBRUSH CPropertySheetLayout::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr;

	if(pWnd == this)
		hbr = (HBRUSH) m_BkGBrush; // Vorlufiger Fix fr XP-Luna
	else
		hbr = CPropertySheet::OnCtlColor(pDC, pWnd, nCtlColor);

	return hbr;
}

/*********************************************************************/

BOOL CPropertySheetLayout::OnInitDialog(BYTE m_bWizardModeFlags) 
{
	CPropertySheet::OnInitDialog();
	if(_INIT)
		return true;
	_INIT = true;

	VERIFY(m_BkGBrush.CreateSolidBrush(m_LayoutGroup.GetDlgBKColor()));
	m_LayoutGroup.LayoutInit();
	m_LayoutGroup.lTheWindowIsA = IS_CPropertySheetLayout;

	if(m_lSpread & MOVEWINDOW_REDRAW)
		m_LayoutGroup.m_bMWRedrawWindow = true;

	m_LayoutGroup.SetDlgName(m_strRegStore);
#ifndef UNDER_CE
	//	All Windows CE dialog boxes are control parents and are recursive, so you do not need to specify the DS_CONTROL, DS_RECURSE, or WS_EX_CONTROLPARENT styles for your dialog boxes.
	if(IsModeLess())
		ModifyStyleEx(0, WS_EX_CONTROLPARENT/*|WS_EX_STATICEDGE*/);// WICHTIG! Sonst Crash bei ModelsSheets in Views/Sheets
#endif

	if(this->IsKindOf(RUNTIME_CLASS(CPropertySheetLayout)) == FALSE)
		{
		AfxMessageBox(_T("Fehler!\nIMPLEMENT_DYNAMIC(CMyPropertySheet, CPropertySheetLayout)\nvergessen????"));
		}

	CPropertyPage* pPage;
	pPage = (CPropertyPageLayout*) CPropertySheet::GetActivePage();
	GLLASSERT_F(pPage);

	MoveWindow(0, 0, 80, 10, false);
	pPage->MoveWindow(0, 0, 80, 10, false);
	GetTabControl()->MoveWindow(0, 0, 10, 10, false);

	if(IsWizard() == FALSE && m_lAdjust == LABEL_BOTTOM)
		GetTabControl()->ModifyStyle(TCS_MULTILINE, TCS_BOTTOM);

	GetTabControl()->ModifyStyle(TCS_MULTILINE, 0);

	if(m_psh.dwFlags & PSH_MODELESS || m_bModeless)
		{
		m_bModeless = true;
		m_bGripper = false;
#ifdef WS_THICKFRAME
		ModifyStyle(WS_THICKFRAME, WS_CLIPCHILDREN);
#else
		ModifyStyle(0,WS_CLIPCHILDREN);
#endif
		GetTabControl()->ModifyStyle(TCS_MULTILINE, 0);
		}

#ifdef WS_THICKFRAME
	if((m_lSpread & NORESIZE) == NORESIZE)
		{
		ModifyStyle(WS_THICKFRAME, 0);
		}
#endif

	if(m_bNoTabCtrl || IsWizard())
		{
		GetTabControl()->ShowWindow(false);
		}


	if(m_bGripper)
		{
		RECT rectDlg;
		GetClientRect(&rectDlg);
		ASSERT(::IsWindow(::GetDlgItem(m_hWnd, AFX_IDW_STATUS_BAR)) == FALSE);
		if(::IsWindow(::GetDlgItem(m_hWnd, AFX_IDW_STATUS_BAR)) == FALSE)
			{

			m_StatusBar.Create(_T("SCROLLBAR"), _T(""), WS_CHILD | WS_VISIBLE |
				WS_CLIPSIBLINGS | SBS_SIZEBOX | SBS_SIZEGRIP | SBS_SIZEBOXBOTTOMRIGHTALIGN, rectDlg, this, AFX_IDW_STATUS_BAR);
			if(IsWindow(m_StatusBar.m_hWnd))
				{
				CRect rcSizeIcon;
				m_StatusBar.GetWindowRect(rcSizeIcon);
				m_StatusBarSize = rcSizeIcon.Size();
				iStatusBarHeight = abs(rcSizeIcon.Height() - 5);
				if(iStatusBarHeight < 10)
					iStatusBarHeight = 10;

				iStatusBarHeight /= 2;
				iStatusBarHeight += 2;
				}
			else
				AfxMessageBox(_T("Statusbar creation failed"));
			}
		}


	CWnd *pIrgendEinWindow = NULL, *pWnd = NULL;
	bool bInsertVorSpace = false, bInsert = false, bInsertASpace = false;

	m_LayoutGroup.pTheWindow = this;


	VGroup();
	AddTab(GetTabControl());

	if(m_bModeless == FALSE && IsWizard())
		{
		pWnd = GetDlgItem(ID_WIZFINISH + 1);
		//
		if(pWnd)
			{
			if((m_bWizardModeFlags & _WMFlags_NoBottomLine) == 0)
				{
				CRect winRect;
				pWnd->GetWindowRect(winRect);
				winRect.right = winRect.left + 100;
				pWnd->MoveWindow(winRect);
				AddSpace(6);
				AddChild(pWnd, FIX_VERT);
				}
			else
				{
				AddSpace(5);
				pWnd->ShowWindow(false);
				}
			}
		}

	if(m_bModeless == FALSE)// && !IsWizard())
		{
		AddSpace(5);
		HGroup();
		SetAlign(RIGHT);
		for(int i = 0; i < (sizeof(CPropertySheetMgrIDs) / sizeof(long)); i++)
			{
			pWnd = GetDlgItem(CPropertySheetMgrIDs[i]);

			if(pWnd)
				{
				if(pIrgendEinWindow == NULL)
					pIrgendEinWindow = pWnd;

				bInsertVorSpace = true;
				bInsert = true;	// Soll Control eingefgt werden.
				bInsertASpace = false; // Space hinter Control

				if(IsWizard() && CPropertySheetMgrIDs[i] == ID_WIZNEXT)
					bInsertASpace = true;

				if(IsWizard() && CPropertySheetMgrIDs[i] == IDCANCEL)
					bInsertASpace = true;

				if(m_bHideHelp && CPropertySheetMgrIDs[i] == IDHELP)
					{
					bInsert = false;
					pWnd->ShowWindow(false);
					continue;
					}

				if(CPropertySheetMgrIDs[i] == ID_APPLY_NOW)
					{
					if(m_psh.dwFlags & PSH_NOAPPLYNOW)
						{
						bInsert = false;
						continue;
						}
					}

				if(IsWizard() && CPropertySheetMgrIDs[i] == ID_WIZNEXT || !bInsert)
					bInsertVorSpace = false;
				if(IsWizard() && CPropertySheetMgrIDs[i] == IDCANCEL)
					bInsertVorSpace = false;

				if(bInsertVorSpace)
					AddSpace(5);

				if(bInsert)
					AddChild(CPropertySheetMgrIDs[i], NORESIZE);

				if(bInsertASpace)
					AddSpace(10);
				}

			if((m_bWizardModeFlags & _WMFlags_Wizard) && IsWizard())
				AddSpace(5);

			}
		EndGrp;
		}

	if(m_bGripper == false && m_bModeless == FALSE)
		AddSpace(5);

	EndGrp;

	//Fix 2.4.17
	if((m_bWizardModeFlags & _WMFlags_Wizard) && IsWizard())
		{
		CRect rcWnd, winRect;
		m_LayoutGroup.m_RootGroup.rcBorder.top = 0;
		m_LayoutGroup.m_RootGroup.rcBorder.left = 0;
		m_LayoutGroup.m_RootGroup.rcBorder.right = 0;

		AKReSize(this);
		}

	//fix 2.4.5
	if(m_bNoTabCtrl || IsWizard())
		{
		GetTabControl()->ShowWindow(false);
		}

	CPropertySheet::SetActivePage(GetActiveIndex());

	if(lpInitialGrow)
		{
		CRect rc;
		GetWindowRect(rc);
		rc = GrowSize(rc, lpInitialGrow);
		MoveWindow(rc);
		}


	return TRUE;
}

/*********************************************************************/

//Fix 2.4.17
void CPropertySheetLayout::SetWizardButtons(DWORD dwFlags)
{
	if(dwFlags & PSWIZB_FINISH)
		{
		CWnd *pWnd1, *pWnd2;
		CRect rcWnd1, rcWnd2;

		pWnd1 = GetDlgItem(ID_WIZFINISH);
		pWnd2 = GetDlgItem(IDCANCEL);

		if(pWnd1 && pWnd2)
			{
			pWnd1->GetWindowRect(rcWnd1);
			pWnd2->GetWindowRect(rcWnd2);

			AKScreenToClient(GetSafeHwnd(), rcWnd2);
			AKScreenToClient(GetSafeHwnd(), rcWnd1);

			pWnd1->SetWindowPos(NULL, rcWnd1.left, rcWnd2.top, 0, 0, SWP_NOSIZE | SWP_NOACTIVATE);
			}
		}

	CPropertySheet::SetWizardButtons(dwFlags);
}

/**********************************************************************/

BOOL CPropertySheetLayout::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	if(m_bGripper)
		{
		CRect rectClient;
		CPoint ptCursor;

		GetWindowRect(rectClient);
		AKScreenToClient(GetSafeHwnd(), rectClient);

		rectClient.left = rectClient.right - GetSystemMetrics(SM_CYVSCROLL);
		rectClient.top = rectClient.bottom - GetSystemMetrics(SM_CXVSCROLL);

		GetCursorPos(&ptCursor);
		ScreenToClient(&ptCursor);

		if(rectClient.PtInRect(ptCursor)) // Vergrerungs-Cursor
			{
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_SIZENWSE));
			return true;
			}
		}
	
	return CPropertySheet::OnSetCursor(pWnd, nHitTest, message);
}

/**********************************************************************/

int CPropertySheetLayout::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CPropertySheet::OnCreate(lpCreateStruct) == -1)
		return -1;
#ifdef WS_THICKFRAME
	ModifyStyle(0, WS_THICKFRAME | WS_SYSMENU | WS_CLIPCHILDREN);
#else
	ModifyStyle(0,WS_SYSMENU|WS_CLIPCHILDREN);
#endif

	m_psh.dwFlags &= ~PSH_MODELESS;
#ifdef WS_THICKFRAME
	if((m_lSpread & NORESIZE) == NORESIZE)
		ModifyStyle(WS_THICKFRAME, 0);
#endif
	return 0;
}

/*********************************************************************/

BOOL CPropertySheetLayout::SetActivePage(int nPage)
{
	if(GetSafeHwnd())
		{
		if(GetActiveIndex() != nPage)
			return CPropertySheet::SetActivePage(nPage);
		}
	else
		ASSERT(0);

	return true;
}

/**********************************************************************/

BOOL CPropertySheetLayout::SetActivePage(CPropertyPage* pnPage)
{
	if(GetSafeHwnd())
		{
		CPropertyPage* pPage = GetActivePage();
		if(pPage != pnPage)
			return CPropertySheet::SetActivePage(pnPage);
		}
	else
		ASSERT(0);

	return true;
}

/*********************************************************************/

long CPropertySheetLayout::GetTapHeight()
{
	long height = 0;
	CRect rcWnd(0, 0, 0, 0);
	GetTabControl()->AdjustRect(true, &rcWnd);
	height = abs(rcWnd.top) + abs(rcWnd.bottom);

	if(IsNoTabCtrl() || IsWizard())
		height = -10;
	return height;
}

/*********************************************************************/

CPropertyPageLayout::CPropertyPageLayout():CPropertyPage()
{
	m_Sheet = NULL;
	m_IsThisNT = false;
	m_LayoutGroup.lTheWindowIsA = IS_CPropertyPageLayout;
};

/**********************************************************************/

CPropertyPageLayout::CPropertyPageLayout(LPCTSTR lpszTemplateName, UINT nIDCaption) 
	: CPropertyPage(lpszTemplateName, nIDCaption)
{
	m_Sheet = NULL;
	//{{AFX_DATA_INIT(CPropertyPageLayout)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}

/**********************************************************************/

CPropertyPageLayout::CPropertyPageLayout(UINT nIDTemplate, UINT nIDCaption)
	: CPropertyPage(nIDTemplate, nIDCaption)
{
	m_Sheet = NULL;
}

/**********************************************************************/

void CPropertyPageLayout::ShowVisibleGroup(CLayoutGroupObj *m_pGrp,bool bShow, bool bRefresh)
{
	m_LayoutGroup.privShowVisibleGroup(m_pGrp, bShow, bRefresh);
	if(GetParent())
		GetParent()->SendMessage(WM_VISIBLEGROUP_RESIZED, 0, (LPARAM)this);
}

/**********************************************************************/

CPropertyPageLayout::~CPropertyPageLayout()
{
	if(m_IsThisNT == false)
		::SetFocus(NULL); // Bug in Windows98????
	
	if(m_BkGBrush.GetSafeHandle())
		m_BkGBrush.DeleteObject();
	DestroyWindow();
}

/*********************************************************************/

void CPropertyPageLayout::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropertyPageLayout)
		// HINWEIS: Der Klassen-Assistent fgt hier DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}

/*********************************************************************/

BEGIN_MESSAGE_MAP(CPropertyPageLayout, CPropertyPage)
	//{{AFX_MSG_MAP(CPropertyPageLayout)
	ON_WM_SIZE()
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(WM_PROPPAGE_SIZED_SHEET, OnPageResize)
END_MESSAGE_MAP()

/*********************************************************************/

BOOL CPropertyPageLayout::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	m_LayoutGroup.LayoutInit();

	SetWindowPos(NULL, 0, 0, 10, 10, SWP_NOZORDER | SWP_NOMOVE);
	m_LayoutGroup.pTheWindow = this;
	m_LayoutGroup.lTheWindowIsA = IS_CPropertyPageLayout;
	ModifyStyle(0, WS_CLIPCHILDREN);
	
	return TRUE;
}

/*********************************************************************/

void CPropertyPageLayout::OnSize(UINT nType, int cx, int cy) 
{
	CPropertyPage::OnSize(nType, cx, cy);
	m_LayoutGroup.Size(&m_LayoutGroup.m_RootGroup);
}

/*********************************************************************/

CSize CPropertyPageLayout::GetMinSize()
{
	return m_LayoutGroup.privGetMinSize();
}

/**********************************************************************/

void CPropertyPageLayout::EndGroup()
{
	if(m_LayoutGroup.m_FIFO.GetCount() > 1)
		{
		CLayoutGroupObj *pGrp = m_LayoutGroup.m_FIFO.RemoveHead();
		if(pGrp->m_Childs.GetSize() == 0)
			{
			if((pGrp->dwFlags & IS_LF_GROUP) == 0)
				{
				AfxMessageBox(_T("Group is empty!"));
				}
			}
		}
	else
		{
		m_LayoutGroup.InitGroups(&m_LayoutGroup.m_RootGroup);

		m_LayoutGroup.SearchForGroupStatics(&m_LayoutGroup.m_RootGroup, NULL);

		m_LayoutGroup.SetPosGroups(&m_LayoutGroup.m_RootGroup,
			m_LayoutGroup.m_RootGroup.rcBorder.left,
			m_LayoutGroup.m_RootGroup.rcBorder.top);

		m_DlgSize.x = m_LayoutGroup.m_RootGroup.rcMinSize.Width()
			+ (GetSystemMetrics(SM_CYDLGFRAME) * 2)
			+ m_LayoutGroup.m_RootGroup.rcBorder.left
			+ m_LayoutGroup.m_RootGroup.rcBorder.right;

		m_DlgSize.y = m_LayoutGroup.m_RootGroup.rcMinSize.Height();


		if(GLL_GetWindowsVers() >= 60)
			m_DlgSize.y += GetSystemMetrics(SM_CYDLGFRAME);


		SetWindowPos(NULL, 0, 0, 10, 10, SWP_NOZORDER | SWP_NOMOVE);

		m_LayoutGroup.m_FIFO.RemoveAll();
		}
}

/*********************************************************************/

BOOL CPropertyPageLayout::OnSetActive() 
{
	bool m_bMove = false;

	if(m_Sheet)
		{
		if(m_bFirstSetActive)
			{
			if(m_Sheet->m_TabGroup)
				{
				CPoint m_Tab;
				int w, h, x = 0;

				CRect rcWnd(0, 0, 0, 0);

				m_Tab.x = m_Sheet->m_TabGroup->rcMinSize.right;
				m_Tab.y = m_Sheet->m_TabGroup->rcMinSize.bottom;

				x += m_Sheet->GetTapHeight();
				w = max(m_Tab.x, m_DlgSize.x);
				h = max(m_Tab.y, m_DlgSize.y);

				if(m_Tab.x < w)
					{
					m_Sheet->m_TabGroup->rcAktSize.right = m_Sheet->m_TabGroup->rcMinSize.right = w;
					m_bMove = true;
					}
				if(m_Tab.y - x < m_DlgSize.y)
					{
					m_Sheet->m_TabGroup->rcAktSize.bottom = m_Sheet->m_TabGroup->rcMinSize.bottom = m_DlgSize.y + x;
					m_bMove = true;
					}

				if(m_Sheet->IsBottomLabel() && (m_Sheet->IsWizard() == FALSE && !m_Sheet->IsNoTabCtrl()))
					if(m_LayoutGroup.m_RootGroup.rcBorder.bottom == 0)
						m_LayoutGroup.m_RootGroup.rcBorder.bottom = 1;

				if(m_bMove)
					{
					m_Sheet->SetSize(2056);

					m_Sheet->GetTabControl()->GetWindowRect(&rcWnd);
					AKScreenToClient(m_Sheet->GetSafeHwnd(), &rcWnd);
					m_Sheet->GetTabControl()->AdjustRect(false, &rcWnd);

					if(m_Sheet->IsWizard() || m_Sheet->IsNoTabCtrl())
						MoveWindow(m_Sheet->m_rcAktPage);
					else
						SetWindowPos(NULL, 0, 0, rcWnd.Width(), rcWnd.Height(), SWP_NOZORDER | SWP_NOMOVE);
					}
				else
					{
					if(m_Sheet->IsBottomLabel() && (m_Sheet->IsWizard() == FALSE && m_Sheet->IsNoTabCtrl() == false))
						{
						m_Sheet->GetTabControl()->GetWindowRect(&rcWnd);
						AKScreenToClient(m_Sheet->GetSafeHwnd(), &rcWnd);
						m_Sheet->GetTabControl()->AdjustRect(false, &rcWnd);
						SetWindowPos(NULL, 0, 0, rcWnd.Width(), rcWnd.Height() - 1, SWP_NOZORDER | SWP_NOMOVE);
						}
					}
				}
			else
				return true;
			}

		if(m_Sheet->IsWizard() || m_Sheet->IsNoTabCtrl())
			{
			MoveWindow(m_Sheet->m_rcAktPage);
			}
		}

	return CPropertyPage::OnSetActive();
}

/**********************************************************************/

LRESULT CPropertyPageLayout::OnPageResize(WPARAM /*wp*/, LPARAM /*lp*/) ///Page -> Sheet -> Page
{
	return TRUE; // Wichtig! Zeigt an, dass Message behandelt wird
}

/*********************************************************************/
#ifndef UNDER_CE
//Because the current version of Windows CE does not support wizards, MFC for Windows CE does not support the OnWizardBack, OnWizardNext, or OnWizardFinish methods of the CPropertyPage class.

LRESULT CPropertyPageLayout::OnWizardNext() 
{
	if(m_Sheet)
		{
		int iAkt = m_Sheet->GetPageIndex(this);
		if(iAkt == m_Sheet->GetPageCount() - 1)
			return -1;
		}

	return CPropertyPage::OnWizardNext();
}

/*********************************************************************/

LRESULT CPropertyPageLayout::OnWizardBack() 
{
	if(m_Sheet->GetPageIndex(this) == 0)
		return -1;
	return CPropertyPage::OnWizardBack();
}
#endif
/*********************************************************************/
/*********************************************************************/

CFormViewLayout::CFormViewLayout(UINT nID, LPCTSTR strName /*=NULL*/)
	: CFormView(nID)
{
	m_LayoutGroup.pTheWindow = this;
	//m_LayoutGroup.m_RootGroup.SetWindowType(IS_CFormViewLayout);

	//{{AFX_DATA_INIT(CFormViewLayout)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
	if(strName)
		m_strRegStore = strName;
	m_nMapMode = MM_TEXT;
	m_LayoutGroup.lTheWindowIsA = IS_CFormViewLayout;
}

/**********************************************************************/

CFormViewLayout::~CFormViewLayout()
{
	DestroyWindow();
}

/**********************************************************************/

void CFormViewLayout::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFormViewLayout)
		// HINWEIS: Der Klassen-Assistent fgt hier DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}

/**********************************************************************/

BEGIN_MESSAGE_MAP(CFormViewLayout, CFormView)
	//{{AFX_MSG_MAP(CFormViewLayout)
	ON_WM_SIZE()
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/**********************************************************************/

void CFormViewLayout::ResizeParentToFit(BOOL bShrinkOnly)
{
	if(GetParent()->IsKindOf(RUNTIME_CLASS(CFormViewBox)))
		{
		CWnd* pFrame;
		CRect rectFrame;
		pFrame = (CFrameWnd*) GetParent();
		ASSERT_VALID(pFrame);

		pFrame->GetWindowRect(rectFrame);
		CSize size = rectFrame.Size();
		size.cx++;
		size.cy++;

		pFrame->SetWindowPos(NULL, 0, 0,
			size.cx, size.cy,
			SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);
		}
	else
		CFormView::ResizeParentToFit(bShrinkOnly);
}

/**********************************************************************/

void CFormViewLayout::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	m_LayoutGroup.LayoutInit();
	ModifyStyle(0, WS_CLIPCHILDREN);
	ResizeParentToFit();
	m_LayoutGroup.lTheWindowIsA = IS_CFormViewLayout;
	m_LayoutGroup.pTheWindow = this;
}

/**********************************************************************/

void CFormViewLayout::EndGroup()
{
	if(m_LayoutGroup.m_FIFO.GetCount() > 1)
		{
		CLayoutGroupObj *pGrp = m_LayoutGroup.m_FIFO.RemoveHead();

		if(pGrp->m_Childs.GetSize() == 0)
			{
			if((pGrp->dwFlags & IS_LF_GROUP) == 0)
				{
				AfxMessageBox(_T("Group is empty!"));
				}
			}
		}
	else
		{
		GetClientRect(initRect);
		m_LayoutGroup.InitGroups(&m_LayoutGroup.m_RootGroup);
		m_LayoutGroup.SearchForGroupStatics(&m_LayoutGroup.m_RootGroup, NULL);

		m_LayoutGroup.SetPosGroups(&m_LayoutGroup.m_RootGroup,
			m_LayoutGroup.m_RootGroup.rcBorder.left,
			m_LayoutGroup.m_RootGroup.rcBorder.top);
		SetWindowPos(NULL, 0, 0, 10, 10, SWP_NOZORDER | SWP_NOMOVE);
#ifndef UNDER_CE
		// Unsupported MFC Class
		if(GetParentFrame()->IsKindOf(RUNTIME_CLASS(CMDIChildWnd)))
			{
			CRect rectFrame;
			GetParentFrame()->GetWindowRect(rectFrame);
			GetParentFrame()->SetWindowPos(NULL, 0, 0, rectFrame.Width(), rectFrame.Height() + 1,
				SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);
			}
#endif
		m_LayoutGroup.m_FIFO.RemoveAll();
		}
}

/**********************************************************************/

void CFormViewLayout::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);

	if(GetSafeHwnd())
		{
		CPoint m_ViewPosition = GetScrollPosition();
		m_LayoutGroup.m_ViewSize = GetTotalSize();

		m_LayoutGroup.CalcGroups(&m_LayoutGroup.m_RootGroup);
		m_LayoutGroup.SetPosGroups(&m_LayoutGroup.m_RootGroup,
			m_LayoutGroup.m_RootGroup.rcBorder.left - m_ViewPosition.x,
			m_LayoutGroup.m_RootGroup.rcBorder.top - m_ViewPosition.y);
		}
}

/**********************************************************************/

CSize CFormViewLayout::GetMinSize()
{
	return m_LayoutGroup.privGetMinSize();
}

/**********************************************************************/

#ifdef _DEBUG
void CFormViewLayout::AssertValid() const
{
	CFormView::AssertValid();
}

/**********************************************************************/

void CFormViewLayout::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif

/*********************************************************************/

CFormViewBox::CFormViewBox()
{
	m_pTheView = NULL;
	m_bSimpleRefresh = false;
}

/**********************************************************************/

CFormViewBox::~CFormViewBox()
{
}

/**********************************************************************/

BEGIN_MESSAGE_MAP(CFormViewBox, CStatic)
	//{{AFX_MSG_MAP(CFormViewBox)
	ON_WM_SIZE()
	ON_WM_ENABLE()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/**********************************************************************/

BOOL CFormViewBox::SetView(CRuntimeClass *pViewClass, CDocument* pDoc/*=NULL*/)
{	
	ASSERT_VALID(this);
	ASSERT(pViewClass != NULL);

	if(pViewClass == NULL)
		return false;

	ASSERT(pViewClass->IsDerivedFrom(RUNTIME_CLASS(CWnd)));
	ASSERT(AfxIsValidAddress(pViewClass, sizeof(CRuntimeClass), FALSE));

	CCreateContext context, *pContext = NULL;
	if(pContext == NULL)
		{
		context.m_pCurrentDoc = pDoc;
		context.m_pCurrentFrame = GetParentFrame();
		context.m_pLastView = NULL;
		context.m_pNewDocTemplate = NULL;
		context.m_pNewViewClass = pViewClass;
		pContext = &context;
		}

	CWnd* pWnd = NULL;
	TRY
		{
		pWnd = (CWnd*) pViewClass->CreateObject();
		if(pWnd == NULL)
			AfxThrowMemoryException();
		}
	CATCH_ALL(e)
		{
		TRACE0("Out of memory creating a view.\n");
		return FALSE;
		}
	END_CATCH_ALL

	ASSERT_KINDOF(CWnd, pWnd);
	ASSERT(pWnd->m_hWnd == NULL);       // not yet created

	DWORD dwStyle = AFX_WS_DEFAULT_VIEW;
	CRect rect(0, 0, 100, 100);

	if(pWnd->Create(NULL, NULL, dwStyle, rect, this, 0, pContext) == FALSE)
		{
		TRACE0("Warning: couldn't create client pane for view.\n");
		return FALSE;
		}

	m_pTheView = (CView*) pWnd;
	m_pTheView->SendMessage(WM_INITIALUPDATE, 0, 0);

	CRect rcChild;
	GetWindowRect(rcChild);
	AKScreenToClient(GetSafeHwnd(), rcChild);

	m_pTheView->MoveWindow(rcChild);
#ifdef UNDER_CE
	m_pTheView->RedrawWindow();
#else
	m_pTheView->RedrawWindow(0, 0, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ALLCHILDREN | RDW_FRAME);
#endif

		return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CFormViewBox 

void CFormViewBox::OnSize(UINT nType, int cx, int cy) 
{
	CStatic::OnSize(nType, cx, cy);

	CRect rcChild;
	GetWindowRect(rcChild);
	AKScreenToClient(GetSafeHwnd(), rcChild);

	if(m_pTheView)
		{
		m_pTheView->MoveWindow(rcChild, false);

		if(m_bSimpleRefresh)
			return;
#ifdef UNDER_CE
		m_pTheView->RedrawWindow();
#else
		m_pTheView->RedrawWindow(0, 0, RDW_NOERASE | RDW_INVALIDATE | RDW_UPDATENOW);
#endif

		CWnd* pWndChild = m_pTheView->GetWindow(GW_CHILD);

		while(pWndChild)
			{
#ifdef UNDER_CE
			pWndChild->RedrawWindow();
#else
			pWndChild->RedrawWindow(0, 0, RDW_NOERASE | RDW_INVALIDATE | RDW_UPDATENOW);
#endif
			pWndChild = pWndChild->GetNextWindow();
			}
		}
}

/**********************************************************************/

void CFormViewBox::OnEnable(BOOL bEnable) 
{
	CStatic::OnEnable(bEnable);
	if(m_pTheView)
		{
#ifdef UNDER_CE
		m_pTheView->RedrawWindow();
#else
		m_pTheView->RedrawWindow(0, 0, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ALLCHILDREN | RDW_FRAME);
#endif
		CWnd* pWndChild = m_pTheView->GetWindow(GW_CHILD);
		while(pWndChild)
			{
			pWndChild->EnableWindow(bEnable);
			pWndChild = pWndChild->GetNextWindow();
			}
		}
	else
#ifdef UNDER_CE
		RedrawWindow();
#else
		RedrawWindow(0, 0, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ALLCHILDREN | RDW_FRAME);
#endif
}

/**********************************************************************/

BOOL CFormViewBox::OnEraseBkgnd(CDC* pDC) 
{
	UNUSED_ALWAYS(pDC);
	return false;// CStatic::OnEraseBkgnd(pDC);
}

/**********************************************************************/

void CFormViewBox::OnPaint() 
{
	CPaintDC dc(this);

	if(m_pTheView == NULL)
		{
		CRect winRect;
		GetWindowRect(winRect);
		AKScreenToClient(GetSafeHwnd(), winRect);
		dc.DrawFrameControl(&winRect, DFC_BUTTON, DFCS_BUTTONPUSH | DFCS_PUSHED);
		}
}

/*********************************************************************/

HBRUSH CPropertyPageLayout::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr;
	
	if(pWnd == this)
		hbr = (HBRUSH)m_BkGBrush; // Vorlufiger Fix fr XP-Luna
	else
		hbr = CPropertyPage::OnCtlColor(pDC, pWnd, nCtlColor);

	return hbr;
}

/*********************************************************************/
typedef BOOL (WINAPI* lpfnIsThemeActive)();

// Sicherer Aufruf von IsThemeActive()

int AKIsThemeActive()
{
	int retval = false;
	HMODULE  hThemeDll = NULL;
	lpfnIsThemeActive pFnIsThemeActive = NULL;

	hThemeDll = ::LoadLibrary(_T("UxTheme.dll"));
	if(hThemeDll)
		pFnIsThemeActive = (lpfnIsThemeActive) GetProcAddress(hThemeDll, ("IsThemeActive"));
	if(pFnIsThemeActive)
		{
		retval = pFnIsThemeActive() ? 1 : 0;
		if(GLL_GetWindowsVers() >= 60)
			retval = 2;
		}
	if(hThemeDll)
		::FreeLibrary(hThemeDll);

	return retval;
}


/*********************************************************************/

HBRUSH CFormViewLayout::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr;
	
	if(pWnd == this)
		hbr = ::GetSysColorBrush(COLOR_BTNFACE); // Vorlufiger Fix fr XP-Luna
	else
		hbr = CFormView::OnCtlColor(pDC, pWnd, nCtlColor);

	return hbr;
}

/*********************************************************************/

void CFormViewLayout::ShowVisibleGroup(CLayoutGroupObj *m_pGrp, bool bShow, bool bRefresh)
{
	m_LayoutGroup.privShowVisibleGroup(m_pGrp, bShow, bRefresh);
	if(GetParent())
		GetParent()->SendMessage(WM_VISIBLEGROUP_RESIZED, 0, (LPARAM)this);
}

/**********************************************************************/

void CDialogLayout::SetBkgColor(COLORREF crColor)
{
	m_LayoutGroup.SetBkgColor(crColor);
}

/**********************************************************************/

void CDialogLayout::SetGroupBoxColor(COLORREF crColor)
{
	m_LayoutGroup.m_crGroupBoxBorderColor = crColor;
}

/**********************************************************************/

void CFormViewLayout::SetBkgColor(COLORREF crColor)
{
	m_LayoutGroup.m_crBackGrdColor = crColor;
	if(m_BkGBrush.GetSafeHandle())
		m_BkGBrush.DeleteObject();
	VERIFY(m_BkGBrush.CreateSolidBrush(m_LayoutGroup.GetDlgBKColor()));
}

/**********************************************************************/

void CFormViewLayout::SetGroupBoxColor(COLORREF crColor)
{
	m_LayoutGroup.m_crGroupBoxBorderColor = crColor;
}

/**********************************************************************/

void CPropertySheetLayout::SetBkgColor(COLORREF crColor)
{
	m_LayoutGroup.m_crBackGrdColor = crColor;
	if(m_BkGBrush.GetSafeHandle())
		m_BkGBrush.DeleteObject();
	VERIFY(m_BkGBrush.CreateSolidBrush(m_LayoutGroup.GetDlgBKColor()));
}

/**********************************************************************/

void CPropertyPageLayout::SetBkgColor(COLORREF crColor)
{
	m_LayoutGroup.m_crBackGrdColor = crColor;
	if(m_BkGBrush.GetSafeHandle())
		m_BkGBrush.DeleteObject();
	VERIFY(m_BkGBrush.CreateSolidBrush(m_LayoutGroup.GetDlgBKColor()));
}

/**********************************************************************/

void CPropertyPageLayout::SetGroupBoxColor(COLORREF crColor)
{
	m_LayoutGroup.m_crGroupBoxBorderColor = crColor;
}

/**********************************************************************/

void CDialogLayout::DisableGLLEraseBackground(bool m_NoErase)
{
	m_LayoutGroup.m_NoGLLEraseBackGround=m_NoErase;
}

/**********************************************************************/

void CPropertySheetLayout::DisableGLLEraseBackground(bool m_NoErase)
{
	m_LayoutGroup.m_NoGLLEraseBackGround = m_NoErase;
}

/**********************************************************************/

void CPropertyPageLayout::DisableGLLEraseBackground(bool m_NoErase)
{
	m_LayoutGroup.m_NoGLLEraseBackGround = m_NoErase;
}

/**********************************************************************/

void CFormViewLayout::DisableGLLEraseBackground(bool m_NoErase)
{
	m_LayoutGroup.m_NoGLLEraseBackGround = m_NoErase;
}

/**********************************************************************/
